(function() {
    'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({
                    __proto__: []
                }
                instanceof Array && function(d, b) {
                    d.__proto__ = b;
                }) ||
            function(d, b) {
                for (var p in b)
                    if (b.hasOwnProperty(p)) d[p] = b[p];
            };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);

        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++)
                if (e.indexOf(p[i]) < 0)
                    t[p[i]] = s[p[i]];
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length,
            r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
            d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function(target, key) {
            decorator(target, key, paramIndex);
        }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new(P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
                try {
                    step(generator.next(value));
                } catch (e) {
                    reject(e);
                }
            }

            function rejected(value) {
                try {
                    step(generator["throw"](value));
                } catch (e) {
                    reject(e);
                }
            }

            function step(result) {
                result.done ? resolve(result.value) : new P(function(resolve) {
                    resolve(result.value);
                }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = {
                label: 0,
                sent: function() {
                    if (t[0] & 1) throw t[1];
                    return t[1];
                },
                trys: [],
                ops: []
            },
            f, y, t, g;
        return g = {
            next: verb(0),
            "throw": verb(1),
            "return": verb(2)
        }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
            return this;
        }), g;

        function verb(n) {
            return function(v) {
                return step([n, v]);
            };
        }

        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0:
                    case 1:
                        t = op;
                        break;
                    case 4:
                        _.label++;
                        return {
                            value: op[1],
                            done: false
                        };
                    case 5:
                        _.label++;
                        y = op[1];
                        op = [0];
                        continue;
                    case 7:
                        op = _.ops.pop();
                        _.trys.pop();
                        continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                            _ = 0;
                            continue;
                        }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                            _.label = op[1];
                            break;
                        }
                        if (op[0] === 6 && _.label < t[1]) {
                            _.label = t[1];
                            t = op;
                            break;
                        }
                        if (t && _.label < t[2]) {
                            _.label = t[2];
                            _.ops.push(op);
                            break;
                        }
                        if (t[2]) _.ops.pop();
                        _.trys.pop();
                        continue;
                }
                op = body.call(thisArg, _);
            } catch (e) {
                op = [6, e];
                y = 0;
            } finally {
                f = t = 0;
            }
            if (op[0] & 5) throw op[1];
            return {
                value: op[0] ? op[1] : void 0,
                done: true
            };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m)
            if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator],
            i = 0;
        if (m) return m.call(o);
        return {
            next: function() {
                if (o && i >= o.length) o = void 0;
                return {
                    value: o && o[i++],
                    done: !o
                };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o),
            r, ar = [],
            e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        } catch (error) {
            e = {
                error: error
            };
        } finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            } finally {
                if (e) throw e.error;
            }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []),
            i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
            return this;
        }, i;

        function verb(n) {
            if (g[n]) i[n] = function(v) {
                return new Promise(function(a, b) {
                    q.push([n, v, a, b]) > 1 || resume(n, v);
                });
            };
        }

        function resume(n, v) {
            try {
                step(g[n](v));
            } catch (e) {
                settle(q[0][3], e);
            }
        }

        function step(r) {
            r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
        }

        function fulfill(value) {
            resume("next", value);
        }

        function reject(value) {
            resume("throw", value);
        }

        function settle(f, v) {
            if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]);
        }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function(e) {
            throw e;
        }), verb("return"), i[Symbol.iterator] = function() {
            return this;
        }, i;

        function verb(n, f) {
            i[n] = o[n] ? function(v) {
                return (p = !p) ? {
                    value: __await(o[n](v)),
                    done: n === "return"
                } : f ? f(v) : v;
            } : f;
        }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator],
            i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
            return this;
        }, i);

        function verb(n) {
            i[n] = o[n] && function(v) {
                return new Promise(function(resolve, reject) {
                    v = o[n](v), settle(resolve, reject, v.done, v.value);
                });
            };
        }

        function settle(resolve, reject, d, v) {
            Promise.resolve(v).then(function(v) {
                resolve({
                    value: v,
                    done: d
                });
            }, reject);
        }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", {
                value: raw
            });
        } else {
            cooked.raw = raw;
        }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : {
            default: mod
        };
    }

    class GEvent extends Laya.EventDispatcher {
        static get Ins() {
            if (!this.mInstance)
                this.mInstance = new GEvent();
            return this.mInstance;
        }
    }
    GEvent.kShowReceiveItemTips = 'ShowReceiveItemTips';
    GEvent.KGuideEvent = 'KGuide';
    GEvent.kStartCombat = 'StartCombat';
    GEvent.kWatchAds = "WatchAds";
    GEvent.Audv = 'Audiovolume';
    GEvent.reTop = "reTop";
    const GCamEvent = {
        kFollow: 'CamFollow',
        kOffset: 'CamOffset',
        kRotate: 'CamRotate',
        kObserveTarget: "CamObserveTarget",
        kHover: 'CamHover',
        kCamEnd: "CamEnd",
        kMove: 'CamMove',
        kFail: 'CamFail',
        kOver: 'CamOver',
        kChangeViewValue: 'ChangeViewValue',
        kRedPlayerDie: "RedPlayerDie",
    };

    class WeaponCfg {}
    var EWeaponColor;
    (function(EWeaponColor) {
        EWeaponColor[EWeaponColor["Green"] = 0] = "Green";
        EWeaponColor[EWeaponColor["Purple"] = 1] = "Purple";
        EWeaponColor[EWeaponColor["Yellow"] = 2] = "Yellow";
    })(EWeaponColor || (EWeaponColor = {}));
    class WeaponGradeCfg {}
    class WeaponConfig {
        static GetWeaponCfg(id) {
            for (let index = 0; index < this.WeaponTable.length; index++) {
                if (this.WeaponTable[index].Id == id) {
                    return this.WeaponTable[index];
                }
            }
            console.error(`${this.name}WeaponTable未找到Id:${id}的配置`);
            return null;
        }
    }
    WeaponConfig.WeaponGradeTable = [{
        Type: EWeaponColor.Green,
        WeaponIdList: [1001, 1002, 1003, 1004, 1005, 1006],
        Price: 2500,
        VideoPrice: 1500,
        ColorImg: ""
    }, ];
    WeaponConfig.WeaponTable = [{
            Id: 1001,
            Gold: 5000,
            Type: 1,
            Num: 2,
            Name: "1",
            Model: "Gunp1",
            hModel: "Gunh1",
            AtkDistanceTime: 200 / 2,
            AtkRange: 1,
            Offset: 0.4
        },
        {
            Id: 1002,
            Gold: 5000,
            Type: 1,
            Num: 2,
            Name: "1",
            Model: "Gunp2",
            hModel: "Gunh2",
            AtkDistanceTime: 180 / 2,
            AtkRange: 1,
            Offset: 1
        },
        {
            Id: 1003,
            Gold: 5000,
            Type: 1,
            Num: 2,
            Name: "1",
            Model: "Gunp3",
            hModel: "Gunh3",
            AtkDistanceTime: 160 / 2,
            AtkRange: 1,
            Offset: 1.5
        },
        {
            Id: 1004,
            Gold: 8000,
            Type: 1,
            Num: 2,
            Name: "1",
            Model: "Gunp4",
            hModel: "Gunh4",
            AtkDistanceTime: 140 / 2,
            AtkRange: 1,
            Offset: 0.8
        },
        {
            Id: 1005,
            Gold: 8000,
            Type: 1,
            Num: 3,
            Name: "1",
            Model: "Gunp5",
            hModel: "Gunh5",
            AtkDistanceTime: 120 / 2,
            AtkRange: 1,
            Offset: 1.5
        },
        {
            Id: 1006,
            Gold: 8000,
            Type: 1,
            Num: 3,
            Name: "1",
            Model: "Gunp6",
            hModel: "Gunh6",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 1
        },
        {
            Id: 2001,
            Gold: 10000,
            Type: 1,
            Num: 3,
            Name: "1",
            Model: "Gunp7",
            hModel: "Gunh7",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 1
        },
        {
            Id: 2002,
            Gold: 10000,
            Type: 1,
            Num: 3,
            Name: "1",
            Model: "Gunp8",
            hModel: "Gunh8",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.4
        },
        {
            Id: 2003,
            Gold: 10000,
            Type: 1,
            Num: 3,
            Name: "1",
            Model: "Gunp9",
            hModel: "Gunh9",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.4
        },
        {
            Id: 2004,
            Gold: 12000,
            Type: 2,
            Num: 3,
            Name: "1",
            Model: "Gunp10",
            hModel: "Gunh10",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.8
        },
        {
            Id: 2005,
            Gold: 12000,
            Type: 2,
            Num: 3,
            Name: "1",
            Model: "Gunp11",
            hModel: "Gunh11",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.4
        },
        {
            Id: 2006,
            Gold: 12000,
            Type: 1,
            Num: 4,
            Name: "1",
            Model: "Gunp12",
            hModel: "Gunh12",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.4
        },
        {
            Id: 3001,
            Gold: 15000,
            Type: 1,
            Num: 4,
            Name: "1",
            Model: "Gunp13",
            hModel: "Gunh13",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 1.1
        },
        {
            Id: 3002,
            Gold: 15000,
            Type: 1,
            Num: 4,
            Name: "1",
            Model: "Gunp14",
            hModel: "Gunh14",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 1.1
        },
        {
            Id: 3003,
            Gold: 15000,
            Type: 1,
            Num: 4,
            Name: "1",
            Model: "Gunp15",
            hModel: "Gunh15",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.8
        },
        {
            Id: 3004,
            Gold: 20000,
            Type: 1,
            Num: 6,
            Name: "1",
            Model: "Gunp16",
            hModel: "Gunh16",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 1
        },
        {
            Id: 3005,
            Gold: 20000,
            Type: 1,
            Num: 6,
            Name: "1",
            Model: "Gunp17",
            hModel: "Gunh17",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.8
        },
        {
            Id: 3006,
            Gold: 20000,
            Type: 1,
            Num: 10,
            Name: "1",
            Model: "Gunp18",
            hModel: "Gunh18",
            AtkDistanceTime: 100 / 2,
            AtkRange: 1,
            Offset: 0.8
        },
    ];

    var SDKType;
    (function(SDKType) {
        SDKType[SDKType["Dummy"] = 0] = "Dummy";
        SDKType[SDKType["OPPO"] = 1] = "OPPO";
        SDKType[SDKType["TT"] = 2] = "TT";
        SDKType[SDKType["WX"] = 3] = "WX";
        SDKType[SDKType["Game4399"] = 4] = "Game4399";
    })(SDKType || (SDKType = {}));
    class BSet {}
    BSet.PfSDK = SDKType.Game4399;
    BSet.kName = "ThrBlockade";
    BSet.V = 8;

    var View = Laya.View;
    var REG = Laya.ClassUtils.regClass;
    var ui;
    (function(ui) {
        class AimpointUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(AimpointUI.uiView);
            }
        }
        AimpointUI.uiView = {
            "type": "View",
            "props": {
                "y": 0,
                "x": 0,
                "width": 88,
                "skewY": 0,
                "pivotY": 44,
                "pivotX": 44,
                "height": 88,
                "alpha": 1
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "width": 88,
                    "skin": "subpkg/UI/Playing/mianzhunjing.png",
                    "scaleY": 0.8,
                    "scaleX": 0.8,
                    "height": 88,
                    "centerY": 0,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5,
                    "alpha": 1
                },
                "compId": 86
            }, {
                "type": "Image",
                "props": {
                    "width": 88,
                    "visible": false,
                    "var": "img",
                    "skin": "subpkg/UI/Playing/jizhongtishi.png",
                    "scaleY": 0.8,
                    "scaleX": 0.8,
                    "height": 88,
                    "centerY": 0,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5,
                    "alpha": 0
                },
                "compId": 87
            }],
            "animations": [{
                "nodes": [{
                    "target": 87,
                    "keyframes": {
                        "visible": [{
                            "value": true,
                            "tweenMethod": "linearNone",
                            "tween": false,
                            "target": 87,
                            "key": "visible",
                            "index": 0
                        }, {
                            "value": false,
                            "tweenMethod": "linearNone",
                            "tween": false,
                            "target": 87,
                            "key": "visible",
                            "index": 2
                        }, {
                            "value": true,
                            "tweenMethod": "linearNone",
                            "tween": false,
                            "target": 87,
                            "key": "visible",
                            "index": 4
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }],
            "loadList": ["subpkg/UI/Playing/mianzhunjing.png", "subpkg/UI/Playing/jizhongtishi.png"],
            "loadList3D": []
        };
        ui.AimpointUI = AimpointUI;
        REG("ui.AimpointUI", AimpointUI);
        class BoxAwardUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(BoxAwardUI.uiView);
            }
        }
        BoxAwardUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "y": -10,
                    "x": -10,
                    "top": -10,
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "bgColor": "#242d38",
                    "alpha": 0.7
                },
                "compId": 114
            }, {
                "type": "List",
                "props": {
                    "var": "List",
                    "spaceY": 30,
                    "spaceX": 30,
                    "repeatY": 3,
                    "repeatX": 3,
                    "elasticEnabled": true,
                    "centerY": -187,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 90,
                "child": [{
                    "type": "Box",
                    "props": {
                        "width": 142,
                        "renderType": "render",
                        "height": 142
                    },
                    "compId": 101,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/UI/TreasureBox/10.png",
                            "name": "bj",
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 102
                    }, {
                        "type": "Image",
                        "props": {
                            "visible": false,
                            "skin": "subpkg/UI/TreasureBox/9.png",
                            "sizeGrid": "0,0,0,0",
                            "name": "box",
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 105
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "visible": false,
                            "skin": "subpkg/UI/TreasureBox/5.png",
                            "sizeGrid": "0,0,0,0",
                            "name": "gold",
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 106
                    }, {
                        "type": "Label",
                        "props": {
                            "visible": false,
                            "text": "1000",
                            "name": "num",
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "centerX": 0,
                            "bottom": 10,
                            "bold": true
                        },
                        "compId": 107
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "visible": false,
                            "skin": "subpkg/UI/TreasureBox/8.png",
                            "sizeGrid": "0,0,0,0",
                            "name": "vbj",
                            "centerY": 0,
                            "centerX": 0,
                            "alpha": 0.6
                        },
                        "compId": 109
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 51,
                            "x": 43,
                            "visible": false,
                            "skin": "subpkg/UI/TreasureBox/7.png",
                            "sizeGrid": "0,0,0,0",
                            "name": "video",
                            "centerY": 0,
                            "centerX": 0,
                            "alpha": 0.6
                        },
                        "compId": 110
                    }]
                }]
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/TreasureBox/4.png",
                    "centerY": -507,
                    "centerX": 0
                },
                "compId": 112
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/TreasureBox/1.png",
                    "centerY": 119,
                    "centerX": 0
                },
                "compId": 95
            }, {
                "type": "Image",
                "props": {
                    "var": "video",
                    "skin": "subpkg/UI/TreasureBox/3.png",
                    "centerY": 239,
                    "centerX": -160,
                    "bottom": 379
                },
                "compId": 96
            }, {
                "type": "Image",
                "props": {
                    "var": "Back",
                    "skin": "subpkg/UI/TreasureBox/2.png",
                    "centerY": 239,
                    "centerX": 160,
                    "bottom": 379
                },
                "compId": 97
            }],
            "loadList": ["subpkg/UI/TreasureBox/10.png", "subpkg/UI/TreasureBox/9.png", "subpkg/UI/TreasureBox/5.png", "subpkg/UI/TreasureBox/8.png", "subpkg/UI/TreasureBox/7.png", "subpkg/UI/TreasureBox/4.png", "subpkg/UI/TreasureBox/1.png", "subpkg/UI/TreasureBox/3.png", "subpkg/UI/TreasureBox/2.png"],
            "loadList3D": []
        };
        ui.BoxAwardUI = BoxAwardUI;
        REG("ui.BoxAwardUI", BoxAwardUI);
        class DieTipUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(DieTipUI.uiView);
            }
        }
        DieTipUI.uiView = {
            "type": "View",
            "props": {
                "y": 40,
                "x": 24,
                "width": 48,
                "scaleY": 1.6,
                "scaleX": 1.6,
                "pivotY": 40,
                "pivotX": 24,
                "height": 40
            },
            "compId": 1,
            "child": [{
                "type": "Sprite",
                "props": {
                    "y": 0,
                    "x": 14,
                    "texture": "subpkg/UI/Playing/fenshu.png"
                },
                "compId": 90
            }],
            "animations": [{
                "nodes": [{
                    "target": 90,
                    "keyframes": {
                        "y": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "y",
                            "index": 0
                        }, {
                            "value": -10,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "y",
                            "index": 30
                        }],
                        "x": [{
                            "value": 14,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "x",
                            "index": 0
                        }, {
                            "value": 24,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "x",
                            "index": 30
                        }],
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "scaleY",
                            "index": 30
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 90,
                            "key": "scaleX",
                            "index": 30
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 1
            }],
            "loadList": ["subpkg/UI/Playing/fenshu.png"],
            "loadList3D": []
        };
        ui.DieTipUI = DieTipUI;
        REG("ui.DieTipUI", DieTipUI);
        class DoubleUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(DoubleUI.uiView);
            }
        }
        DoubleUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Label",
                "props": {
                    "top": 464,
                    "text": "X",
                    "fontSize": 80,
                    "font": "Microsoft YaHei",
                    "color": "#7ffe05",
                    "centerX": -81,
                    "bold": true,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 78,
                "child": [{
                    "type": "Label",
                    "props": {
                        "var": "num",
                        "text": "0.4",
                        "left": 70,
                        "fontSize": 130,
                        "font": "Microsoft YaHei",
                        "color": "#7ffe05",
                        "bottom": -10,
                        "bold": true
                    },
                    "compId": 77
                }, {
                    "type": "Image",
                    "props": {
                        "width": 213,
                        "skin": "subpkg/UI/Hp/1.png",
                        "pivotY": 44,
                        "pivotX": 107,
                        "height": 88,
                        "centerY": -180,
                        "centerX": 100
                    },
                    "compId": 80
                }]
            }],
            "animations": [{
                "nodes": [{
                    "target": 78,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 78,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 78,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 78,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 78,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 78,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 78,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }],
            "loadList": ["subpkg/UI/Hp/1.png"],
            "loadList3D": []
        };
        ui.DoubleUI = DoubleUI;
        REG("ui.DoubleUI", DoubleUI);
        class EmojiUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(EmojiUI.uiView);
            }
        }
        EmojiUI.uiView = {
            "type": "View",
            "props": {
                "y": 0,
                "x": 0,
                "width": 88,
                "height": 88
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "y": 0,
                    "x": 0,
                    "width": 95,
                    "var": "img",
                    "skin": "subpkg/UI/27.png",
                    "height": 86,
                    "anchorY": 1,
                    "anchorX": 0.5
                },
                "compId": 86
            }],
            "animations": [{
                "nodes": [{
                    "target": 86,
                    "keyframes": {
                        "y": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "y",
                            "index": 0
                        }, {
                            "value": -90,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "y",
                            "index": 20
                        }, {
                            "value": -180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "y",
                            "index": 40
                        }],
                        "x": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "x",
                            "index": 0
                        }, {
                            "value": -15,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "x",
                            "index": 20
                        }, {
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "x",
                            "index": 40
                        }],
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleY",
                            "index": 20
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleY",
                            "index": 40
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleX",
                            "index": 20
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleX",
                            "index": 40
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 86,
                    "keyframes": {
                        "y": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "y",
                            "index": 0
                        }, {
                            "value": -90,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "y",
                            "index": 20
                        }, {
                            "value": -180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "y",
                            "index": 40
                        }],
                        "x": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "x",
                            "index": 0
                        }, {
                            "value": 15,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "x",
                            "index": 20
                        }, {
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "x",
                            "index": 40
                        }],
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleY",
                            "index": 20
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleY",
                            "index": 40
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleX",
                            "index": 20
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 86,
                            "key": "scaleX",
                            "index": 40
                        }]
                    }
                }],
                "name": "ani2",
                "id": 2,
                "frameRate": 60,
                "action": 0
            }],
            "loadList": ["subpkg/UI/27.png"],
            "loadList3D": []
        };
        ui.EmojiUI = EmojiUI;
        REG("ui.EmojiUI", EmojiUI);
        class ErrModalUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(ErrModalUI.uiView);
            }
        }
        ErrModalUI.uiView = {
            "type": "View",
            "props": {
                "width": 1334,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 750,
                "bottom": 0
            },
            "compId": 2,
            "child": [{
                "type": "Box",
                "props": {
                    "y": 10,
                    "x": 10,
                    "top": -10,
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "bgColor": "#242d38"
                },
                "compId": 61
            }, {
                "type": "Box",
                "props": {
                    "width": 560,
                    "height": 350,
                    "centerY": 0,
                    "centerX": 0,
                    "bgColor": "#373631"
                },
                "compId": 46,
                "child": [{
                    "type": "Label",
                    "props": {
                        "var": "title",
                        "valign": "middle",
                        "top": 20,
                        "text": "资源下载失败！",
                        "fontSize": 30,
                        "font": "Microsoft YaHei",
                        "color": "#ff871b",
                        "centerX": 0,
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 47
                }, {
                    "type": "Box",
                    "props": {
                        "top": 70,
                        "right": 0,
                        "left": 0,
                        "bottom": 0,
                        "bgColor": "#ffffff"
                    },
                    "compId": 58
                }, {
                    "type": "Label",
                    "props": {
                        "var": "content",
                        "text": "请退出重启！",
                        "leading": 5,
                        "fontSize": 30,
                        "font": "Microsoft YaHei",
                        "color": "#676767",
                        "centerY": -60,
                        "centerX": 0,
                        "bold": true
                    },
                    "compId": 49
                }, {
                    "type": "Label",
                    "props": {
                        "text": "若重启无效，请尝试右上角菜单重启！",
                        "strokeColor": "#000000",
                        "stroke": 3,
                        "leading": 5,
                        "fontSize": 25,
                        "font": "Microsoft YaHei",
                        "color": "#ff871b",
                        "centerY": 40,
                        "centerX": 0,
                        "bold": true
                    },
                    "compId": 51
                }, {
                    "type": "Box",
                    "props": {
                        "x": 0,
                        "width": 160,
                        "var": "Clo",
                        "height": 50,
                        "centerX": 0,
                        "bottom": 35,
                        "bgColor": "#000000"
                    },
                    "compId": 62,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "top": 3,
                            "right": 3,
                            "left": 3,
                            "bottom": 3,
                            "bgColor": "#ffe012"
                        },
                        "compId": 63
                    }, {
                        "type": "Label",
                        "props": {
                            "x": 0,
                            "text": "Sure",
                            "leading": 5,
                            "fontSize": 30,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerY": 3,
                            "centerX": 0,
                            "bold": true
                        },
                        "compId": 64
                    }]
                }]
            }],
            "loadList": [],
            "loadList3D": []
        };
        ui.ErrModalUI = ErrModalUI;
        REG("ui.ErrModalUI", ErrModalUI);
        class FailUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(FailUI.uiView);
            }
        }
        FailUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "y": -10,
                    "x": -10,
                    "top": -10,
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "bgColor": "#242d38",
                    "alpha": 0.7
                },
                "compId": 110
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/Fail/3.png",
                    "centerY": -190,
                    "centerX": 0
                },
                "compId": 71,
                "child": [{
                    "type": "Sprite",
                    "props": {
                        "y": -20,
                        "x": 73,
                        "texture": "subpkg/UI/Fail/1.png"
                    },
                    "compId": 107
                }, {
                    "type": "Sprite",
                    "props": {
                        "y": 184,
                        "x": -31,
                        "texture": "subpkg/UI/Fail/2.png"
                    },
                    "compId": 108,
                    "child": [{
                        "type": "Sprite",
                        "props": {
                            "y": 32,
                            "x": 118,
                            "texture": "subpkg/UI/Fail/4.png"
                        },
                        "compId": 109
                    }]
                }]
            }, {
                "type": "Image",
                "props": {
                    "var": "skip",
                    "skin": "subpkg/UI/Fail/tiaoguo2.png",
                    "centerY": 161,
                    "centerX": -150,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 74,
                "child": [{
                    "type": "Label",
                    "props": {
                        "text": "跳 过",
                        "strokeColor": "#000000",
                        "stroke": 4,
                        "fontSize": 45,
                        "font": "Microsoft YaHei",
                        "color": "#ffffff",
                        "centerY": 3,
                        "centerX": 0,
                        "bold": true,
                        "anchorY": 0.5,
                        "anchorX": 0.5,
                        "alpha": 0
                    },
                    "compId": 85
                }]
            }, {
                "type": "Image",
                "props": {
                    "var": "again",
                    "skin": "subpkg/UI/Fail/5.png",
                    "centerY": 161,
                    "centerX": 150,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 82
            }],
            "animations": [{
                "nodes": [{
                    "target": 82,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 82,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 82,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 82,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 82,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 82,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 82,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }, {
                    "target": 74,
                    "keyframes": {
                        "var": [{
                            "value": "skip",
                            "tweenMethod": "linearNone",
                            "tween": false,
                            "target": 74,
                            "key": "var",
                            "index": 0
                        }]
                    }
                }],
                "name": "aniagain",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 74,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 74,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 74,
                            "key": "scaleY",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 74,
                            "key": "scaleY",
                            "index": 60
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 74,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 74,
                            "key": "scaleX",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 74,
                            "key": "scaleX",
                            "index": 60
                        }]
                    }
                }],
                "name": "aniskip",
                "id": 2,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/UI/Fail/3.png", "subpkg/UI/Fail/1.png", "subpkg/UI/Fail/2.png", "subpkg/UI/Fail/4.png", "subpkg/UI/Fail/tiaoguo2.png", "subpkg/UI/Fail/5.png"],
            "loadList3D": []
        };
        ui.FailUI = FailUI;
        REG("ui.FailUI", FailUI);
        class GetGunUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(GetGunUI.uiView);
            }
        }
        GetGunUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "y": 667,
                    "x": 375,
                    "top": -10,
                    "skin": "subpkg/more/Board.png",
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 112
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/GoldSkin/3.png",
                    "centerY": -350,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 99
            }, {
                "type": "Image",
                "props": {
                    "width": 750,
                    "skin": "subpkg/UI/GoldSkin/1.png",
                    "centerY": -75,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 100
            }, {
                "type": "Image",
                "props": {
                    "width": 185,
                    "var": "gun",
                    "skin": "subpkg/gun/1006_2.png",
                    "scaleY": 3,
                    "scaleX": 3,
                    "rotation": 20,
                    "height": 62,
                    "centerY": -75,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 111
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/GoldSkin/2.png",
                    "centerY": 100,
                    "centerX": 0
                },
                "compId": 113
            }, {
                "type": "Image",
                "props": {
                    "var": "Back",
                    "skin": "subpkg/UI/loading/6.png",
                    "centerY": 285,
                    "centerX": 0
                },
                "compId": 101,
                "child": [{
                    "type": "Image",
                    "props": {
                        "y": 0,
                        "x": 0,
                        "skin": "subpkg/share/17.png",
                        "centerY": 0,
                        "centerX": 0,
                        "alpha": 0
                    },
                    "compId": 108
                }]
            }],
            "animations": [{
                "nodes": [{
                    "target": 100,
                    "keyframes": {
                        "rotation": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 0
                        }, {
                            "value": 45,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 10
                        }, {
                            "value": 90,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 20
                        }, {
                            "value": 135,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 30
                        }, {
                            "value": 180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 40
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/more/Board.png", "subpkg/UI/GoldSkin/3.png", "subpkg/UI/GoldSkin/1.png", "subpkg/gun/1006_2.png", "subpkg/UI/GoldSkin/2.png", "subpkg/UI/loading/6.png", "subpkg/share/17.png"],
            "loadList3D": []
        };
        ui.GetGunUI = GetGunUI;
        REG("ui.GetGunUI", GetGunUI);
        class GetGunShareUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(GetGunShareUI.uiView);
            }
        }
        GetGunShareUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "width": 760,
                    "skin": "subpkg/more/Board.png",
                    "height": 1344,
                    "centerY": 0,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 108
            }, {
                "type": "Image",
                "props": {
                    "width": 81,
                    "var": "shadow1",
                    "skin": "subpkg/UI/Share/4.png",
                    "pivotY": 41,
                    "pivotX": 41,
                    "height": 81,
                    "centerY": 225,
                    "centerX": -200
                },
                "compId": 118,
                "child": [{
                    "type": "Image",
                    "props": {
                        "y": 40,
                        "x": 141,
                        "width": 130,
                        "var": "article1",
                        "skin": "subpkg/UI/Share/5.png",
                        "pivotY": 12,
                        "pivotX": 66,
                        "height": 23
                    },
                    "compId": 119
                }, {
                    "type": "Image",
                    "props": {
                        "y": 31,
                        "x": 43,
                        "width": 40,
                        "var": "money1",
                        "skin": "subpkg/UI/Share/1.png",
                        "pivotY": 19,
                        "pivotX": 20,
                        "height": 37
                    },
                    "compId": 127,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "y": 50,
                            "x": 20,
                            "width": 50,
                            "text": "x100",
                            "strokeColor": "#d76b18",
                            "pivotY": 10,
                            "pivotX": 25,
                            "height": 20,
                            "fontSize": 20,
                            "color": "#ffffff",
                            "bold": true
                        },
                        "compId": 130
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "y": 40.5,
                        "x": 41,
                        "width": 100,
                        "var": "get1",
                        "skin": "subpkg/UI/Share/3.png",
                        "pivotY": 50,
                        "pivotX": 50,
                        "height": 100
                    },
                    "compId": 123,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 40,
                            "x": 52,
                            "width": 63,
                            "var": "HaveMoney1",
                            "skin": "subpkg/UI/Share/2.png",
                            "pivotY": 29,
                            "pivotX": 32,
                            "height": 58
                        },
                        "compId": 132,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": 66,
                                "x": 31.5,
                                "width": 55,
                                "text": "x100",
                                "strokeColor": "#d76b18",
                                "stroke": 4,
                                "pivotY": 13,
                                "pivotX": 28,
                                "height": 24,
                                "fontSize": 24,
                                "color": "#ffffff",
                                "bold": true
                            },
                            "compId": 135
                        }]
                    }]
                }]
            }, {
                "type": "Image",
                "props": {
                    "width": 81,
                    "var": "shadow2",
                    "skin": "subpkg/UI/Share/4.png",
                    "pivotY": 41,
                    "pivotX": 41,
                    "height": 81,
                    "centerY": 225,
                    "centerX": 0
                },
                "compId": 116,
                "child": [{
                    "type": "Image",
                    "props": {
                        "y": 40.5,
                        "x": 143,
                        "width": 130,
                        "var": "article2",
                        "skin": "subpkg/UI/Share/5.png",
                        "pivotY": 12,
                        "pivotX": 66,
                        "height": 23
                    },
                    "compId": 121
                }, {
                    "type": "Image",
                    "props": {
                        "y": 30.5,
                        "x": 43,
                        "width": 40,
                        "var": "money2",
                        "skin": "subpkg/UI/Share/1.png",
                        "pivotY": 19,
                        "pivotX": 20,
                        "height": 37
                    },
                    "compId": 128,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "y": 50,
                            "x": 20,
                            "width": 50,
                            "text": "x100",
                            "strokeColor": "#d76b18",
                            "pivotY": 10,
                            "pivotX": 25,
                            "height": 20,
                            "fontSize": 20,
                            "color": "#ffffff",
                            "bold": true
                        },
                        "compId": 131
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "y": 41,
                        "x": 43,
                        "width": 100,
                        "var": "get2",
                        "skin": "subpkg/UI/Share/3.png",
                        "pivotY": 50,
                        "pivotX": 50,
                        "height": 100
                    },
                    "compId": 124,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 40,
                            "x": 50,
                            "width": 63,
                            "var": "HaveMoney2",
                            "skin": "subpkg/UI/Share/2.png",
                            "pivotY": 29,
                            "pivotX": 32,
                            "height": 58
                        },
                        "compId": 133,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": 64,
                                "x": 31.5,
                                "width": 55,
                                "text": "x100",
                                "strokeColor": "#d76b18",
                                "stroke": 4,
                                "pivotY": 12,
                                "pivotX": 28,
                                "height": 24,
                                "fontSize": 24,
                                "color": "#ffffff",
                                "bold": true
                            },
                            "compId": 134
                        }]
                    }]
                }]
            }, {
                "type": "Image",
                "props": {
                    "width": 81,
                    "var": "shadow3",
                    "skin": "subpkg/UI/Share/4.png",
                    "pivotY": 41,
                    "pivotX": 41,
                    "height": 81,
                    "centerY": 225,
                    "centerX": 200
                },
                "compId": 117,
                "child": [{
                    "type": "Image",
                    "props": {
                        "y": 40.5,
                        "x": 40.5,
                        "width": 100,
                        "var": "get3",
                        "skin": "subpkg/UI/Share/3.png",
                        "pivotY": 50,
                        "pivotX": 50,
                        "height": 100
                    },
                    "compId": 125
                }, {
                    "type": "Image",
                    "props": {
                        "y": 40.5,
                        "x": 40.5,
                        "width": 207,
                        "skin": "subpkg/UI/MainUI/12.png",
                        "scaleY": 0.4,
                        "scaleX": 0.4,
                        "rotation": 20,
                        "pivotY": 52,
                        "pivotX": 104,
                        "height": 104
                    },
                    "compId": 129
                }]
            }, {
                "type": "Image",
                "props": {
                    "width": 750,
                    "skin": "subpkg/UI/Share/10.png",
                    "pivotY": 168,
                    "pivotX": 360,
                    "height": 336,
                    "centerY": -110,
                    "centerX": 0
                },
                "compId": 112
            }, {
                "type": "Image",
                "props": {
                    "y": 10,
                    "x": 10,
                    "skin": "subpkg/UI/Share/8.png",
                    "centerY": -410,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 96
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/Share/9.png",
                    "centerY": -90,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 97
            }, {
                "type": "Image",
                "props": {
                    "y": 718,
                    "x": 215,
                    "skin": "subpkg/UI/TheTrial/5.png"
                },
                "compId": 113
            }, {
                "type": "Image",
                "props": {
                    "width": 435,
                    "skin": "subpkg/UI/Share/6.png",
                    "pivotY": 21,
                    "pivotX": 218,
                    "height": 41,
                    "centerY": 140,
                    "centerX": 0
                },
                "compId": 111
            }, {
                "type": "Image",
                "props": {
                    "width": 207,
                    "var": "gun",
                    "skin": "subpkg/UI/MainUI/12.png",
                    "scaleY": 1.5,
                    "scaleX": 1.5,
                    "rotation": 18,
                    "height": 104,
                    "centerY": -90,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 109
            }, {
                "type": "Image",
                "props": {
                    "width": 265,
                    "var": "Share",
                    "skin": "subpkg/UI/Share/7.png",
                    "pivotY": 50,
                    "pivotX": 133,
                    "height": 100,
                    "centerY": 400,
                    "centerX": -175
                },
                "compId": 100,
                "child": [{
                    "type": "Label",
                    "props": {
                        "var": "jd",
                        "text": "(0/3)",
                        "strokeColor": "#d76b18",
                        "stroke": 4,
                        "fontSize": 30,
                        "font": "Microsoft YaHei",
                        "color": "#ffffff",
                        "centerY": -3,
                        "centerX": 86,
                        "bold": true
                    },
                    "compId": 107
                }]
            }, {
                "type": "Image",
                "props": {
                    "width": 266,
                    "var": "Back",
                    "skin": "subpkg/UI/TheTrial/2.png",
                    "pivotY": 50,
                    "pivotX": 133,
                    "height": 100,
                    "centerY": 400,
                    "centerX": 175
                },
                "compId": 101
            }],
            "animations": [{
                "nodes": [{
                    "target": 97,
                    "keyframes": {
                        "rotation": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 97,
                            "key": "rotation",
                            "index": 0
                        }, {
                            "value": 45,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 97,
                            "key": "rotation",
                            "index": 10
                        }, {
                            "value": 90,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 97,
                            "key": "rotation",
                            "index": 20
                        }, {
                            "value": 135,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 97,
                            "key": "rotation",
                            "index": 30
                        }, {
                            "value": 180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 97,
                            "key": "rotation",
                            "index": 40
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/more/Board.png", "subpkg/UI/Share/4.png", "subpkg/UI/Share/5.png", "subpkg/UI/Share/1.png", "subpkg/UI/Share/3.png", "subpkg/UI/Share/2.png", "subpkg/UI/MainUI/12.png", "subpkg/UI/Share/10.png", "subpkg/UI/Share/8.png", "subpkg/UI/Share/9.png", "subpkg/UI/TheTrial/5.png", "subpkg/UI/Share/6.png", "subpkg/UI/Share/7.png", "subpkg/UI/TheTrial/2.png"],
            "loadList3D": []
        };
        ui.GetGunShareUI = GetGunShareUI;
        REG("ui.GetGunShareUI", GetGunShareUI);
        class GetGunVideoUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(GetGunVideoUI.uiView);
            }
        }
        GetGunVideoUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "width": 760,
                    "skin": "subpkg/more/Board.png",
                    "height": 1344,
                    "centerY": 0,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 112
            }, {
                "type": "Image",
                "props": {
                    "width": 750,
                    "skin": "subpkg/UI/TheTrial/7.png",
                    "pivotY": 168,
                    "pivotX": 360,
                    "height": 336,
                    "centerY": -150,
                    "centerX": 0
                },
                "compId": 116
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/TheTrial/5.png",
                    "centerY": 30,
                    "centerX": 0
                },
                "compId": 117
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/TheTrial/4.png",
                    "centerY": -410,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 99
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/TheTrial/6.png",
                    "centerY": -150,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 100
            }, {
                "type": "Image",
                "props": {
                    "width": 362,
                    "skin": "subpkg/UI/TheTrial/3.png",
                    "pivotY": 21,
                    "pivotX": 181,
                    "height": 41,
                    "centerY": 120,
                    "centerX": 0
                },
                "compId": 115
            }, {
                "type": "Image",
                "props": {
                    "width": 207,
                    "var": "gun",
                    "skin": "subpkg/UI/MainUI/12.png",
                    "scaleY": 2,
                    "scaleX": 2,
                    "rotation": 20,
                    "height": 104,
                    "centerY": -150,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 114
            }, {
                "type": "Image",
                "props": {
                    "y": 303,
                    "x": 175,
                    "skin": "subpkg/UI/Win/5.png",
                    "centerY": -180,
                    "centerX": 0
                },
                "compId": 118
            }, {
                "type": "Image",
                "props": {
                    "var": "Video",
                    "skin": "subpkg/UI/TheTrial/1.png",
                    "pivotY": -171,
                    "pivotX": 70,
                    "centerY": 240,
                    "centerX": -170
                },
                "compId": 102,
                "child": [{
                    "type": "Label",
                    "props": {
                        "var": "jd",
                        "text": "(0/3)",
                        "fontSize": 30,
                        "font": "Microsoft YaHei",
                        "color": "#ffffff",
                        "centerY": 0,
                        "centerX": 90,
                        "bold": true
                    },
                    "compId": 105
                }]
            }, {
                "type": "Image",
                "props": {
                    "y": 857,
                    "x": 412,
                    "var": "Back",
                    "skin": "subpkg/UI/TheTrial/2.png",
                    "centerY": 240,
                    "centerX": 170
                },
                "compId": 101
            }],
            "animations": [{
                "nodes": [{
                    "target": 100,
                    "keyframes": {
                        "rotation": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 0
                        }, {
                            "value": 45,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 10
                        }, {
                            "value": 90,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 20
                        }, {
                            "value": 135,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 30
                        }, {
                            "value": 180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 100,
                            "key": "rotation",
                            "index": 40
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/more/Board.png", "subpkg/UI/TheTrial/7.png", "subpkg/UI/TheTrial/5.png", "subpkg/UI/TheTrial/4.png", "subpkg/UI/TheTrial/6.png", "subpkg/UI/TheTrial/3.png", "subpkg/UI/MainUI/12.png", "subpkg/UI/Win/5.png", "subpkg/UI/TheTrial/1.png", "subpkg/UI/TheTrial/2.png"],
            "loadList3D": []
        };
        ui.GetGunVideoUI = GetGunVideoUI;
        REG("ui.GetGunVideoUI", GetGunVideoUI);
        class GetMoneyUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(GetMoneyUI.uiView);
            }
        }
        GetMoneyUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/bj3.png",
                    "sizeGrid": "0,0,0,0",
                    "centerY": -142,
                    "centerX": 0
                },
                "compId": 92
            }, {
                "type": "Image",
                "props": {
                    "width": 300,
                    "var": "videobtn",
                    "skin": "subpkg/UI/Win/8.png",
                    "height": 120,
                    "centerY": 0,
                    "centerX": 12,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 79,
                "child": [{
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/50.png",
                        "centerY": 0,
                        "centerX": 35,
                        "alpha": 0
                    },
                    "compId": 81
                }, {
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/Button/fenxiang.png",
                        "left": 30,
                        "centerY": 0,
                        "alpha": 0
                    },
                    "compId": 82
                }]
            }],
            "animations": [{
                "nodes": [],
                "name": "anibtn",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 79,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleY",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleY",
                            "index": 60
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleX",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleX",
                            "index": 60
                        }]
                    }
                }],
                "name": "anivideobtn",
                "id": 2,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/UI/bj3.png", "subpkg/UI/Win/8.png", "subpkg/UI/50.png", "subpkg/UI/Button/fenxiang.png"],
            "loadList3D": []
        };
        ui.GetMoneyUI = GetMoneyUI;
        REG("ui.GetMoneyUI", GetMoneyUI);
        class LoadingUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(LoadingUI.uiView);
            }
        }
        LoadingUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 2,
            "child": [{
                "type": "Image",
                "props": {
                    "top": 0,
                    "skin": "subpkg/UI/loading/2.png",
                    "right": 0,
                    "left": 0,
                    "bottom": 0
                },
                "compId": 3,
                "child": [{
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/loading/1.png",
                        "centerY": -250,
                        "centerX": 0
                    },
                    "compId": 43
                }]
            }, {
                "type": "Box",
                "props": {
                    "width": 495,
                    "var": "LoadingBox",
                    "height": 19,
                    "centerY": 380,
                    "centerX": 0
                },
                "compId": 40,
                "child": [{
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/loading/loadingbar.png",
                        "centerY": 0
                    },
                    "compId": 38
                }, {
                    "type": "Panel",
                    "props": {
                        "y": 0,
                        "x": 6,
                        "width": 204,
                        "var": "jd",
                        "height": 19
                    },
                    "compId": 39,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 495,
                            "skin": "subpkg/UI/loading/loading.png",
                            "height": 19
                        },
                        "compId": 41
                    }]
                }, {
                    "type": "Label",
                    "props": {
                        "var": "txtjd",
                        "valign": "middle",
                        "top": 50,
                        "text": "加载中..0%",
                        "strokeColor": "#370721",
                        "stroke": 4,
                        "fontSize": 40,
                        "font": "Microsoft YaHei",
                        "color": "#ffffff",
                        "centerX": 0,
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 42
                }]
            }],
            "loadList": ["subpkg/UI/loading/2.png", "subpkg/UI/loading/1.png", "subpkg/UI/loading/loadingbar.png", "subpkg/UI/loading/loading.png"],
            "loadList3D": []
        };
        ui.LoadingUI = LoadingUI;
        REG("ui.LoadingUI", LoadingUI);
        class MainUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(MainUI.uiView);
            }
        }
        MainUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "width": 750,
                    "var": "sBox",
                    "height": 1334,
                    "centerY": 0,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 75,
                "child": [{
                    "type": "Box",
                    "props": {
                        "y": 0,
                        "x": 0,
                        "var": "Box",
                        "top": 0,
                        "right": 0,
                        "left": 0,
                        "bottom": 0
                    },
                    "compId": 72
                }, {
                    "type": "Image",
                    "props": {
                        "var": "lvup",
                        "skin": "subpkg/UI/MainUI/10.png",
                        "centerY": -50,
                        "centerX": -290,
                        "anchorY": 0.5
                    },
                    "compId": 45,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "x": 32,
                            "var": "lvLV1",
                            "top": 28,
                            "text": "Lvl 21",
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerX": -20,
                            "bold": true,
                            "alpha": 0
                        },
                        "compId": 76
                    }, {
                        "type": "Label",
                        "props": {
                            "var": "lvLV2",
                            "valign": "middle",
                            "top": 13,
                            "text": "21",
                            "strokeColor": "#e07400",
                            "stroke": 3,
                            "left": 12,
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "bold": true,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "align": "center"
                        },
                        "compId": 65
                    }, {
                        "type": "Image",
                        "props": {
                            "x": 106,
                            "var": "uplv",
                            "top": -20,
                            "skin": "subpkg/UI/MainUI/8.png",
                            "right": 0
                        },
                        "compId": 62
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 104,
                            "var": "lvmoney1",
                            "text": "2000",
                            "strokeColor": "#000000",
                            "height": 22,
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerY": 37,
                            "centerX": 16,
                            "bold": true,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "alpha": 0
                        },
                        "compId": 77
                    }, {
                        "type": "Label",
                        "props": {
                            "var": "lvmoney2",
                            "text": "2000",
                            "strokeColor": "#e07400",
                            "stroke": 3,
                            "height": 22,
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "centerY": 38,
                            "centerX": 12,
                            "bold": true,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 67
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "var": "plup",
                        "skin": "subpkg/UI/MainUI/9.png",
                        "centerY": 130,
                        "centerX": -290,
                        "anchorY": 0.5
                    },
                    "compId": 46,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "x": 32,
                            "var": "plLV1",
                            "top": 28,
                            "text": "Lvl 21",
                            "strokeColor": "#000000",
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerX": -20,
                            "bold": true,
                            "alpha": 0
                        },
                        "compId": 78
                    }, {
                        "type": "Label",
                        "props": {
                            "var": "plLV2",
                            "valign": "middle",
                            "top": 17,
                            "text": "21",
                            "strokeColor": "#00458b",
                            "stroke": 3,
                            "left": 12,
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "bold": true,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "align": "center"
                        },
                        "compId": 66
                    }, {
                        "type": "Image",
                        "props": {
                            "x": 106,
                            "var": "uppl",
                            "top": -20,
                            "skin": "subpkg/UI/MainUI/8.png",
                            "right": 0
                        },
                        "compId": 64
                    }, {
                        "type": "Label",
                        "props": {
                            "var": "plmoney1",
                            "text": "2000",
                            "height": 22,
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerY": 39,
                            "centerX": 15,
                            "bold": true,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "alpha": 0
                        },
                        "compId": 79
                    }, {
                        "type": "Label",
                        "props": {
                            "var": "plmoney2",
                            "text": "2000",
                            "strokeColor": "#00458b",
                            "stroke": 3,
                            "height": 22,
                            "fontSize": 22,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "centerY": 40,
                            "centerX": 12,
                            "bold": true,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 69
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "var": "shop",
                        "skin": "subpkg/UI/MainUI/20.png",
                        "scaleY": 1,
                        "scaleX": 1,
                        "centerY": 110,
                        "centerX": 300,
                        "anchorY": 0.5,
                        "anchorX": 1
                    },
                    "compId": 47,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "width": 105,
                            "visible": false,
                            "skin": "subpkg/gun/1001.png",
                            "scaleY": 1,
                            "scaleX": 1,
                            "name": "gun",
                            "height": 105,
                            "centerY": 0,
                            "centerX": 0,
                            "anchorY": 0.5,
                            "anchorX": 1
                        },
                        "compId": 74
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 39,
                            "top": -22,
                            "skin": "subpkg/UI/MainUI/14.png",
                            "scaleY": 1,
                            "scaleX": 1,
                            "left": -1,
                            "height": 45,
                            "anchorY": 0.5,
                            "anchorX": 1
                        },
                        "compId": 91
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "share",
                        "skin": "subpkg/UI/MainUI/6.png",
                        "scaleY": 1,
                        "scaleX": 1,
                        "centerY": -160,
                        "centerX": 300,
                        "anchorY": 0.5,
                        "anchorX": 1
                    },
                    "compId": 89,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/share/share1.png",
                            "centerY": -20,
                            "centerX": 0
                        },
                        "compId": 90
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "trial",
                        "skin": "subpkg/UI/MainUI/7.png",
                        "scaleY": 1,
                        "scaleX": 1,
                        "centerY": -30,
                        "centerX": 300,
                        "anchorY": 0.5,
                        "anchorX": 1
                    },
                    "compId": 87,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/share/trial1.png",
                            "centerY": -20,
                            "centerX": 0
                        },
                        "compId": 88
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "var": "sup",
                        "skin": "subpkg/UI/MainUI/12.png",
                        "scaleY": 1,
                        "scaleX": 1,
                        "centerY": -224,
                        "centerX": -260,
                        "anchorY": 0.5,
                        "anchorX": 1
                    },
                    "compId": 92,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/UI/MainUI/11.png",
                            "scaleY": 1,
                            "scaleX": 1,
                            "centerY": 48,
                            "centerX": -7,
                            "anchorY": 0.5,
                            "anchorX": 1
                        },
                        "compId": 95
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 30,
                            "top": 10,
                            "skin": "subpkg/UI/hd.png",
                            "scaleY": 1,
                            "scaleX": 1,
                            "left": 10,
                            "height": 30,
                            "anchorY": 0.5,
                            "anchorX": 1
                        },
                        "compId": 96
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "y": 887,
                        "x": 202,
                        "skin": "subpkg/UI/MainUI/3.png",
                        "centerY": 250,
                        "centerX": 0
                    },
                    "compId": 48
                }, {
                    "type": "Image",
                    "props": {
                        "y": 1067,
                        "x": 375,
                        "skin": "subpkg/UI/MainUI/4399.png",
                        "centerY": 400,
                        "centerX": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 49,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 115,
                            "x": 209,
                            "width": 122,
                            "skin": "subpkg/UI/MainUI/5.png",
                            "pivotY": 62,
                            "pivotX": 61,
                            "height": 124
                        },
                        "compId": 50
                    }]
                }, {
                    "type": "List",
                    "props": {
                        "width": 555,
                        "var": "List",
                        "repeatY": 1,
                        "repeatX": 5,
                        "height": 98,
                        "centerY": -460,
                        "centerX": 20,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 59,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": -15,
                            "width": 117,
                            "renderType": "render",
                            "height": 98
                        },
                        "compId": 56,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "width": 50,
                                "skin": "subpkg/UI/MainUI/18.png",
                                "sizeGrid": "0,0,0,0",
                                "right": 90,
                                "name": "left",
                                "height": 30,
                                "centerY": 3
                            },
                            "compId": 58
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 50,
                                "skin": "subpkg/UI/MainUI/18.png",
                                "sizeGrid": "0,0,0,0",
                                "name": "right",
                                "left": 90,
                                "height": 30,
                                "centerY": 3
                            },
                            "compId": 57
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 70,
                                "skin": "subpkg/UI/MainUI/15.png",
                                "name": "now",
                                "height": 70,
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 55
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 70,
                                "skin": "subpkg/UI/MainUI/16.png",
                                "name": "lock",
                                "height": 70,
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 54
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 70,
                                "skin": "subpkg/UI/MainUI/17.png",
                                "name": "pass",
                                "height": 70,
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 70
                        }, {
                            "type": "Label",
                            "props": {
                                "text": "999",
                                "name": "Level",
                                "fontSize": 35,
                                "color": "#ffffff",
                                "centerY": 0,
                                "centerX": 0,
                                "bold": true
                            },
                            "compId": 73
                        }]
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "more",
                        "stateNum": 1,
                        "skin": "subpkg/UI/more.png",
                        "left": 0,
                        "labelStrokeColor": "#ffffff",
                        "labelStroke": 1,
                        "labelSize": 30,
                        "labelBold": true,
                        "centerY": 300
                    },
                    "compId": 80
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "AddIcon",
                        "stateNum": 1,
                        "skin": "subpkg/UI/home.png",
                        "right": 20,
                        "labelStrokeColor": "#ffffff",
                        "labelStroke": 1,
                        "labelSize": 30,
                        "labelBold": true,
                        "centerY": 450
                    },
                    "compId": 81
                }, {
                    "type": "Box",
                    "props": {
                        "width": 90,
                        "visible": false,
                        "var": "Nad",
                        "right": 30,
                        "mouseThrough": true,
                        "height": 90,
                        "centerY": 300
                    },
                    "compId": 82,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "width": 90,
                            "var": "NadIcon",
                            "mouseThrough": true,
                            "height": 90,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 84
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 20,
                            "var": "NadClo",
                            "top": -10,
                            "skin": "subpkg/more/ad-close.png",
                            "right": -10,
                            "height": 20
                        },
                        "compId": 85
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 30,
                            "skin": "subpkg/more/ad-text.png",
                            "right": 0,
                            "height": 18,
                            "bottom": 0
                        },
                        "compId": 86
                    }]
                }]
            }],
            "animations": [{
                "nodes": [{
                    "target": 50,
                    "keyframes": {
                        "y": [{
                            "value": 123,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 0
                        }, {
                            "value": 85,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 3
                        }, {
                            "value": 59,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 6
                        }, {
                            "value": 60,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 9
                        }, {
                            "value": 105,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 12
                        }, {
                            "value": 155,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 15
                        }, {
                            "value": 186,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 18
                        }, {
                            "value": 164,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 21
                        }, {
                            "value": 124,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 24
                        }, {
                            "value": 89,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 27
                        }, {
                            "value": 60,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 30
                        }, {
                            "value": 52,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 33
                        }, {
                            "value": 81,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 36
                        }, {
                            "value": 134,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 39
                        }, {
                            "value": 180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 42
                        }, {
                            "value": 177,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 45
                        }, {
                            "value": 151,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 48
                        }, {
                            "value": 123,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "y",
                            "index": 51
                        }],
                        "x": [{
                            "value": 182,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 0
                        }, {
                            "value": 151,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 3
                        }, {
                            "value": 106,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 6
                        }, {
                            "value": 41,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 9
                        }, {
                            "value": 7,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 12
                        }, {
                            "value": 19,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 15
                        }, {
                            "value": 73,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 18
                        }, {
                            "value": 132,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 21
                        }, {
                            "value": 181,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 24
                        }, {
                            "value": 210,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 27
                        }, {
                            "value": 254,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 30
                        }, {
                            "value": 303,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 33
                        }, {
                            "value": 351,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 36
                        }, {
                            "value": 359,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 39
                        }, {
                            "value": 318,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 42
                        }, {
                            "value": 252,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 45
                        }, {
                            "value": 210,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 48
                        }, {
                            "value": 182,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 50,
                            "key": "x",
                            "index": 51
                        }]
                    }
                }],
                "name": "anistart1",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 49,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 49,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 49,
                            "key": "scaleY",
                            "index": 3
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 49,
                            "key": "scaleY",
                            "index": 6
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 49,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 49,
                            "key": "scaleX",
                            "index": 3
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 49,
                            "key": "scaleX",
                            "index": 6
                        }]
                    }
                }],
                "name": "anistart2",
                "id": 2,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 62,
                    "keyframes": {
                        "top": [{
                            "value": -20,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 62,
                            "key": "top",
                            "index": 0
                        }, {
                            "value": -66,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 62,
                            "key": "top",
                            "index": 15
                        }, {
                            "value": -20,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 62,
                            "key": "top",
                            "index": 30
                        }]
                    }
                }],
                "name": "anilvup",
                "id": 5,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 64,
                    "keyframes": {
                        "top": [{
                            "value": -20,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 64,
                            "key": "top",
                            "index": 0
                        }, {
                            "value": -66,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 64,
                            "key": "top",
                            "index": 15
                        }, {
                            "value": -20,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 64,
                            "key": "top",
                            "index": 30
                        }]
                    }
                }],
                "name": "aniplup",
                "id": 6,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 45,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 45,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 45,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 45,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 45,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 45,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 45,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }],
                "name": "anilv",
                "id": 7,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 46,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 46,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 46,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 46,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 46,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.3,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 46,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 46,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }],
                "name": "anipl",
                "id": 8,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 47,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 47,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 47,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 47,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 47,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 47,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 47,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }],
                "name": "anishop",
                "id": 9,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 75,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleY",
                            "index": 7
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleX",
                            "index": 7
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleX",
                            "index": 10
                        }],
                        "alpha": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "alpha",
                            "index": 0
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "alpha",
                            "index": 7
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "alpha",
                            "index": 10
                        }]
                    }
                }],
                "name": "SHOW",
                "id": 10,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 75,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleY",
                            "index": 7
                        }, {
                            "value": 0.5,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleX",
                            "index": 7
                        }, {
                            "value": 0.5,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "scaleX",
                            "index": 10
                        }],
                        "alpha": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "alpha",
                            "index": 0
                        }, {
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 75,
                            "key": "alpha",
                            "index": 10
                        }]
                    }
                }],
                "name": "HIDE",
                "id": 11,
                "frameRate": 60,
                "action": 0
            }],
            "loadList": ["subpkg/UI/MainUI/10.png", "subpkg/UI/MainUI/8.png", "subpkg/UI/MainUI/9.png", "subpkg/UI/MainUI/20.png", "subpkg/gun/1001.png", "subpkg/UI/MainUI/14.png", "subpkg/UI/MainUI/6.png", "subpkg/share/share1.png", "subpkg/UI/MainUI/7.png", "subpkg/share/trial1.png", "subpkg/UI/MainUI/12.png", "subpkg/UI/MainUI/11.png", "subpkg/UI/hd.png", "subpkg/UI/MainUI/3.png", "subpkg/UI/MainUI/4399.png", "subpkg/UI/MainUI/5.png", "subpkg/UI/MainUI/18.png", "subpkg/UI/MainUI/15.png", "subpkg/UI/MainUI/16.png", "subpkg/UI/MainUI/17.png", "subpkg/UI/more.png", "subpkg/UI/home.png", "subpkg/more/ad-close.png", "subpkg/more/ad-text.png"],
            "loadList3D": []
        };
        ui.MainUI = MainUI;
        REG("ui.MainUI", MainUI);
        class NBUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(NBUI.uiView);
            }
        }
        NBUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "height": 120,
                "centerX": 0,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "var": "AD",
                    "top": 0,
                    "right": 0,
                    "left": 0,
                    "bottom": 0,
                    "bgColor": "#000000"
                },
                "compId": 9,
                "child": [{
                    "type": "Box",
                    "props": {
                        "y": 0,
                        "x": 0,
                        "var": "BJ",
                        "top": 0,
                        "right": 0,
                        "left": 0,
                        "bottom": 0,
                        "bgColor": "#ffffff"
                    },
                    "compId": 43
                }, {
                    "type": "Label",
                    "props": {
                        "var": "Title",
                        "valign": "middle",
                        "text": "标题标题",
                        "right": 140,
                        "overflow": "hidden",
                        "mouseThrough": true,
                        "left": 150,
                        "height": 25,
                        "fontSize": 25,
                        "color": "#000000",
                        "centerY": -20,
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 4
                }, {
                    "type": "Label",
                    "props": {
                        "wordWrap": true,
                        "var": "Desc",
                        "valign": "middle",
                        "text": "广告广告广告广告广告广告广告广告广告广告广告广告",
                        "right": 140,
                        "mouseThrough": true,
                        "left": 150,
                        "height": 30,
                        "fontSize": 14,
                        "color": "#000000",
                        "centerY": 20,
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 5
                }, {
                    "type": "Image",
                    "props": {
                        "width": 90,
                        "var": "Icon",
                        "mouseThrough": true,
                        "left": 50,
                        "height": 90,
                        "centerY": 0
                    },
                    "compId": 6
                }, {
                    "type": "Image",
                    "props": {
                        "width": 25,
                        "var": "Clo",
                        "top": 3,
                        "skin": "subpkg/more/ad-close.png",
                        "left": 3,
                        "height": 25,
                        "alpha": 0.7
                    },
                    "compId": 30
                }, {
                    "type": "Image",
                    "props": {
                        "width": 40,
                        "skin": "subpkg/more/ad-text.png",
                        "right": 0,
                        "height": 25,
                        "bottom": 0
                    },
                    "compId": 41
                }, {
                    "type": "Box",
                    "props": {
                        "y": 33,
                        "width": 110,
                        "var": "Click",
                        "right": 20,
                        "height": 35,
                        "centerY": 0,
                        "bgColor": "#000000"
                    },
                    "compId": 44,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "top": 2,
                            "right": 2,
                            "left": 2,
                            "bottom": 2,
                            "bgColor": "#12c9e1"
                        },
                        "compId": 45
                    }, {
                        "type": "Label",
                        "props": {
                            "x": 0,
                            "var": "Clicklabel",
                            "text": "查看详情",
                            "leading": 5,
                            "fontSize": 20,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerY": 3,
                            "centerX": 0,
                            "bold": true
                        },
                        "compId": 46
                    }]
                }]
            }],
            "loadList": ["subpkg/more/ad-close.png", "subpkg/more/ad-text.png"],
            "loadList3D": []
        };
        ui.NBUI = NBUI;
        REG("ui.NBUI", NBUI);
        class NB2UI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(NB2UI.uiView);
            }
        }
        NB2UI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "height": 360,
                "centerX": 0,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "y": 10,
                    "x": 10,
                    "width": 750,
                    "var": "NAD",
                    "right": 0,
                    "left": 0,
                    "height": 300,
                    "bottom": 0
                },
                "compId": 47,
                "child": [{
                    "type": "Image",
                    "props": {
                        "var": "img",
                        "top": 0,
                        "skin": "subpkg/more/BJ2.png",
                        "rotation": 0,
                        "right": 0,
                        "left": 0,
                        "bottom": 0
                    },
                    "compId": 48
                }, {
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/more/ad-text.png",
                        "right": 0,
                        "bottom": 0
                    },
                    "compId": 49
                }, {
                    "type": "Label",
                    "props": {
                        "y": 156,
                        "x": 166,
                        "var": "Desc",
                        "valign": "middle",
                        "text": "广告广告广告广告",
                        "overflow": "hidden",
                        "mouseThrough": true,
                        "fontSize": 28,
                        "color": "#000000",
                        "centerY": 0,
                        "centerX": 0,
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 50
                }, {
                    "type": "Image",
                    "props": {
                        "width": 35,
                        "var": "Clo",
                        "top": 10,
                        "skin": "subpkg/more/ad-close.png",
                        "right": 10,
                        "height": 35
                    },
                    "compId": 51
                }, {
                    "type": "Image",
                    "props": {
                        "var": "Click",
                        "skin": "subpkg/UI/nad.png",
                        "centerY": -150,
                        "centerX": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 52
                }]
            }],
            "loadList": ["subpkg/more/BJ2.png", "subpkg/more/ad-text.png", "subpkg/more/ad-close.png", "subpkg/UI/nad.png"],
            "loadList3D": []
        };
        ui.NB2UI = NB2UI;
        REG("ui.NB2UI", NB2UI);
        class NIUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(NIUI.uiView);
            }
        }
        NIUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "top": -10,
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "bgColor": "#242d38",
                    "alpha": 0.5
                },
                "compId": 44
            }, {
                "type": "Image",
                "props": {
                    "width": 560,
                    "var": "AD",
                    "height": 420,
                    "centerY": 0,
                    "centerX": 0
                },
                "compId": 9,
                "child": [{
                    "type": "Box",
                    "props": {
                        "y": -165,
                        "x": -387,
                        "var": "BJ",
                        "top": 0,
                        "right": 0,
                        "left": 0,
                        "bottom": 0,
                        "bgColor": "#ffffff"
                    },
                    "compId": 43
                }, {
                    "type": "Label",
                    "props": {
                        "y": 10,
                        "x": 10,
                        "var": "Desc",
                        "valign": "middle",
                        "top": 10,
                        "text": "广告广告广告广告",
                        "right": 10,
                        "overflow": "hidden",
                        "mouseThrough": true,
                        "left": 10,
                        "fontSize": 20,
                        "color": "#000000",
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 5
                }, {
                    "type": "Image",
                    "props": {
                        "var": "img",
                        "top": 45,
                        "skin": "subpkg/more/Board.png",
                        "rotation": 0,
                        "right": 5,
                        "left": 5,
                        "bottom": 90
                    },
                    "compId": 3,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/more/ad-text.png",
                            "right": 0,
                            "bottom": 0
                        },
                        "compId": 41
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "width": 64,
                        "var": "Icon",
                        "mouseThrough": true,
                        "left": 40,
                        "height": 64,
                        "bottom": 10
                    },
                    "compId": 6,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "width": 280,
                            "var": "Title",
                            "valign": "middle",
                            "text": "标题标题",
                            "overflow": "hidden",
                            "mouseThrough": true,
                            "left": 70,
                            "height": 20,
                            "fontSize": 20,
                            "color": "#000000",
                            "centerY": 0,
                            "bold": true
                        },
                        "compId": 4
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "width": 40,
                        "var": "Clo",
                        "top": 3,
                        "skin": "subpkg/more/ad-close.png",
                        "right": 3,
                        "height": 40
                    },
                    "compId": 30
                }, {
                    "type": "Box",
                    "props": {
                        "width": 110,
                        "var": "Click",
                        "right": 30,
                        "height": 35,
                        "bottom": 25,
                        "bgColor": "#000000"
                    },
                    "compId": 45,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "top": 2,
                            "right": 2,
                            "left": 2,
                            "bottom": 2,
                            "bgColor": "#12c9e1"
                        },
                        "compId": 46
                    }, {
                        "type": "Label",
                        "props": {
                            "x": 0,
                            "var": "Clicklabel",
                            "text": "查看详情",
                            "leading": 5,
                            "fontSize": 20,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerY": 3,
                            "centerX": 0,
                            "bold": true
                        },
                        "compId": 47
                    }]
                }]
            }],
            "loadList": ["subpkg/more/Board.png", "subpkg/more/ad-text.png", "subpkg/more/ad-close.png"],
            "loadList3D": []
        };
        ui.NIUI = NIUI;
        REG("ui.NIUI", NIUI);
        class POPUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(POPUI.uiView);
            }
        }
        POPUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "width": 750,
                    "skin": "subpkg/UI/GoldSkin/1.png",
                    "centerY": 0,
                    "centerX": 0
                },
                "compId": 85,
                "child": [{
                    "type": "Image",
                    "props": {
                        "top": -150,
                        "skin": "subpkg/UI/GoldSkin/3.png",
                        "centerX": 0
                    },
                    "compId": 86
                }, {
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/16-1.png",
                        "centerY": 0,
                        "centerX": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 89
                }, {
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/GoldSkin/2.png",
                        "centerY": 170,
                        "centerX": 0
                    },
                    "compId": 90
                }, {
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/GoldSkin/4.png",
                        "centerX": -160,
                        "bottom": -276
                    },
                    "compId": 79,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/UI/57.png",
                            "centerY": 0,
                            "centerX": 20,
                            "alpha": 0
                        },
                        "compId": 81
                    }, {
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/UI/video1.png",
                            "left": 50,
                            "centerY": 0,
                            "alpha": 0
                        },
                        "compId": 82
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "var": "Back",
                        "skin": "subpkg/UI/GoldSkin/5.png",
                        "centerX": 160,
                        "bottom": -276
                    },
                    "compId": 80,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "skin": "subpkg/UI/58.png",
                            "centerY": 0,
                            "centerX": 0,
                            "alpha": 0
                        },
                        "compId": 87
                    }]
                }]
            }],
            "loadList": ["subpkg/UI/GoldSkin/1.png", "subpkg/UI/GoldSkin/3.png", "subpkg/UI/16-1.png", "subpkg/UI/GoldSkin/2.png", "subpkg/UI/GoldSkin/4.png", "subpkg/UI/57.png", "subpkg/UI/video1.png", "subpkg/UI/GoldSkin/5.png", "subpkg/UI/58.png"],
            "loadList3D": []
        };
        ui.POPUI = POPUI;
        REG("ui.POPUI", POPUI);
        class ShopUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(ShopUI.uiView);
            }
        }
        ShopUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "width": 750,
                    "var": "sBox",
                    "height": 1334,
                    "centerY": 0,
                    "centerX": 0,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 107,
                "child": [{
                    "type": "Image",
                    "props": {
                        "width": 750,
                        "skin": "subpkg/UI/Mall/BGnode.png",
                        "sizeGrid": "5,5,5,5",
                        "height": 1334,
                        "centerY": 0,
                        "centerX": 0
                    },
                    "compId": 130
                }, {
                    "type": "Image",
                    "props": {
                        "width": 750,
                        "var": "BJ",
                        "skin": "subpkg/UI/bj1.png",
                        "sizeGrid": "10,10,10,10",
                        "height": 520,
                        "centerY": -407,
                        "centerX": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 131,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/UI/Mall/Mall8.png",
                            "centerY": 160,
                            "centerX": 0
                        },
                        "compId": 192
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "unlock",
                        "top": 457,
                        "skin": "subpkg/UI/38.png",
                        "right": 0,
                        "alpha": 0
                    },
                    "compId": 132,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "subpkg/UI/39.png",
                            "right": 11,
                            "centerY": 0,
                            "alpha": 0
                        },
                        "compId": 139,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "skin": "subpkg/UI/40.png",
                                "centerY": 0,
                                "centerX": 0,
                                "alpha": 0
                            },
                            "compId": 140
                        }]
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "width": 200,
                        "visible": false,
                        "var": "lock",
                        "height": 80,
                        "centerY": -179,
                        "centerX": 275
                    },
                    "compId": 133,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "width": 222,
                            "sizeGrid": "10,0,10,0",
                            "height": 80,
                            "centerY": 40,
                            "centerX": -11,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 141,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": -102,
                                "x": 4,
                                "width": 215,
                                "skin": "subpkg/gun/2006_2.png",
                                "left": 4,
                                "height": 86,
                                "centerY": -59,
                                "alpha": 1
                            },
                            "compId": 143
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "subpkg/UI/Mall/Mall1.png",
                                "left": 7,
                                "centerY": -24
                            },
                            "compId": 142
                        }, {
                            "type": "Label",
                            "props": {
                                "visible": true,
                                "var": "progress",
                                "text": "（0/2）",
                                "strokeColor": "#0d0d0d",
                                "stroke": 3,
                                "fontSize": 22,
                                "font": "Microsoft YaHei",
                                "color": "#ffffff",
                                "centerY": 10,
                                "centerX": 0,
                                "bold": true
                            },
                            "compId": 144
                        }]
                    }]
                }, {
                    "type": "List",
                    "props": {
                        "x": 0,
                        "width": 650,
                        "var": "List",
                        "spaceY": 15,
                        "spaceX": 15,
                        "repeatY": 2,
                        "repeatX": 3,
                        "height": 500,
                        "elasticEnabled": true,
                        "centerY": 130,
                        "centerX": 0
                    },
                    "compId": 134,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 150,
                            "x": 120,
                            "width": 188,
                            "renderType": "render",
                            "height": 188,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 145,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 7,
                                "x": 7,
                                "skin": "subpkg/UI/45.png",
                                "sizeGrid": "0,0,0,0",
                                "name": "BG",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 146
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "subpkg/UI/47.png",
                                "sizeGrid": "0,0,0,0",
                                "name": "xuanz",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 147
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "subpkg/gun/1001.png",
                                "name": "gun",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 148
                        }, {
                            "type": "Sprite",
                            "props": {
                                "y": 63.5,
                                "x": 68,
                                "width": 0,
                                "texture": "subpkg/UI/Mall/Mall7.png",
                                "name": "lock"
                            },
                            "compId": 191
                        }]
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "x": 0,
                        "centerY": -160,
                        "centerX": 0
                    },
                    "compId": 135,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "var": "Left",
                            "skin": "subpkg/UI/Mall/Mall3.png",
                            "centerY": 300,
                            "centerX": -340
                        },
                        "compId": 150
                    }, {
                        "type": "Image",
                        "props": {
                            "var": "Right",
                            "skin": "subpkg/UI/Mall/Mall2.png",
                            "centerY": 300,
                            "centerX": 340
                        },
                        "compId": 151
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 25,
                            "var": "putbtn",
                            "skin": "subpkg/UI/Mall/Mall10.png",
                            "height": 25,
                            "centerY": 560,
                            "centerX": -150
                        },
                        "compId": 155
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 25,
                            "var": "shisbtn",
                            "skin": "subpkg/UI/Mall/Mall10.png",
                            "height": 25,
                            "centerY": 560,
                            "centerX": 0
                        },
                        "compId": 156
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 25,
                            "var": "chuansbtn",
                            "skin": "subpkg/UI/Mall/Mall10.png",
                            "height": 25,
                            "centerY": 560,
                            "centerX": 150
                        },
                        "compId": 157
                    }, {
                        "type": "Image",
                        "props": {
                            "visible": false,
                            "var": "put",
                            "skin": "subpkg/UI/Mall/Mall11.png",
                            "centerY": 560,
                            "centerX": -150
                        },
                        "compId": 152,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "text": "- 普通 -",
                                "name": "PutTitle",
                                "fontSize": 40,
                                "font": "Microsoft YaHei",
                                "color": "#ffffff",
                                "centerY": -520,
                                "centerX": 150,
                                "bold": true
                            },
                            "compId": 194
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "visible": false,
                            "var": "shis",
                            "skin": "subpkg/UI/Mall/Mall11.png",
                            "centerY": 560,
                            "centerX": 0
                        },
                        "compId": 153,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "text": "- 史诗 -",
                                "name": "ShisTitle",
                                "fontSize": 40,
                                "font": "Microsoft YaHei",
                                "color": "#ffffff",
                                "centerY": -520,
                                "centerX": 0,
                                "bold": true
                            },
                            "compId": 195
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "visible": false,
                            "var": "chuans",
                            "skin": "subpkg/UI/Mall/Mall11.png",
                            "centerY": 560,
                            "centerX": 150
                        },
                        "compId": 154,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "var": "ChuansTitle",
                                "text": "- 传说 -",
                                "fontSize": 40,
                                "font": "Microsoft YaHei",
                                "color": "#ffffff",
                                "centerY": -520,
                                "centerX": -150,
                                "bold": true
                            },
                            "compId": 196
                        }]
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "Used",
                        "skin": "subpkg/UI/Mall/24.png",
                        "centerY": 510,
                        "centerX": 0
                    },
                    "compId": 197
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "random",
                        "skin": "subpkg/UI/Mall/dianjigoumai.png",
                        "centerY": 510,
                        "centerX": -180,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 136,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "var": "r_num",
                            "text": "5000",
                            "fontSize": 40,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "centerY": 22,
                            "centerX": 1,
                            "bold": true
                        },
                        "compId": 159
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "width": 339,
                        "visible": false,
                        "var": "video",
                        "skin": "subpkg/UI/Mall/jieshuo2.png",
                        "height": 137,
                        "centerY": 510,
                        "centerX": 180,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 137,
                    "child": [{
                        "type": "Label",
                        "props": {
                            "var": "v_num",
                            "text": "0/2",
                            "fontSize": 40,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "centerY": 0,
                            "centerX": 75,
                            "bold": true
                        },
                        "compId": 161
                    }, {
                        "type": "Image",
                        "props": {
                            "y": -403,
                            "var": "Adimg",
                            "skin": "subpkg/UI/video1.png",
                            "left": 45,
                            "centerY": 0,
                            "alpha": 0
                        },
                        "compId": 162
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "var": "Back",
                        "skin": "subpkg/UI/Mall/Mall6.png",
                        "centerY": -200,
                        "centerX": -320
                    },
                    "compId": 138
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "tishi",
                        "top": 0,
                        "skin": "subpkg/UI/Fail/zhezhao.png",
                        "sizeGrid": "5,5,5,5",
                        "right": 0,
                        "left": 0,
                        "bottom": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 201,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 667,
                            "x": 375,
                            "visible": true,
                            "skin": "subpkg/UI/Mall/tishi.png",
                            "sizeGrid": "5,5,5,5",
                            "rotation": 0,
                            "right": 0,
                            "left": 0,
                            "centerY": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 198,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "valign": "middle",
                                "text": "获得1碎片",
                                "strokeColor": "#cb7500",
                                "stroke": 8,
                                "fontSize": 42,
                                "font": "Microsoft YaHei",
                                "color": "#ffffff",
                                "centerY": 3,
                                "centerX": 0,
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 200
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 207,
                                "x": 375,
                                "var": "queding",
                                "skin": "subpkg/UI/Mall/queding.png",
                                "centerY": 151,
                                "centerX": 0,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 199
                        }]
                    }]
                }]
            }],
            "animations": [{
                "nodes": [{
                    "target": 136,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }],
                "name": "anirandom1",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 136,
                    "keyframes": {
                        "centerX": [{
                            "value": -180,
                            "tweenMethod": "linearNone",
                            "tween": false,
                            "target": 136,
                            "key": "centerX",
                            "index": 0
                        }, {
                            "value": -170,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "centerX",
                            "index": 2
                        }, {
                            "value": -190,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "centerX",
                            "index": 6
                        }, {
                            "value": -175,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "centerX",
                            "index": 10
                        }, {
                            "value": -185,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "centerX",
                            "index": 14
                        }, {
                            "value": -180,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 136,
                            "key": "centerX",
                            "index": 16
                        }]
                    }
                }],
                "name": "anirandom2",
                "id": 2,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 137,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 137,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 137,
                            "key": "scaleY",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 137,
                            "key": "scaleY",
                            "index": 60
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 137,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 137,
                            "key": "scaleX",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 137,
                            "key": "scaleX",
                            "index": 60
                        }]
                    }
                }],
                "name": "anivideo",
                "id": 3,
                "frameRate": 60,
                "action": 2
            }, {
                "nodes": [{
                    "target": 107,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleY",
                            "index": 7
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleX",
                            "index": 7
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleX",
                            "index": 10
                        }],
                        "alpha": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "alpha",
                            "index": 0
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "alpha",
                            "index": 7
                        }]
                    }
                }],
                "name": "SHOW",
                "id": 4,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 107,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleY",
                            "index": 7
                        }, {
                            "value": 0.5,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleX",
                            "index": 7
                        }, {
                            "value": 0.5,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "scaleX",
                            "index": 10
                        }],
                        "alpha": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "alpha",
                            "index": 0
                        }, {
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 107,
                            "key": "alpha",
                            "index": 10
                        }]
                    }
                }],
                "name": "HIDE",
                "id": 5,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 141,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 141,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 141,
                            "key": "scaleY",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 141,
                            "key": "scaleY",
                            "index": 60
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 141,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 141,
                            "key": "scaleX",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 141,
                            "key": "scaleX",
                            "index": 60
                        }]
                    }
                }],
                "name": "anilock",
                "id": 6,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/UI/Mall/BGnode.png", "subpkg/UI/bj1.png", "subpkg/UI/Mall/Mall8.png", "subpkg/UI/38.png", "subpkg/UI/39.png", "subpkg/UI/40.png", "subpkg/gun/2006_2.png", "subpkg/UI/Mall/Mall1.png", "subpkg/UI/45.png", "subpkg/UI/47.png", "subpkg/gun/1001.png", "subpkg/UI/Mall/Mall7.png", "subpkg/UI/Mall/Mall3.png", "subpkg/UI/Mall/Mall2.png", "subpkg/UI/Mall/Mall10.png", "subpkg/UI/Mall/Mall11.png", "subpkg/UI/Mall/24.png", "subpkg/UI/Mall/dianjigoumai.png", "subpkg/UI/Mall/jieshuo2.png", "subpkg/UI/video1.png", "subpkg/UI/Mall/Mall6.png", "subpkg/UI/Fail/zhezhao.png", "subpkg/UI/Mall/tishi.png", "subpkg/UI/Mall/queding.png"],
            "loadList3D": []
        };
        ui.ShopUI = ShopUI;
        REG("ui.ShopUI", ShopUI);
        class TipsUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(TipsUI.uiView);
            }
        }
        TipsUI.uiView = {
            "type": "View",
            "props": {
                "x": 0,
                "width": 750,
                "height": 75,
                "centerX": 0
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "top": 0,
                    "skin": "subpkg/more/Board.png",
                    "right": 0,
                    "left": 0,
                    "bottom": 0,
                    "alpha": 1
                },
                "compId": 2
            }, {
                "type": "Label",
                "props": {
                    "y": 0,
                    "var": "TXT",
                    "valign": "middle",
                    "text": "只有观看了完整的广告，才能复活角色",
                    "strokeColor": "#5a5a5a",
                    "stroke": 0,
                    "padding": "4,4,0,4",
                    "fontSize": 32,
                    "font": "Arial",
                    "color": "#f8e400",
                    "centerY": 0,
                    "centerX": 0,
                    "align": "center"
                },
                "compId": 7
            }],
            "loadList": ["subpkg/more/Board.png"],
            "loadList3D": []
        };
        ui.TipsUI = TipsUI;
        REG("ui.TipsUI", TipsUI);
        class Tips_VideoUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(Tips_VideoUI.uiView);
            }
        }
        Tips_VideoUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "mouseThrough": true,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 2,
            "child": [{
                "type": "Box",
                "props": {
                    "y": -10,
                    "x": -10,
                    "var": "Im_tips",
                    "top": -10,
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "bgColor": "#242d38",
                    "alpha": 0.5
                },
                "compId": 9
            }, {
                "type": "Label",
                "props": {
                    "wordWrap": true,
                    "width": 563,
                    "var": "TXT",
                    "valign": "middle",
                    "text": "播放广告中...",
                    "height": 150,
                    "fontSize": 50,
                    "color": "#ffffff",
                    "centerY": 0,
                    "centerX": 0,
                    "align": "center"
                },
                "compId": 7
            }, {
                "type": "Label",
                "props": {
                    "visible": false,
                    "var": "tip",
                    "text": "长时间无反应点击任意地方即可返回",
                    "fontSize": 35,
                    "color": "#ffffff",
                    "centerY": 100,
                    "centerX": 0
                },
                "compId": 8
            }],
            "loadList": [],
            "loadList3D": []
        };
        ui.Tips_VideoUI = Tips_VideoUI;
        REG("ui.Tips_VideoUI", Tips_VideoUI);
        class TopUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(TopUI.uiView);
            }
        }
        TopUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "mouseThrough": true,
                "left": 0,
                "height": 360
            },
            "compId": 1,
            "child": [{
                "type": "Image",
                "props": {
                    "width": 260,
                    "skin": "subpkg/UI/Top/2.png",
                    "height": 60,
                    "centerY": -100,
                    "centerX": -180
                },
                "compId": 61,
                "child": [{
                    "type": "Label",
                    "props": {
                        "var": "Gold",
                        "valign": "middle",
                        "text": "9999999",
                        "fontSize": 50,
                        "font": "Arial",
                        "color": "#ffffff",
                        "centerY": 0,
                        "centerX": 25,
                        "bold": true,
                        "align": "left"
                    },
                    "compId": 63
                }, {
                    "type": "Image",
                    "props": {
                        "var": "goldImg",
                        "skin": "subpkg/UI/Top/1.png",
                        "right": 212,
                        "centerY": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 62
                }]
            }, {
                "type": "Box",
                "props": {
                    "width": 96,
                    "visible": false,
                    "var": "Box",
                    "top": 169,
                    "left": 10,
                    "height": 96,
                    "alpha": 0
                },
                "compId": 60,
                "child": [{
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "top": 190,
                        "skin": "subpkg/UI/25.png",
                        "centerX": 0,
                        "alpha": 0
                    },
                    "compId": 44
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "vib",
                        "top": 109,
                        "skin": "subpkg/UI/MainUI/1.png",
                        "centerX": 0,
                        "alpha": 0
                    },
                    "compId": 43
                }, {
                    "type": "Image",
                    "props": {
                        "visible": false,
                        "var": "Set",
                        "skin": "subpkg/UI/23.png",
                        "centerY": 0,
                        "centerX": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5,
                        "alpha": 0
                    },
                    "compId": 42
                }]
            }],
            "animations": [{
                "nodes": [{
                    "target": 43,
                    "keyframes": {
                        "top": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 43,
                            "key": "top",
                            "index": 0
                        }, {
                            "value": 100,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 43,
                            "key": "top",
                            "index": 5
                        }]
                    }
                }, {
                    "target": 44,
                    "keyframes": {
                        "top": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 44,
                            "key": "top",
                            "index": 0
                        }, {
                            "value": 190,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 44,
                            "key": "top",
                            "index": 5
                        }]
                    }
                }],
                "name": "showset",
                "id": 1,
                "frameRate": 24,
                "action": 0
            }, {
                "nodes": [{
                    "target": 44,
                    "keyframes": {
                        "top": [{
                            "value": 190,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 44,
                            "key": "top",
                            "index": 0
                        }, {
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 44,
                            "key": "top",
                            "index": 5
                        }]
                    }
                }, {
                    "target": 43,
                    "keyframes": {
                        "top": [{
                            "value": 100,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 43,
                            "key": "top",
                            "index": 0
                        }, {
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 43,
                            "key": "top",
                            "index": 5
                        }]
                    }
                }],
                "name": "hideset",
                "id": 2,
                "frameRate": 24,
                "action": 0
            }, {
                "nodes": [{
                    "target": 42,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 42,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 42,
                            "key": "scaleY",
                            "index": 3
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 42,
                            "key": "scaleY",
                            "index": 6
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 42,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 42,
                            "key": "scaleX",
                            "index": 3
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 42,
                            "key": "scaleX",
                            "index": 6
                        }]
                    }
                }],
                "name": "aniSet",
                "id": 3,
                "frameRate": 60,
                "action": 0
            }],
            "loadList": ["subpkg/UI/Top/2.png", "subpkg/UI/Top/1.png", "subpkg/UI/25.png", "subpkg/UI/MainUI/1.png", "subpkg/UI/23.png"],
            "loadList3D": []
        };
        ui.TopUI = TopUI;
        REG("ui.TopUI", TopUI);
        class WinUI extends View {
            constructor() {
                super();
            }
            createChildren() {
                super.createChildren();
                this.createView(WinUI.uiView);
            }
        }
        WinUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 1,
            "child": [{
                "type": "Box",
                "props": {
                    "top": -11,
                    "right": -10,
                    "left": -10,
                    "bottom": -10,
                    "bgColor": "#242d38",
                    "alpha": 0.7
                },
                "compId": 119
            }, {
                "type": "Image",
                "props": {
                    "skin": "subpkg/UI/Win/10.png",
                    "centerY": -343,
                    "centerX": -10
                },
                "compId": 75,
                "child": [{
                    "type": "Sprite",
                    "props": {
                        "y": 0,
                        "x": 61,
                        "texture": "subpkg/UI/Win/6.png"
                    },
                    "compId": 114
                }, {
                    "type": "Sprite",
                    "props": {
                        "y": 181,
                        "x": -22.5,
                        "texture": "subpkg/UI/Win/4.png"
                    },
                    "compId": 115,
                    "child": [{
                        "type": "Sprite",
                        "props": {
                            "y": 15.25,
                            "x": 126.75,
                            "texture": "subpkg/UI/Win/3.png"
                        },
                        "compId": 116
                    }]
                }, {
                    "type": "Sprite",
                    "props": {
                        "y": 0,
                        "x": 30,
                        "texture": "subpkg/UI/Win/5.png"
                    },
                    "compId": 117
                }]
            }, {
                "type": "Image",
                "props": {
                    "var": "goldImg",
                    "skin": "subpkg/UI/Win/1.png",
                    "centerY": -138,
                    "centerX": -10,
                    "anchorY": 0.5,
                    "anchorX": 0.5
                },
                "compId": 73,
                "child": [{
                    "type": "Image",
                    "props": {
                        "skin": "subpkg/UI/Win/2.png",
                        "centerY": 122,
                        "centerX": 12
                    },
                    "compId": 118
                }, {
                    "type": "Label",
                    "props": {
                        "width": 154,
                        "var": "gold1",
                        "valign": "middle",
                        "text": "14064",
                        "pivotY": 25,
                        "pivotX": 77,
                        "height": 50,
                        "fontSize": 50,
                        "font": "Microsoft YaHei",
                        "color": "#000000",
                        "centerY": 131,
                        "centerX": 12,
                        "bold": true,
                        "alpha": 0.6,
                        "align": "center"
                    },
                    "compId": 74
                }, {
                    "type": "Label",
                    "props": {
                        "width": 154,
                        "var": "gold2",
                        "valign": "middle",
                        "text": "14064",
                        "pivotY": 25,
                        "pivotX": 77,
                        "height": 50,
                        "fontSize": 50,
                        "font": "Microsoft YaHei",
                        "color": "#fdcd02",
                        "centerY": 128,
                        "centerX": 12,
                        "bold": true,
                        "align": "center"
                    },
                    "compId": 92
                }]
            }, {
                "type": "Box",
                "props": {
                    "width": 650,
                    "height": 260,
                    "centerX": 0,
                    "bottom": 386
                },
                "compId": 95,
                "child": [{
                    "type": "Image",
                    "props": {
                        "width": 300,
                        "visible": false,
                        "var": "Share",
                        "top": 216,
                        "skin": "subpkg/UI/Win/8.png",
                        "sizeGrid": "0,20,0,20",
                        "height": 120,
                        "centerX": 0,
                        "anchorY": 0.5,
                        "anchorX": 0.5,
                        "alpha": 1
                    },
                    "compId": 109
                }, {
                    "type": "Image",
                    "props": {
                        "width": 300,
                        "var": "btn",
                        "skin": "subpkg/UI/Win/7.png",
                        "pivotY": 60,
                        "pivotX": 150,
                        "height": 120,
                        "centerX": 175,
                        "bottom": 93
                    },
                    "compId": 80,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "skin": "subpkg/UI/53.png",
                            "left": 35,
                            "centerY": 0,
                            "alpha": 0
                        },
                        "compId": 84
                    }, {
                        "type": "Label",
                        "props": {
                            "x": 88,
                            "var": "gold3",
                            "text": "14064",
                            "fontSize": 50,
                            "font": "Microsoft YaHei",
                            "color": "#000000",
                            "centerY": 6,
                            "centerX": 15,
                            "bold": true,
                            "alpha": 0
                        },
                        "compId": 94
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 38,
                            "x": 88,
                            "var": "gold4",
                            "text": "14064",
                            "fontSize": 50,
                            "font": "Microsoft YaHei",
                            "color": "#ffffff",
                            "centerY": 3,
                            "centerX": 15,
                            "bold": true,
                            "alpha": 0
                        },
                        "compId": 76
                    }]
                }, {
                    "type": "Image",
                    "props": {
                        "width": 300,
                        "var": "videobtn",
                        "skin": "subpkg/UI/Win/9.png",
                        "height": 120,
                        "centerX": -170,
                        "bottom": 93,
                        "anchorY": 0.5,
                        "anchorX": 0.5
                    },
                    "compId": 79
                }]
            }],
            "animations": [{
                "nodes": [{
                    "target": 80,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 80,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 80,
                            "key": "scaleY",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 80,
                            "key": "scaleY",
                            "index": 10
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 80,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 80,
                            "key": "scaleX",
                            "index": 5
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 80,
                            "key": "scaleX",
                            "index": 10
                        }]
                    }
                }],
                "name": "anibtn",
                "id": 1,
                "frameRate": 60,
                "action": 0
            }, {
                "nodes": [{
                    "target": 79,
                    "keyframes": {
                        "scaleY": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleY",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleY",
                            "index": 60
                        }],
                        "scaleX": [{
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 1.2,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleX",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 79,
                            "key": "scaleX",
                            "index": 60
                        }]
                    }
                }],
                "name": "anivideobtn",
                "id": 2,
                "frameRate": 60,
                "action": 2
            }],
            "loadList": ["subpkg/UI/Win/10.png", "subpkg/UI/Win/6.png", "subpkg/UI/Win/4.png", "subpkg/UI/Win/3.png", "subpkg/UI/Win/5.png", "subpkg/UI/Win/1.png", "subpkg/UI/Win/2.png", "subpkg/UI/Win/8.png", "subpkg/UI/Win/7.png", "subpkg/UI/53.png", "subpkg/UI/Win/9.png"],
            "loadList3D": []
        };
        ui.WinUI = WinUI;
        REG("ui.WinUI", WinUI);
    })(ui || (ui = {}));

    class VTips extends ui.Tips_VideoUI {
        constructor() {
            super();
            this.zOrder = 9999;
            this.visible = false;
            Laya.stage.addChild(this);
        }
        static Show() {
            if (!VTips.UI)
                VTips.UI = new VTips();
            VTips.UI.visible = true;
            VTips.UI.tip.visible = false;
            VTips.UI.Im_tips.offAll(Laya.Event.CLICK);
            VTips.UI.Im_tips.on(Laya.Event.CLICK, VTips, () => {
                VTips.Hide();
            });
            if (BSet.PfSDK == SDKType.Dummy)
                VTips.UI.TXT.changeText("播放广告中...");
            else
                VTips.UI.TXT.changeText("广告加载中...");
            Laya.timer.once(5000, VTips.UI, () => {
                if (VTips.UI) {
                    VTips.UI.tip.visible = true;
                    VTips.UI.Im_tips.offAll(Laya.Event.CLICK);
                    VTips.UI.Im_tips.on(Laya.Event.CLICK, VTips, () => {
                        Laya.timer.resume();
                        GEvent.Ins.event(GEvent.Audv, true);
                        VTips.Hide();
                    });
                }
            });
        }
        static ShowTip(Tip) {
            if (!VTips.UI)
                VTips.UI = new VTips();
            VTips.UI.visible = true;
            VTips.UI.tip.visible = false;
            VTips.UI.Im_tips.offAll(Laya.Event.CLICK);
            VTips.UI.Im_tips.on(Laya.Event.CLICK, VTips, () => {});
            VTips.UI.TXT.changeText(Tip);
            Laya.timer.once(5000, VTips.UI, () => {
                if (VTips.UI) {
                    VTips.UI.tip.visible = true;
                    VTips.UI.Im_tips.offAll(Laya.Event.CLICK);
                    VTips.UI.Im_tips.on(Laya.Event.CLICK, VTips, () => {
                        Laya.timer.resume();
                        GEvent.Ins.event(GEvent.Audv, true);
                        VTips.Hide();
                    });
                }
            });
        }
        static Hide() {
            if (VTips.UI && VTips.UI.visible) {
                VTips.UI.visible = false;
                Laya.timer.clearAll(VTips.UI);
            }
        }
    }
    VTips.UI = null;

    class EMod extends ui.ErrModalUI {
        constructor() {
            super();
            this.visible = false;
            this.Clo.on(Laya.Event.CLICK, this, () => {
                SDK().Exit();
            });
        }
        static CreateIns() {
            this.EMod = new EMod();
        }
        static Show(tit, cont) {}
    }

    class SDKB {
        constructor() {
            this.EnterTime = 0;
            this.vPath = null;
            this.GRec = null;
            this.mIsRec = false;
            this.mRecStaT = 0;
            this.mRecL = 0;
            this.VAd = null;
            this.IsLVdeo = false;
            this.IsSVdeo = false;
            this.IAd = null;
            this.BAd = null;
            this.IsShowB = false;
            this.IsShowI = false;
            this.NB = null;
            this.NB2 = null;
            this.NIcon = null;
            this.NInsert = null;
            this.NIc = "NIc";
            this.VCbk = null;
            this.RecCbk = null;
            this.Music = null;
            this.fullAdTime = 0;
        }
        SupShe() {
            return false;
        }
        Init() {
            this.EnterTime = Date.now();
        }
        Initialize() {}
        onS(res) {
            console.log('onShow', JSON.stringify(res));
            GEvent.Ins.event(GEvent.Audv, true);
            GStor.Updt();
            setTimeout(() => {
                GStor.PrCag();
                GStor.Updt();
            }, 100);
            setTimeout(() => VTips.Hide(), 100);
            setTimeout(() => Laya.timer.resume(), 100);
        }
        onH(res) {
            console.log('onHide', JSON.stringify(res));
            GEvent.Ins.event(GEvent.Audv, false);
            Laya.timer.pause();
        }
        SetAudv(play) {
            Laya.SoundManager.soundMuted = !play;
        }
        Login() {}
        ShowB() {}
        ShowB2() {
            this.ShowB();
        }
        HideB() {}
        ShowNIc() {
            this.ShowB();
        }
        NIOnShow() {}
        NIcOnCl() {}
        ShowV(Cbk,e) {
            console.log(e);
            delete this.VCbk;
            this.VCbk = null;
            this.VCbk = Cbk;
            awardVideo(e,()=>{//激励视频
                this.ShowVAd();
            },
            (error)=>{
                failure();
            })
            console.log("showRewardVideo");
        }
        ShowVAd() {
            this.VCbk && this.VCbk(true);
        }
        VidSSuc() {
            this.onH('');
        }
        Verr(err) {
            this.v_over(false, true);
        }
        onVClo(res) {
            let ok = true;
            if (res && !res.isEnded)
                ok = false;
            this.v_over(ok);
        }
        v_over(end, e = false, m = "广告拉取繁忙，稍后再试!") {
            this.IsLVdeo = false;
            this.IsSVdeo = false;
            this.onS('');
            if (e)
                this.STips(m);
            else {
                if (end) {
                    GEvent.Ins.event(GEvent.kWatchAds);
                } else {}
            }
            this.VCbk && this.VCbk(end, e);
            delete this.VCbk;
            this.VCbk = null;
        }
        VsLoad() {
            this.IsSVdeo = true;
            VTips.Show();
        }
        ShowI(video = false) {
            console.log("showFullScreenAd");
            var self = this;
            var currentTime = Math.round(new Date().getTime() / 1000);
            if (window.ysdk && currentTime - this.fullAdTime >= 60) {
                window.ysdk.adv.showFullscreenAdv({
                    callbacks: {
                        onOpen: function() {
                            self.fullAdTime = Math.round(new Date().getTime() / 1000);
                            // Laya.SoundManager.muted = true;
                            GameSound.StopMusic();
                            console.log(`fullscreen open`)
                        },
                        onClose: function(wasShown) {
                            // Laya.SoundManager.muted = false;
                            GameSound.PlayMusic();
                            console.log(`fullscreen close`, wasShown)
                            // some action after close
                        },
                        onError: function(error) {
                            console.log(`fullscreen error`, error)
                            // some action on error
                        }
                    }
                })
            }
        }
        ShowGB() {}
        HideGB() {}
        ShowGP() {}
        HideGP() {}
        VibL() {
            navigator.vibrate && navigator.vibrate(400);
        }
        VibS() {
            navigator.vibrate && navigator.vibrate(30);
        }
        GetStor(key) {
            return window.ystorage.getItem(key);
        }
        SetStor(key, value) {
            window.ystorage.setItem(key, value);
        }
        DelStor(key) {
            window.ystorage.removeItem(key);
        }
        CleStor() {
            window.ystorage.clear();
        }
        SupRec() {
            return false;
        }
        IsRec() {
            return false;
        }
        RecL() {
            return 0;
        }
        StaRec(StopFun) {}
        StRec() {}
        RecEv(Cbk) {
            delete this.RecCbk;
            this.RecCbk = null;
            this.RecCbk = Cbk;
        }
        ShaRec() {
            this.Recend(true);
        }
        Recend(end) {
            this.RecCbk && this.RecCbk(end);
            delete this.RecCbk;
            this.RecCbk = null;
        }
        playM(url) {
            if (!url)
                return;
            if (this.Musicurl != url && this.Music) {
                Laya.SoundManager.stopMusic();
                delete this.Music;
                this.Music = null;
            }
            this.Musicurl = url;
            if (!this.Music) {
                Laya.SoundManager.useAudioMusic = false;
                this.Music = Laya.SoundManager.playMusic(this.Musicurl, 0);
            } else {
                this.Music.loops = 0;
                this.Music.play();
            }
        }
        StM() {
            this.Music && this.Music.pause();
        }
        plS(url, loop, complete = null) {
            Laya.SoundManager.playSound(url, loop, complete);
        }
        StS(url) {
            Laya.SoundManager.stopSound(url);
        }
        Exit() {}
        showerrM(title, content) {
            EMod.Show(title, content);
        }
        LoadSub(C1, C2) {
            delete this.SubComp;
            this.SubComp = null;
            delete this.SubPro;
            this.SubPro = null;
            this.SubComp = C1;
            this.SubPro = C2;
            this.loadSub();
        }
        loadSub() {
            this.SubComp && this.SubComp(null);
        }
        STips(msg) {
            let UI = new ui.TipsUI();
            Laya.stage.addChild(UI);
            UI.TXT.text = msg;
            UI.centerY = 0;
            UI.centerX = 0;
            UI.zOrder = 5000;
            setTimeout(() => UI.destroy(), 1000);
        }
        AddIcon() {}
    }

    class Dummy extends SDKB {}

    class TT extends SDKB {
        constructor() {
            super(...arguments);
            this.Videoid = 'be9j9afah8j31391po';
            this.Insertid = 'prlq4o41m7up5aq6kp';
            this.Bannerid = '4890iaed1f63h7116j';
            this.ShaRecCD = 0;
        }
        SupShe() {
            return true;
        }
        Init() {
            if (tt.getUpdateManager) {
                const update = tt.getUpdateManager();
                update.onCheckForUpdate((res) => {});
                update.onUpdateReady(() => update.applyUpdate());
                update.onUpdateFailed(() => {});
            }
            tt.setKeepScreenOn({
                keepScreenOn: true
            });
            this.Sys = tt.getSystemInfoSync();
            this.InitRec();
        }
        InitRec() {
            if (tt.getGameRecorderManager) {
                this.GRec = tt.getGameRecorderManager();
                this.GRec.onStart(res => {
                    console.error('录屏开始', res);
                    this.mRecStaT = Date.now();
                    this.mRecL = 0;
                    this.mIsRec = true;
                    this.vPath = null;
                });
                this.GRec.onResume(res => {
                    console.error('继续录屏', res);
                    this.mRecStaT = Date.now();
                    this.mIsRec = true;
                });
                this.GRec.onPause(res => {
                    console.error('录屏暂停', res);
                    this.IsRec() && (this.mRecL += Date.now() - this.mRecStaT);
                    this.mIsRec = false;
                });
                this.GRec.onStop(res => {
                    console.error('录屏结束', res);
                    this.IsRec() && (this.mRecL += Date.now() - this.mRecStaT);
                    this.mIsRec = false;
                    this.vPath = res.videoPath;
                    this.RecordeEnd();
                });
                this.GRec.onError(err => {
                    console.error('录屏错误', err);
                    this.mIsRec = false;
                    this.vPath = null;
                    this.mRecStaT = 0;
                    this.mRecL = 0;
                    this.RecordeEnd();
                });
            }
        }
        Initialize() {
            tt.onShow(res => this.onS(res));
            tt.onHide(res => this.onH(res));
        }
        ShowB() {
            if (!tt.createBannerAd || !this.Bannerid)
                return;
            this.HideB();
            this.IsShowB = true;
            this.BAd = tt.createBannerAd({
                adUnitId: this.Bannerid,
                style: {
                    width: 208
                }
            });
            this.BResize = this.onBRes.bind(this);
            this.BLoad = this.onBLoad.bind(this);
            this.BAd.onResize(this.BResize);
            this.BAd.onLoad(this.BLoad);
        }
        onBRes(res) {
            this.BAd.style.top = this.Sys.screenHeight - res.height;
            this.BAd.style.left = (this.Sys.screenWidth - res.width) * 0.5;
        }
        HideB() {
            this.IsShowB = false;
            this.DesB();
        }
        onBLoad(res) {
            this.IsShowB && this.BAd && this.BAd.show();
        }
        DesB() {
            if (this.BAd) {
                this.BResize && this.BAd.offResize(this.BResize);
                this.BLoad && this.BAd.offLoad(this.BLoad);
                this.BAd.hide();
                this.BAd.destroy();
                this.BAd = null;
            }
        }
        ShowVAd() {
            this.VsLoad();
            if (!this.VAd) {
                this.VAd = tt.createRewardedVideoAd({
                    adUnitId: this.Videoid
                });
                this.VAd.onError((err) => {
                    if (!this.VCbk)
                        return;
                    this.Verr();
                });
                this.VAd.onLoad((res) => {
                    console.log('拉取视频广告成功');
                    this.IsLVdeo = true;
                    if (!this.VCbk)
                        return;
                    this.VAd.show().then(() => {
                        this.onH('');
                        this.VClo && this.VAd.offClose(this.VClo);
                        delete this.VClo;
                        this.VClo = this.onVClo.bind(this);
                        this.VAd.onClose(this.VClo);
                    });
                });
            }
            this.VAd.load();
        };
        ShowI(video = false) {
            if (!tt.createInterstitialAd || !this.Insertid)
                return;
            this.IAd && this.IAd.destroy();
            delete this.IAd;
            this.IAd = null;
            this.IAd = tt.createInterstitialAd({
                adUnitId: this.Insertid
            });
            this.IAd.load()
                .then(() => this.IAd.show()
                    .then(res => video && this.v_over(true))
                    .catch(e => this.Verr(e)))
                .catch(e => this.Verr(e));
        }
        VibL() {
            tt.vibrateLong({});
        }
        VibS() {
            tt.vibrateShort({});
        }
        GetStor(key) {
            try {
                return tt.getStorageSync(key);
            } catch (error) {
                return "";
            }
        }
        SetStor(key, value) {
            tt.setStorage({
                key: key,
                data: value
            });
        }
        DelStor(key) {
            tt.removeStorage({
                key: key
            });
        }
        SupRec() {
            return this.GRec ? true : false;
        }
        IsRec() {
            return this.mIsRec;
        }
        RecL() {
            let nLength = this.mRecL;
            if (this.mIsRec)
                nLength += Date.now() - this.mRecStaT;
            return nLength;
        }
        StaRec(StopFun) {
            this.StopF && delete this.StopF;
            this.StopF = StopFun;
            this.GRec.start({
                duration: 300
            });
        }
        StRec() {
            this.GRec.stop();
        }
        RecordeEnd() {
            console.error('StopFun');
            this.StopF && this.StopF();
            delete this.StopF;
            this.StopF = null;
        }
        ShaRec() {
            let now = Date.now();
            if (now - this.ShaRecCD <= 500)
                return;
            this.ShaRecCD = now;
            if (!this.vPath) {
                this.STips("先玩一局再来分享");
                this.Recend(false);
                return;
            }
            if (tt.shareAppMessage) {
                tt.shareAppMessage({
                    channel: 'video',
                    extra: {
                        videoPath: this.vPath,
                        videoTopics: ["营救特工队", "抖音小游戏"],
                        hashtag_list: ["营救特工队", "抖音小游戏"],
                    },
                    success: () => {
                        this.vPath = null;
                        this.STips('分享视频成功!');
                        this.Recend(true);
                    },
                    fail: (e) => {
                        console.error(`分享视频失败`, e);
                        if (e.errMsg.indexOf('short') >= 0) {
                            this.STips('失败 时间太短!');
                            this.Recend(false);
                        } else if (e.errMsg.indexOf('fail can not be shared without clicking by user') >= 0) {
                            this.ShaRec();
                        } else {
                            this.Recend(false);
                        }
                    }
                });
            }
        }
        Exit() {
            tt.exitMiniProgram({});
        }
        loadSub() {
            if (tt.loadSubpackage)
                tt.loadSubpackage({
                    name: 'Resources',
                    success: res => super.loadSub()
                }).onProgressUpdate(msg => this.SubPro && this.SubPro(Math.floor(msg.progress)));
            else
                super.loadSub();
        }
    }

    class NB2UI {
        constructor(onClick, onShow) {
            this.UI = new ui.NB2UI();
            Laya.stage.addChild(this.UI);
            this.UI.zOrder = 2000;
            this.UI.visible = false;
            this.OnClick = onClick;
            this.OnShow = onShow;
            this.UI.img.on("click", this, this.OnBtnClick);
            this.UI.Click.on("click", this, this.OnBtnClick);
            this.UI.Clo.on("click", this, this.Hide);
        }
        Show() {
            this.UI.visible = true;
            this.OnShow && SDK().NB2 && this.OnShow(SDK().NB2.adId);
        }
        Hide() {
            this.UI.visible = false;
            delete SDK().NB2;
            SDK().NB2 = null;
        }
        OnLoadAdData() {
            if (SDK().NB2) {
                if (SDK().NB2.imgUrlList && SDK().NB2.imgUrlList.length > 0)
                    this.UI.img.skin = SDK().NB2.imgUrlList[0];
                else if (SDK().NB2.iconUrlList && SDK().NB2.iconUrlList.length > 0)
                    this.UI.img.skin = SDK().NB2.iconUrlList[0];
                if (SDK().NB2.desc)
                    this.UI.Desc.text = SDK().NB2.desc;
            }
            SDK().IsShowB && this.Show();
        }
        OnBtnClick() {
            this.OnClick && SDK().NB2 && this.OnClick(SDK().NB2.adId);
        }
    }

    class NIUI {
        constructor(onClick, onShow) {
            this.UI = new ui.NIUI();
            Laya.stage.addChild(this.UI);
            this.UI.zOrder = 2000;
            this.UI.visible = false;
            this.mBtnClick = onClick;
            this.mOnShow = onShow;
            this.UI.BJ.on("click", this, this.OnBtnClick);
            this.UI.img.on("click", this, this.OnBtnClick);
            this.UI.Click.on("click", this, this.OnBtnClick);
            this.UI.Clo.on("click", this, this.Hide);
        }
        Show() {
            this.UI.visible = true;
            this.mOnShow && SDK().NInsert && this.mOnShow(SDK().NInsert.adId);
        }
        Hide() {
            SDK().IsShowI = false;
            this.UI.visible = false;
            delete SDK().NInsert;
            SDK().NInsert = null;
        }
        OnLoadAdData() {
            if (SDK().NInsert) {
                if (SDK().NInsert.imgUrlList && SDK().NInsert.imgUrlList.length > 0)
                    this.UI.img.skin = SDK().NInsert.imgUrlList[0];
                else if (SDK().NInsert.iconUrlList && SDK().NInsert.iconUrlList.length > 0)
                    this.UI.img.skin = SDK().NInsert.iconUrlList[0];
                if (SDK().NInsert.clickBtnTxt)
                    this.UI.Clicklabel.text = SDK().NInsert.clickBtnTxt;
                if (SDK().NInsert.title)
                    this.UI.Title.text = SDK().NInsert.title;
                if (SDK().NInsert.desc)
                    this.UI.Desc.text = SDK().NInsert.desc;
                if (SDK().NInsert.icon)
                    this.UI.Icon.skin = SDK().NInsert.icon;
            }
            this.Show();
        }
        OnBtnClick() {
            this.mBtnClick && SDK().NInsert && this.mBtnClick(SDK().NInsert.adId);
        }
    }

    class NBUI {
        constructor(onClick, onShow) {
            this.mViewUI = new ui.NBUI();
            Laya.stage.addChild(this.mViewUI);
            this.mViewUI.zOrder = 2000;
            this.mViewUI.visible = false;
            this.mBtnClick = onClick;
            this.mOnShow = onShow;
            this.mViewUI.BJ.on("click", this, this.OnBtnClick);
            this.mViewUI.Click.on("click", this, this.OnBtnClick);
            this.mViewUI.Clo.on("click", this, this.Hide);
        }
        Show() {
            this.mViewUI.visible = true;
            this.mOnShow && SDK().NB && this.mOnShow(SDK().NB.adId);
        }
        Hide() {
            this.mViewUI.visible = false;
            delete SDK().NB;
            SDK().NB = null;
        }
        OnLoadAdData() {
            if (SDK().NB) {
                if (SDK().NB.clickBtnTxt)
                    this.mViewUI.Clicklabel.text = SDK().NB.clickBtnTxt;
                if (SDK().NB.title)
                    this.mViewUI.Title.text = SDK().NB.title;
                if (SDK().NB.desc)
                    this.mViewUI.Desc.text = SDK().NB.desc;
                if (SDK().NB.icon)
                    this.mViewUI.Icon.skin = SDK().NB.icon;
                else if (SDK().NB.iconUrlList && SDK().NB.iconUrlList.length > 0)
                    this.mViewUI.Icon.skin = SDK().NB.iconUrlList[0];
                else if (SDK().NB.imgUrlList && SDK().NB.imgUrlList.length > 0)
                    this.mViewUI.Icon.skin = SDK().NB.imgUrlList[0];
            }
            SDK().IsShowB && this.Show();
        }
        OnBtnClick() {
            this.mBtnClick && SDK().NB && this.mBtnClick(SDK().NB.adId);
        }
    }

    class OPPO extends SDKB {
        constructor() {
            super(...arguments);
            this.Vid = "308427";
            this.Bid = "308425";
            this.Nid = ["308429", "308431"];
            this.GBid = '308434';
            this.GPid = "308432";
            this.GBAd = null;
            this.GPAd = null;
            this.PortalAdCD = 0;
        }
        Init() {
            if (qg.getUpdateManager) {
                const update = qg.getUpdateManager();
                update.onCheckForUpdate((res) => {});
                update.onUpdateReady(() => update.applyUpdate());
                update.onUpdateFailed(() => {});
            }
            qg.setKeepScreenOn({
                keepScreenOn: true
            });
            this.Sys = qg.getSystemInfoSync();
        }
        Initialize() {
            this.NIUI = new NIUI((adId) => {
                this.NInsertAd && this.NInsertAd.reportAdClick({
                    adId: adId
                });
                this.NIUI.Hide();
            }, (adId) => this.NInsertAd && this.NInsertAd.reportAdShow({
                adId: adId
            }));
            this.NBUI = new NBUI((adId) => {
                this.NBAd && this.NBAd.reportAdClick({
                    adId: adId
                });
                this.NBUI.Hide();
            }, (adId) => this.NBAd && this.NBAd.reportAdShow({
                adId: adId
            }));
            this.NB2UI = new NB2UI((adId) => {
                this.NBAd2 && this.NBAd2.reportAdClick({
                    adId: adId
                });
                this.NB2UI.Hide();
            }, (adId) => this.NBAd2 && this.NBAd2.reportAdShow({
                adId: adId
            }));
            qg.onShow(res => this.onS(res));
            qg.onHide(res => this.onH(res));
        }
        ShowB() {
            if (Date.now() - this.EnterTime <= 60000)
                return;
            if (!qg.createNativeAd) {
                this.showB();
                return;
            }
            this.HideB();
            this.IsShowB = true;
            this.NB = null;
            this.NBAd = qg.createNativeAd({
                posId: this.Nid[Math.floor(Math.random() * this.Nid.length)]
            });
            this.NBAd.onLoad((res) => {
                console.log(`NBannerAd  OnLoad => ${JSON.stringify(res)}`);
                this.NB = res.adList[0];
                this.NBUI.OnLoadAdData();
            });
            this.NBAd.onError((err) => {
                console.error(`NBannerAd  err => ${JSON.stringify(err)}`);
                this.NB = null;
                this.showB();
            });
            this.NBAd && this.NBAd.load();
            this.bTio && clearTimeout(this.bTio);
            this.bTio = setTimeout(() => this.ShowB(), 30000);
        }
        ShowB2() {
            if (Date.now() - this.EnterTime <= 60000)
                return;
            if (!qg.createNativeAd) {
                this.showB();
                return;
            }
            this.HideB();
            this.IsShowB = true;
            this.NB2 = null;
            this.NBAd2 = qg.createNativeAd({
                posId: this.Nid[Math.floor(Math.random() * this.Nid.length)]
            });
            this.NBAd2.onLoad((res) => {
                console.log(`NBannerAd2  OnLoad => ${JSON.stringify(res)}`);
                this.NB2 = res.adList[0];
                this.NB2UI.OnLoadAdData();
            });
            this.NBAd2.onError((err) => {
                console.error(`NBannerAd2  err => ${JSON.stringify(err)}`);
                this.NB2 = null;
                this.showB();
            });
            this.NBAd2 && this.NBAd2.load();
        }
        showB() {
            if (!qg.createBannerAd || !this.Bid)
                return;
            this.BAd = qg.createBannerAd({
                adUnitId: this.Bid,
                style: {}
            });
            this.IsShowB && this.BAd.show();
        }
        HideB() {
            this.bTio && clearTimeout(this.bTio);
            this.bTio = null;
            this.IsShowB = false;
            this.NBUI.Hide();
            this.NB2UI.Hide();
            this.DesBanner();
        }
        DesBanner() {
            if (this.NBAd) {
                this.NBAd.offError();
                this.NBAd.offLoad();
                this.NBAd.destroy();
                delete this.NBAd;
                this.NBAd = null;
            }
            if (this.NBAd2) {
                this.NBAd2.offError();
                this.NBAd2.offLoad();
                this.NBAd2.destroy();
                this.NBAd2 = null;
            }
            if (this.NIcAd) {
                this.NIcAd.offError();
                this.NIcAd.offLoad();
                this.NIcAd.destroy();
                this.NIcAd = null;
            }
            if (this.BAd) {
                this.BAd.hide();
                this.BAd.destroy();
                this.BAd = null;
            }
        }
        ShowVAd() {
            this.VsLoad();
            if (!this.VAd) {
                this.VAd = qg.createRewardedVideoAd({
                    adUnitId: this.Vid
                });
                this.VAd.onError((err) => {
                    if (!this.VCbk)
                        return;
                    this.Verr();
                });
                this.VAd.onLoad((res) => {
                    console.log('拉取视频广告成功');
                    this.IsLVdeo = true;
                    if (!this.VCbk)
                        return;
                    this.onH('');
                    this.VClo && this.VAd.offClose(this.VClo);
                    delete this.VClo;
                    this.VClo = this.onVClo.bind(this);
                    this.VAd.onClose(this.VClo);
                    this.VAd.show();
                });
            }
            this.VAd.load();
        }
        ShowGB() {
            if (this.Sys.platformVersionCode >= 1076) {
                this.HideB();
                if (this.GBAd) {
                    this.GBAd.destroy();
                    delete this.GBAd;
                    this.GBAd = null;
                }
                this.GBAd = qg.createGameBannerAd({
                    adUnitId: this.GBid
                });
                this.GBAd.show().catch(err => this.ShowB());
            } else
                this.ShowB();
        }
        HideGB() {
            this.GBAd && this.GBAd.hide();
        }
        ShowGP() {
            if (this.Sys.platformVersionCode >= 1076) {
                let now = Date.now();
                if (now - this.PortalAdCD < 0)
                    return;
                this.PortalAdCD = now + 1000;
                this.HideB();
                if (this.GPAd) {
                    this.GPAd.destroy();
                    delete this.GPAd;
                    this.GPAd = null;
                }
                this.GPAd = qg.createGamePortalAd({
                    adUnitId: this.GPid
                });
                this.GPAd.onClose(() => this.ShowB());
                this.GPAd.load().then(res => this.GPAd.show());
            }
        }
        HideGP() {
            this.GPAd && this.GPAd.hide();
        }
        ShowNIc() {
            if (Date.now() - this.EnterTime <= 60000)
                return;
            if (!qg.createNativeAd)
                return;
            this.HideB();
            this.NIcon = null;
            this.NIcAd = qg.createNativeAd({
                posId: this.Nid[Math.floor(Math.random() * this.Nid.length)]
            });
            this.NIcAd.onLoad((res) => {
                console.log(`NIconAd  OnLoad => ${JSON.stringify(res)}`);
                this.NIcon = res.adList[0];
                GEvent.Ins.event(this.NIc);
            });
            this.NIcAd.onError((err) => {
                console.error(`NIconAd  err => ${JSON.stringify(err)}`);
                this.ShowB();
            });
            this.NIcAd && this.NIcAd.load();
        }
        NIOnShow() {
            this.NIcAd && this.NIcAd.reportAdShow({
                adId: this.NIcon.adId
            });
        }
        NIcOnCl() {
            this.NIcAd && this.NIcAd.reportAdClick({
                adId: this.NIcon.adId
            });
        }
        AddIcon() {
            qg.hasShortcutInstalled({
                success: res => res == false && qg.installShortcut({
                    success: () => {}
                })
            });
        }
        VibL() {
            qg.vibrateLong({});
        }
        VibS() {
            qg.vibrateShort({});
        }
        GetStor(key) {
            try {
                return window.ystorage.getItem(key);
            } catch (error) {
                return "";
            }
        }
        SetStor(key, value) {
            window.ystorage.setItem(key, value);
        }
        DelStor(key) {
            window.ystorage.removeItem(key);
        }
        Exit() {
            qg.exitApplication({});
        }
        loadSub() {
            this.SubComp && this.SubComp(null);
        }
    }

    class WeChat extends SDKB {
        constructor() {
            super(...arguments);
            this.Videoid = 'adunit-bfa5eec7e484a6a4';
            this.Insertid = 'adunit-7a3014eaa8be8ffb';
            this.Bannerid = 'adunit-2a5e437475de0ef1';
            this.ShareImageUrl = "";
            this.IsShaRecShare = false;
            this.ShaRecCD = 0;
        }
        SupShe() {
            return true;
        }
        Init() {
            if (wx.getUpdateManager) {
                const update = wx.getUpdateManager();
                update.onCheckForUpdate((res) => {});
                update.onUpdateReady(() => update.applyUpdate());
                update.onUpdateFailed(() => {});
            }
            wx.setKeepScreenOn({
                keepScreenOn: true
            });
            this.Sys = wx.getSystemInfoSync();
            this.InitRec();
        }
        InitRec() {
            if (wx.getGameRecorderManager) {
                this.GRec = wx.getGameRecorderManager();
                this.GRec.onStart(res => {
                    console.error('录屏开始', res);
                    this.mRecStaT = Date.now();
                    this.mRecL = 0;
                    this.mIsRec = true;
                    this.vPath = null;
                });
                this.GRec.onResume(res => {
                    console.error('继续录屏', res);
                    this.mRecStaT = Date.now();
                    this.mIsRec = true;
                });
                this.GRec.onPause(res => {
                    console.error('录屏暂停', res);
                    this.IsRec() && (this.mRecL += Date.now() - this.mRecStaT);
                    this.mIsRec = false;
                });
                this.GRec.onStop(res => {
                    console.error('录屏结束', res);
                    this.IsRec() && (this.mRecL += Date.now() - this.mRecStaT);
                    this.mIsRec = false;
                    this.vPath = res.videoPath;
                    this.RecordeEnd();
                });
                this.GRec.onError(err => {
                    console.error('录屏错误', err);
                    this.mIsRec = false;
                    this.vPath = null;
                    this.mRecStaT = 0;
                    this.mRecL = 0;
                    this.RecordeEnd();
                });
            }
        }
        Initialize() {
            wx.onShow(res => this.onS(res));
            wx.onHide(res => this.onH(res));
        }
        ShowB() {
            if (!wx.createBannerAd || !this.Bannerid)
                return;
            this.HideB();
            this.IsShowB = true;
            this.BAd = wx.createBannerAd({
                adUnitId: this.Bannerid,
                style: {
                    top: Laya.Browser.clientHeight - 80,
                    left: 0,
                    width: 60,
                    height: 60
                }
            });
            this.BResize = this.onBRes.bind(this);
            this.BLoad = this.onBLoad.bind(this);
            this.BAd.onResize(this.BResize);
            this.BAd.onLoad(this.BLoad);
            this.BAd.onError(() => {});
        }
        onBRes(res) {
            this.BAd.style.top = this.Sys.screenHeight - res.height;
            this.BAd.style.left = (this.Sys.screenWidth - res.width) * 0.5;
        }
        HideB() {
            this.IsShowB = false;
            this.DesB();
        }
        onBLoad(res) {
            this.IsShowB && this.BAd && this.BAd.show();
        }
        DesB() {
            if (this.BAd) {
                this.BResize && this.BAd.offResize(this.BResize);
                this.BLoad && this.BAd.offLoad(this.BLoad);
                this.BAd.hide();
                this.BAd.destroy();
                this.BAd = null;
            }
        }
        onS(res) {
            super.onS(res);
            this.ShowShaRec();
        }
        ShowVAd() {
            this.VsLoad();
            if (!this.VAd) {
                this.VAd = wx.createRewardedVideoAd({
                    adUnitId: this.Videoid
                });
                this.VAd.onError(function(err) {
                    if (!this.VCbk)
                        return;
                    this.Verr();
                }.bind(this));
                this.VAd.onLoad(function(res) {
                    console.log('拉取视频广告成功');
                    this.IsLVdeo = true;
                    if (!this.VCbk)
                        return;
                    this.VAd.show().then(() => {
                        this.onH('');
                        this.VClo && this.VAd.offClose(this.VClo);
                        delete this.VClo;
                        this.VClo = this.onVClo.bind(this);
                        this.VAd.onClose(this.VClo);
                    });
                }.bind(this));
            } else {
                this.VAd.show().then(() => {
                    this.onH('');
                    this.VClo && this.VAd.offClose(this.VClo);
                    delete this.VClo;
                    this.VClo = this.onVClo.bind(this);
                    this.VAd.onClose(this.VClo);
                });
            }
            this.VAd.load();
        };
        ShowI(video = false) {
            if (!wx.createInterstitialAd || !this.Insertid)
                return;
            this.IAd && this.IAd.destroy();
            delete this.IAd;
            this.IAd = null;
            this.IAd = wx.createInterstitialAd({
                adUnitId: this.Insertid
            });
            this.IAd.load()
                .then(() => this.IAd.show()
                    .then(res => video && this.v_over(true))
                    .catch(e => this.Verr(e)))
                .catch(e => this.Verr(e));
            this.IAd.onError(() => {});
        }
        VibL() {
            wx.vibrateLong({});
        }
        VibS() {
            wx.vibrateShort({});
        }
        GetStor(key) {
            try {
                return wx.getStorageSync(key);
            } catch (error) {
                return "";
            }
        }
        SetStor(key, value) {
            wx.setStorage({
                key: key,
                data: value
            });
        }
        DelStor(key) {
            wx.removeStorage({
                key: key
            });
        }
        SupRec() {
            return this.GRec ? true : false;
        }
        IsRec() {
            return this.mIsRec;
        }
        RecL() {
            let nLength = this.mRecL;
            if (this.mIsRec)
                nLength += Date.now() - this.mRecStaT;
            return nLength;
        }
        StaRec(StopFun) {}
        StRec() {}
        RecordeEnd() {
            console.error('StopFun');
            this.StopF && this.StopF();
            delete this.StopF;
            this.StopF = null;
        }
        ShaRec() {
            if (!this.IsShaRecShare) {
                if (wx.shareAppMessage) {
                    wx.shareAppMessage({
                        title: "营救特工队",
                        imageUrl: this.ShareImageUrl,
                        success: () => {
                            this.vPath = null;
                            this.STips('分享成功!');
                        },
                        fail: (e) => {
                            console.error(`分享失败`, e);
                            this.Recend(false);
                        }
                    });
                    this.IsShaRecShare = true;
                }
            }
        }
        ShowShaRec() {
            if (this.IsShaRecShare) {
                super.ShaRec();
                this.IsShaRecShare = false;
            }
        }
        Exit() {
            wx.exitMiniProgram({});
        }
        loadSub() {
            if (wx.loadSubpackage) {
                wx.loadSubpackage({
                    name: 'Resources',
                    success: (resa) => {
                        wx.loadSubpackage({
                            name: 'subpkg',
                            success: (res) => {
                                super.loadSub();
                            }
                        });
                    }
                }).onProgressUpdate(msg => this.SubPro && this.SubPro(Math.floor(msg.progress)));
            } else {
                super.loadSub();
            }
        }
    }

    class Game4399 extends SDKB {
        SupShe() {
            return false;
        }
        ShowVAd() {
            this.VClo && this.VClo();
            delete this.VClo;
            this.VClo = this.onVClo.bind(this);
            this.VClo();
        }
    }

    var Ins = null;

    function SDK() {
        if (!Ins)
            init();
        return Ins;
    }

    function init() {
        if (Ins)
            return;
        switch (BSet.PfSDK) {
            case SDKType.TT:
                Ins = new TT();
                console.log("ToutiaoSDK...");
                break;
            case SDKType.OPPO:
                Ins = new OPPO();
                console.log("OPPOSDK...");
                break;
            case SDKType.WX:
                Ins = new WeChat();
                console.log("WeChatSDK...");
                break;
            case SDKType.Game4399:
                Ins = new Game4399();
                console.log("Game4399SDK...");
                break;
            default:
                Ins = new Dummy();
                console.log("DummySDK....");
                break;
        }
    }

    class StrSet {}
    class GStor {
        static Save() {
            GStor.Dit = false;
            GStor.CkDaRef();
            var data = {
                FDt: GStor.FDt,
                V: BSet.V,
                DReDt: GStor.DReDt
            };
            var n = GStor.StrSet.length;
            for (var nIndex = 0; nIndex < n; nIndex++) {
                var Set = GStor.StrSet[nIndex];
                data[Set.Name] = Set.ClsT[Set.Name];
            }
            SDK().SetStor(GStor.kName, JSON.stringify(data));
        }
        static Load() {
            var Text = SDK().GetStor(GStor.kName);
            let Obj;
            try {
                Obj = JSON.parse(Text);
                if (!Obj) {
                    GStor.DefV(false);
                    return;
                }
            } catch (error) {
                GStor.DefV(false);
                return;
            }
            if (Obj["V"] != BSet.V) {
                SDK().DelStor(GStor.kName);
                GStor.DefV(false);
                GStor.Save();
                return;
            }
            var n = GStor.StrSet.length;
            for (var nIndex = 0; nIndex < n; nIndex++) {
                var Set = GStor.StrSet[nIndex];
                if (Obj[Set.Name] == null) {
                    if (null != Set.V)
                        Set.ClsT["$" + Set.Name] = Set.V;
                    continue;
                }
                Set.ClsT["$" + Set.Name] = Obj[Set.Name];
            }
            GStor.FDt = Obj["FDt"];
            GStor.DReDt = Obj["DReDt"];
        }
        static Updt() {
            if (GStor.Dit) {
                GStor.Save();
            }
        }
        static DefPro(StrSet) {
            Object.defineProperty(StrSet.ClsT, StrSet.Name, {
                set: function(v) {
                    GStor.PrCagPre();
                    StrSet.ClsT["$" + StrSet.Name] = v;
                    GStor.PrCag();
                },
                get: function() {
                    GStor.PrRe();
                    return StrSet.ClsT["$" + StrSet.Name];
                }
            });
        }
        static PrCag() {
            GStor.Dit = true;
        }
        static PrCagPre() {
            if (!GStor.Init) {
                GStor.Load();
                GStor.Init = true;
            }
            GStor.CkDaRef();
        }
        static PrRe() {
            if (!GStor.Init) {
                GStor.Init = true;
                GStor.Load();
            }
            GStor.CkDaRef();
        }
        static DefV(Ref) {
            var n = GStor.StrSet.length;
            for (var nIndex = 0; nIndex < n; nIndex++) {
                var Set = GStor.StrSet[nIndex];
                if (Ref && !Set.Ref)
                    continue;
                if (null != Set.V) {
                    if (typeof Set.V === "function")
                        Set.ClsT["$" + Set.Name] = Set.V();
                    else
                        Set.ClsT["$" + Set.Name] = Set.V;
                }
            }
            GStor.DReDt = Date.now();
            GStor.Dit = true;
        }
        static CkDaRef() {
            if (!GStor.FDt) {
                GStor.FDt = Date.now();
                GStor.DReDt = Date.now();
            }
            var lostDay = (Date.now() - GStor.DReDt) / 1000 / 60 / 60 / 24;
            if (lostDay >= 1) {
                GStor.DefV(true);
                GStor.PrCag();
            }
        }
    }
    GStor.StrSet = [];
    GStor.Dit = false;
    GStor.Init = false;
    GStor.kName = "GameSave_" + BSet.kName;

    function GS(V, Ref) {
        return function(trg, Name) {
            var StoSet = {
                ClsT: trg,
                Name: Name,
                V: V,
                Ref: Ref
            };
            GStor.StrSet.push(StoSet);
            GStor.DefPro(StoSet);
        };
    }

    class LoadingUI extends ui.LoadingUI {
        constructor() {
            super();
            this.Loadlab = '游戏加载中';
            this.visible = false;
            Laya.stage.addChild(this);
        }
        static get UI() {
            if (!LoadingUI._UI)
                LoadingUI._UI = new LoadingUI();
            return LoadingUI._UI;
        }
        static LoaderClear(res) {
            for (let i = 0; i < res.length; i++)
                Laya.loader.clearRes(res[i]);
        }
        static LoaderCreate(url) {
            return __awaiter(this, void 0, void 0, function*() {
                let data = Laya.loader.getRes(url);
                if (data)
                    return Promise.resolve(data);
                else
                    return new Promise((resolve) => {
                        Laya.loader.create(url, Laya.Handler.create(this, res => {
                            if (res)
                                resolve(res);
                            else {
                                console.error("create 加载资源失败", url);
                                Laya.loader.load(url, Laya.Handler.create(this, res => {
                                    if (res)
                                        resolve(res);
                                    else {
                                        console.error("load 加载资源失败", url);
                                        resolve(null);
                                    }
                                }));
                            }
                        }));
                    });
            });
        }
        static Load(resList) {
            return __awaiter(this, void 0, void 0, function*() {
                if (!resList || resList.length == 0)
                    return Promise.resolve(true);
                LoadingUI.UI.jd.width = 1;
                return new Promise((resolve) => Laya.loader.create(resList, Laya.Handler.create(this, (end) => resolve(end)), Laya.Handler.create(this, this.onProgress)));
            });
        }
        static onProgress(progress) {
            LoadingUI.UI.jd.width = Math.round(progress * LoadingUI.UI.LoadingBox.width);
            LoadingUI.UI.txtjd.text = LoadingUI.UI.Loadlab + ` ${Math.round(progress * 100)}%`;
        }
        static Show() {
            if (LoadingUI.UI.visible)
                return;
            LoadingUI.UI.visible = true;
            LoadingUI.UI.zOrder = 6666;
        }
        static Hide() {
            setTimeout(() => {
                Laya.timer.clearAll(this);
                LoadingUI.UI.visible = false;
            }, 200);
        }
    }
    LoadingUI.Loaderr = false;

    class Guninfo {
        constructor() {
            this.lock = false;
        }
    }
    class GInfo {
        static CagVib() {
            this.Vib = !this.Vib;
        }
        static get LevelIdUI() {
            return GInfo._LevelIdUI;
        }
        static set LevelIdUI(v) {
            GInfo._LevelIdUI = v;
        }
        static get LevelId() {
            if (GInfo._LevelId) {
                return GInfo._LevelId;
            } else {
                return 1;
            }
        }
        static set LevelId(v) {
            GInfo._LevelId = v;
        }
        static addGold(n) {
            GInfo.Gold += n;
            if (GInfo.Gold <= 0)
                GInfo.Gold = 0;
            GEvent.Ins.event(GEvent.reTop);
        }
        static GetGun(Id) {
            return GInfo.GunList[Id];
        }
        static GetNoUnlockGun() {
            let IdList = [];
            for (let i = 0; i < WeaponConfig.WeaponTable.length; i++) {
                const ele = WeaponConfig.WeaponTable[i];
                let Gun = GInfo.GunList[ele.Id];
                if (!Gun) {
                    IdList.push(ele.Id);
                    GInfo.GunList[ele.Id] = {
                        lock: false,
                        Num: 0,
                        goldskin: 0
                    };
                } else if (!Gun.lock)
                    IdList.push(ele.Id);
            }
            if (IdList.length > 0) {
                IdList.sort(() => {
                    return Math.random() - 0.5;
                });
                return IdList[0];
            }
            return null;
        }
    }
    GInfo.MAXBlueRole = 21;
    GInfo.trialGunId = null;
    GInfo.suptrialGunId = 3005;
    GInfo.suptrial = false;
    __decorate([
        GS(true)
    ], GInfo, "Vib", void 0);
    __decorate([
        GS(1)
    ], GInfo, "_LevelIdUI", void 0);
    __decorate([
        GS(1)
    ], GInfo, "_LevelId", void 0);
    __decorate([
        GS(1000)
    ], GInfo, "Gold", void 0);
    __decorate([
        GS(0)
    ], GInfo, "Commission", void 0);
    __decorate([
        GS(5)
    ], GInfo, "BlueRole", void 0);
    __decorate([
        GS(1001)
    ], GInfo, "GunId", void 0);
    __decorate([
        GS({
            1001: {
                lock: true,
                Num: 0,
                goldskin: 0
            }
        })
    ], GInfo, "GunList", void 0);

    class GameSound {
        constructor() {}
        static PlaySound(name, loop = false) {
            SDK().plS(GameSound.getUrl(name), loop ? 0 : 1);
        }
        static PlayMusic() {
            SDK().playM(GameSound.Music);
        }
        static StopMusic() {
            SDK().StM();
        }
        static StopSound(name) {
            SDK().StS(GameSound.getUrl(name));
        }
        static VibrateShort() {
            GInfo.Vib && SDK().VibS();
        }
        static VibrateLong() {
            GInfo.Vib && SDK().VibL();
        }
        static getUrl(name) {
            let Cfg = GameSound.SoundTable[name];
            let Url = `subpkg/sounds/${Cfg ? Cfg : name}.mp3`;
            return Url;
        }
    }
    GameSound.Music = "bgm";
    GameSound.SoundTable = {
        bgm: "bgm",
        boom: "boom",
        bullet: "bullet",
        fail: "fail",
        win: "win"
    };

    class LevelCfg {}
    class LevelConfig {
        static getCfg(id) {
            for (let index = 0; index < this.Table.length; index++) {
                if (this.Table[index].Id == id) {
                    return this.Table[index];
                }
            }
            console.error(`在${this.name}配置表中 未找到Id:${id}的配置`);
            return null;
        }
        static getMaxLevel() {
            return this.Table.length;
        }
    }
    LevelConfig.Table = [{
            Id: 1,
            Fog: [0.4, 0.7, 1]
        },
        {
            Id: 2,
            Fog: [0.4, 0.7, 1]
        },
        {
            Id: 3,
            Fog: [0.4, 0.7, 1]
        },
        {
            Id: 4,
            Fog: [0.4, 0.7, 1]
        },
        {
            Id: 5,
            Fog: [0.4, 0.7, 1]
        },
        {
            Id: 6,
            Fog: [0.5, 1, 0.5]
        },
        {
            Id: 7,
            Fog: [0.5, 1, 0.5]
        },
        {
            Id: 8,
            Fog: [0.5, 1, 0.5]
        },
        {
            Id: 9,
            Fog: [0.5, 1, 0.5]
        },
        {
            Id: 10,
            Fog: [0.5, 1, 0.5]
        },
        {
            Id: 11,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 12,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 13,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 14,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 15,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 16,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 17,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 18,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 19,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 20,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 21,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 22,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 23,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 24,
            Fog: [0.7, 0.3, 1]
        },
        {
            Id: 25,
            Fog: [0.7, 0.3, 1]
        },
    ];

    class GetGun extends ui.GetGunUI {
        constructor(Id, Cal) {
            super();
            this.zOrder = 10;
            this.visible = true;
            Laya.stage.addChild(this);
            GInfo.GunId = Id;
            GInfo.trialGunId = Id;
            this.gun.skin = `subpkg/gun/${Id}.png`;
            this.Back.on(Laya.Event.CLICK, this, () => {
                this.destroy();
                Cal && Cal();
            });
        }
    }

    function GetNum(Num) {
        if (Num === 1)
            return "一";
        else if (Num === 2)
            return "二";
        else if (Num === 3)
            return "三";
        else if (Num === 4)
            return "四";
        else if (Num === 5)
            return "五";
        else if (Num === 6)
            return "六";
        else if (Num === 7)
            return "七";
        else if (Num === 8)
            return "八";
        else if (Num === 9)
            return "九";
        else if (Num === 10)
            return "十";
    }

    class GetGunShare extends ui.GetGunShareUI {
        constructor(Id, Cal) {
            super();
            this.zOrder = 10;
            this.visible = true;
            Laya.stage.addChild(this);
            this.Id = Id;
            this.Gun = GInfo.GunList[this.Id];
            this.data = WeaponConfig.GetWeaponCfg(this.Id);
            this.initUi();
            this.Share.on(Laya.Event.CLICK, this, () => {
                SDK().RecEv(end => {
                    if (end) {
                        if (++this.Gun.Num >= this.data.Num) {
                            GInfo.GunList[Id].lock = true;
                            this.destroy();
                            new GetGun(Id, Cal);
                        } else {
                            this.initUi();
                            GInfo.addGold(150);
                            GInfo.trialGunId = Id;
                            if (Cal) {
                                this.destroy();
                                Cal();
                            }
                        }
                    }
                });
                SDK().ShaRec();
            });
            this.Back.on(Laya.Event.CLICK, this, () => {
                this.destroy();
                Cal && Cal();
            });
        }
        initUi() {
            this.jd.text = `(${this.Gun.Num}/${this.data.Num})`;
            if (this.Gun.Num == 1) {
                this.get1.visible = true;
            } else if (this.Gun.Num == 2) {
                this.get1.visible = true;
                this.get2.visible = true;
            } else if (this.Gun.Num == 3) {
                this.get1.visible = true;
                this.get2.visible = true;
                this.get3.visible = true;
            } else {
                this.get1.visible = false;
                this.get2.visible = false;
                this.get3.visible = false;
            }
            this.gun.skin = `subpkg/gun/${this.Id}.png`;
        }
    }

    class GetGunVideo extends ui.GetGunVideoUI {
        constructor(Id, Cal) {
            super();
            this.zOrder = 10;
            this.visible = true;
            Laya.stage.addChild(this);
            this.Id = Id;
            this.Gun = GInfo.GunList[this.Id];
            this.data = WeaponConfig.GetWeaponCfg(this.Id);
            this.initUi();
            this.Video.on(Laya.Event.CLICK, this, () => {
                SDK().ShowV(end => {
                    if (end) {
                        if (++this.Gun.Num >= this.data.Num) {
                            GInfo.GunList[Id].lock = true;
                            this.destroy();
                            new GetGun(Id, Cal);
                        } else {
                            this.initUi();
                            GInfo.addGold(150);
                            GInfo.trialGunId = Id;
                            if (Cal) {
                                this.destroy();
                                Cal();
                            }
                        }
                    }
                },"1001");
            });
            this.Back.on(Laya.Event.CLICK, this, () => {
                this.destroy();
                Cal && Cal();
            });
        }
        initUi() {
            this.jd.text = `(${this.Gun.Num}/${this.data.Num})`;
            this.gun.skin = `subpkg/gun/${this.Id}.png`;
        }
    }

    class TrailModelRotate extends Laya.Script3D {
        constructor() {
            super();
            this.Mmodel = null;
        }
        onStart() {
            this.Mmodel = this.owner;
        }
        onUpdate() {
            if (this.Mmodel) {
                this.Mmodel.transform.localRotationEulerY += 0.1 * Laya.timer.delta;
                this.Mmodel.transform.localRotationEulerY = this.Mmodel.transform.localRotationEulerY;
            }
        }
    }

    class Player3DShow {
        constructor() {
            this.SceneM = null;
            this.PlayerModel = null;
        }
        InitScene3D(Par, WeaponSkinId) {
            if (this.SceneM) {
                this.onUninit();
            }
            this.SceneM = new Laya.Scene3D();
            Par.addChild(this.SceneM);
            this.Camera = new Laya.Camera(0, 0.05, 100);
            this.SceneM.addChild(this.Camera);
            this.Camera.transform.translate(new Laya.Vector3(0, 0, 2));
            this.Camera.transform.rotate(new Laya.Vector3(0, 0, 0), false, false);
            this.Camera.orthographic = true;
            this.Camera.orthographicVerticalSize = 10;
            this.Camera.clearFlag = Laya.CameraClearFlags.DepthOnly;
            let direclight = new Laya.DirectionLight();
            this.SceneM.addChild(direclight);
            direclight.color = new Laya.Vector3(1, 1, 1);
            this.CreatPlayer(WeaponSkinId);
        }
        CreatPlayer(skinid) {
            return __awaiter(this, void 0, void 0, function*() {
                if (skinid == -1) {
                    skinid = 1;
                }
                let skindata = WeaponConfig.GetWeaponCfg(skinid);
                if (!skindata) {
                    return;
                }
                this.PlayerModelUrl && Laya.loader.clearRes(this.PlayerModelUrl);
                let Gun = GInfo.GetGun(skinid);
                if (Gun.lock && Gun.goldskin === true)
                    this.PlayerModelUrl = skindata.hModel;
                else
                    this.PlayerModelUrl = skindata.Model;
                if (this.PlayerModel) {
                    this.PlayerModel.removeSelf();
                    this.PlayerModel.destroy();
                    this.PlayerModel = null;
                }
                let res = yield LoadingUI.LoaderCreate(GetSpPath(this.PlayerModelUrl));
                if (!res) {
                    console.error('加载资源失败', this.PlayerModelUrl);
                    return;
                }
                this.PlayerModel = res.clone();
                let ccc = new Laya.MeshSprite3D();
                this.SceneM.addChild(ccc);
                let ddd = new Laya.MeshSprite3D();
                ccc.addChild(ddd);
                ddd.transform.localRotationEulerX = 40;
                ccc.transform.position = new Laya.Vector3(0, 3, 0);
                this.PlayerModel.transform.localScale = new Laya.Vector3(0.25, 0.25, 0.25);
                ddd.addChild(this.PlayerModel);
                this.PlayerModel.transform.localPosition = new Laya.Vector3(0, 0, skindata.Offset);
                let TrailmodelSpt = new TrailModelRotate();
                ccc.addComponentIntance(TrailmodelSpt);
            });
        }
        findPoint(parent, name) {
            let n = parent.numChildren;
            if (n == 0)
                return;
            for (let i = 0; i < n; i++) {
                let node = parent.getChildAt(i);
                if (node) {
                    if (node.name == name) {
                        return node;
                    } else {
                        let sonNode = this.findPoint(node, name);
                        if (sonNode) {
                            return sonNode;
                        }
                    }
                }
            }
            return null;
        }
        onUninit() {
            this.Camera = null;
            this.SceneM.removeSelf();
            this.SceneM.destroy();
            this.SceneM = null;
        }
    }

    class Vec3Ext {
        static Add(left, right) {
            var result = new Laya.Vector3();
            Laya.Vector3.add(left, right, result);
            return result;
        }
        static Sub(left, right) {
            var result = new Laya.Vector3();
            Laya.Vector3.subtract(left, right, result);
            return result;
        }
        static MulValue(left, right) {
            return new Laya.Vector3(left.x * right, left.y * right, left.z * right);
        }
        static Scale(a, b) {
            let result = new Laya.Vector3();
            Laya.Vector3.scale(a, b, result);
            return result;
        }
        static Mul(left, right) {
            var result = new Laya.Vector3();
            Laya.Vector3.multiply(left, right, result);
            return result;
        }
        static DivValue(left, right) {
            return new Laya.Vector3(left.x / right, left.y / right, left.z / right);
        }
        static Distance(left, right) {
            return Laya.Vector3.distance(left, right);
        }
        static DistanceSquared(left, right) {
            return Laya.Vector3.distanceSquared(left, right);
        }
        static ScalarLength(v) {
            return Laya.Vector3.scalarLength(v);
        }
        static ScalarLengthSqrt(v) {
            return Laya.Vector3.scalarLengthSquared(v);
        }
        static Reversal(vec) {
            return new Laya.Vector3(-vec.x, -vec.y, -vec.z);
        }
        static Cross(left, right) {
            var result = new Laya.Vector3();
            Laya.Vector3.cross(left, right, result);
            return result;
        }
        static Dot(left, right) {
            return Laya.Vector3.dot(left, right);
        }
        static Normalize(v) {
            var result = new Laya.Vector3();
            Laya.Vector3.normalize(v, result);
            return result;
        }
        static ScaleValue(v, scaleValue) {
            var result = new Laya.Vector3();
            Laya.Vector3.scale(v, scaleValue, result);
            return result;
        }
        static Equal(left, right) {
            return left.x == right.x && left.y == right.y && left.z == right.z;
        }
        static GreaterThan(left, right) {
            return left.x > right.x && left.y > right.y && left.z > right.z;
        }
        static GreaterThanOrEqual(left, right) {
            return left.x >= right.x && left.y >= right.y && left.z >= right.z;
        }
        static LessThan(left, right) {
            return left.x < right.x && left.y < right.y && left.z < right.z;
        }
        static LessThanOrEqual(left, right) {
            return left.x <= right.x && left.y <= right.y && left.z <= right.z;
        }
        static Rotate(out, radian, axle = 1) {
            if (axle == 1) {
                let x = out.x * Math.cos(radian) - out.z * Math.sin(radian);
                let z = out.x * Math.sin(radian) + out.z * Math.cos(radian);
                out.x = x;
                out.z = z;
            } else {}
        }
        static randomRotate(out, radian) {}
    }

    class ObjectPoolManager {
        constructor() {
            this.nameToUrl = {};
        }
        static get Instance() {
            if (!this.instance) {
                this.instance = new ObjectPoolManager();
            }
            return this.instance;
        }
        getPool(rPoolName) {
            return this.nameToUrl[rPoolName];
        }
        cloneSprite(rSpriteUrl) {
            let sprite = Laya.loader.getRes(rSpriteUrl);
            if (!sprite) {
                console.error("对象池：获取Sprite3D资源失败，需要先加载Sprite3D资源。。。", rSpriteUrl);
                return null;
            }
            return sprite.clone();
        }
        getItem(poolName) {
            let rUrl = this.getPool(poolName);
            if (!rUrl) {
                let rUrl = "Resources/Conventional/" + poolName + ".lh";
                let obj = Laya.Pool.getItemByCreateFun(poolName, () => {
                    return this.cloneSprite(rUrl);
                }, this);
                if (!obj) {
                    console.warn("对象池：获取失败", poolName);
                    return null;
                } else {
                    this.nameToUrl[poolName] = rUrl;
                    return obj;
                }
            }
            return Laya.Pool.getItemByCreateFun(poolName, () => {
                return this.cloneSprite(rUrl);
            }, this);
        }
        recover(poolName, model) {
            if (!model) {
                console.warn("对象池：回收需要有物体 ", poolName);
                return;
            }
            if (model.destroyed) {
                console.warn("对象池：已经destroy的物体不能回收 ", poolName);
                return;
            }
            model.removeSelf();
            Laya.Pool.recover(poolName, model);
        }
        clearAllPool() {
            for (const key in this.nameToUrl) {
                Laya.Pool.clearBySign(key);
            }
            this.nameToUrl = {};
        }
        createEffect(poolName, parent, localPosition, localRotation, recoverTime, delayTime) {
            if (!parent || !localPosition || !localRotation)
                return;
            if (delayTime && delayTime > 0) {
                Laya.timer.once(delayTime, this, this._createEffect, [poolName, parent, localPosition, localRotation, recoverTime], false);
            } else {
                this._createEffect(poolName, parent, localPosition, localRotation, recoverTime);
            }
        }
        _createEffect(poolName, parent, localPosition, localRotation, recoverTime) {
            let effect = ObjectPoolManager.Instance.getItem(poolName);
            parent.addChild(effect);
            effect.name = poolName;
            effect.transform.localPosition = localPosition;
            effect.transform.localRotation = localRotation;
            Laya.timer.once(recoverTime, null, () => {
                if (effect && !effect.destroyed) {
                    effect.removeSelf();
                    ObjectPoolManager.Instance.recover(poolName, effect);
                }
            });
        }
    }

    class CollisionConfig {}
    CollisionConfig.kDefaultGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER;
    CollisionConfig.kGroundGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER1;
    CollisionConfig.kBuildingGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER9;
    CollisionConfig.kBarrierGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3;
    CollisionConfig.kCameraState = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER4;
    CollisionConfig.kMonsterGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER5;
    CollisionConfig.kAreaGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER6;
    CollisionConfig.kPlayerGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER10;

    class MathExt {
        static RandomInt(min, max) {
            return Math.floor(this.RandomNum(min, max));
        }
        static RandomNum(min, max) {
            return Math.random() * (max - min) + min;
        }
    }

    class TweenExt {
        constructor() {
            this.mState = 0;
        }
        static PWXTo(model, pos, isAlong, midpointOffsetHeight, time, complete) {
            let tween = new TweenExt();
            tween.startMove(model, pos, null, time, null, isAlong, midpointOffsetHeight, 2);
            return tween;
        }
        static ZXTo(model, pos, rot, time, ease, complete) {
            let tween = new TweenExt();
            tween.startMove(model, pos, rot, time, ease, null, null, 1, complete);
            return tween;
        }
        startMove(model, pos, rot, time, ease, isAlong, midpointOffsetHeight, transType, complete) {
            this.mModel = model;
            this.mComplete = complete;
            if (pos && !Vec3Ext.Equal(this.mModel.transform.position, pos)) {
                this.mStartPos = this.mModel.transform.position.clone();
                this.mTargetPos = pos.clone();
                this.mTempVec3 = new Laya.Vector3();
            }
            this.mMoveTime = time;
            this.mStartTimer = Laya.timer.currTimer - 10;
            this.mState = 1;
            if (transType == 1) {
                if (rot && !this.Equal(this.mModel.transform.rotation, rot)) {
                    this.mStartRot = this.mModel.transform.rotation.clone();
                    this.mTargetRot = rot.clone();
                    this.mTempQuat = new Laya.Quaternion();
                }
                this.mEaseFun = ease;
                this.onZLUpdate();
                Laya.timer.frameLoop(1, this, this.onZLUpdate);
            } else if (transType == 2) {
                this.mMidpointOffset = midpointOffsetHeight;
                this.mAlong = isAlong;
                this.onPWXUpdate();
                Laya.timer.frameLoop(1, this, this.onPWXUpdate);
            }
        }
        Equal(left, right) {
            return left.w == right.w && left.x == right.x && left.y == right.y && left.z == left.z;
        }
        onPWXUpdate() {
            if (this.mModel && !this.mModel.destroyed) {
                let t = Laya.timer.currTimer - this.mStartTimer;
                let ratio = t / this.mMoveTime;
                if (ratio >= 1) {
                    ratio = 1;
                    this.mState = -1;
                }
                Laya.Vector3.lerp(this.mStartPos, this.mTargetPos, ratio, this.mTempVec3);
                if (this.mMidpointOffset != 0) {
                    if (ratio < 0.5) {
                        this.mTempVec3.y += Laya.Ease.sineOut(ratio * 2, 0, this.mMidpointOffset, 1);
                    } else {
                        this.mTempVec3.y += Laya.Ease.sineOut((1 - ratio) * 2, 0, this.mMidpointOffset, 1);
                    }
                }
                if (this.mAlong && ratio < 1) {
                    let q = new Laya.Quaternion();
                    let m = this.mModel.transform.position.clone();
                    let t = this.mTempVec3.clone();
                    let f = new Laya.Vector3();
                    Laya.Vector3.subtract(t, m, f);
                    let u = new Laya.Vector3(0, 1, 0);
                    let r = new Laya.Vector3();
                    Laya.Vector3.cross(f, u, r);
                    Laya.Vector3.cross(r, f, u);
                    Laya.Vector3.normalize(f, f);
                    Laya.Vector3.normalize(u, u);
                    f.z = -f.z;
                    u.z = -u.z;
                    Laya.Quaternion.rotationLookAt(f, u, q);
                    let temp = q.x;
                    q.x = -q.z;
                    q.z = -temp;
                    temp = q.y;
                    q.y = -q.w;
                    q.w = temp;
                    this.mModel.transform.rotation = q;
                }
                this.mModel.transform.position = this.mTempVec3;
            } else {
                this.mState = -1;
            }
            if (this.mState == -1) {
                this.onUninit();
            }
        }
        onZLUpdate() {
            if (this.mModel && !this.mModel.destroyed) {
                let t = Laya.timer.currTimer - this.mStartTimer;
                if (t > this.mMoveTime) {
                    t = this.mMoveTime;
                    this.mState = -1;
                }
                let ratio = this.mEaseFun(t, 0, 1, this.mMoveTime);
                if (this.mTargetPos) {
                    Laya.Vector3.lerp(this.mStartPos, this.mTargetPos, ratio, this.mTempVec3);
                    this.mModel.transform.position = this.mTempVec3;
                }
                if (this.mTargetRot) {
                    Laya.Quaternion.lerp(this.mStartRot, this.mTargetRot, ratio, this.mTempQuat);
                    this.mModel.transform.rotation = this.mTempQuat;
                }
            } else {
                this.mState = -1;
            }
            if (this.mState == -1) {
                if (this.mComplete) {
                    this.mComplete();
                }
                this.onUninit();
            }
        }
        onUninit() {
            this.mState = 0;
            Laya.timer.clearAll(this);
            this.mModel = null;
            this.mStartPos = null;
            this.mStartRot = null;
            this.mTargetPos = null;
            this.mTargetRot = null;
            this.mEaseFun = null;
            this.mTempVec3 = null;
            this.mTempQuat = null;
        }
    }

    class DieTip extends ui.DieTipUI {
        constructor() {
            super();
            this.zOrder = 10;
            this.visible = true;
            Laya.stage.addChild(this);
            this.ani1.on(Laya.Event.COMPLETE, this, this.Hide);
        }
        Hide() {
            this.removeSelf();
            this.destroy();
        }
        static Show(x, y) {
            new DieTip().pos(x, y);
        }
    }

    class Emoji extends ui.EmojiUI {
        constructor() {
            super();
            this.zOrder = 10;
            this.visible = true;
            Laya.stage.addChild(this);
            this.img.skin = `subpkg/UI/${27 + Math.floor(Math.random() * 6)}.png`;
            this.ani1.on(Laya.Event.COMPLETE, this, this.Hide);
            this.ani2.on(Laya.Event.COMPLETE, this, this.Hide);
            if (Math.random() > 0.5)
                this.ani1.play(0, false);
            else
                this.ani2.play(0, false);
        }
        Hide() {
            this.removeSelf();
            this.destroy();
        }
        static Show(x, y) {
            new Emoji().pos(x, y);
            Double.UI.Show();
        }
    }

    class Sprite3DExt {
        static setSprite3DShodow(sprite3D, isCast, isReceive) {
            for (let i = 0; i < sprite3D.numChildren; i++) {
                const son = sprite3D.getChildAt(i);
                if (son.meshRenderer) {
                    son.meshRenderer.castShadow = isCast;
                    son.meshRenderer.receiveShadow = isReceive;
                }
                if (son.skinnedMeshRenderer) {
                    son.skinnedMeshRenderer.castShadow = isCast;
                    son.skinnedMeshRenderer.receiveShadow = isReceive;
                }
                Sprite3DExt.setSprite3DShodow(son, isCast, isReceive);
            }
        }
        static getCBN(p, name) {
            let n = p.numChildren;
            if (n == 0)
                return;
            for (let i = 0; i < n; i++) {
                let node = p.getChildAt(i);
                if (node) {
                    if (node.name == name) {
                        return node;
                    } else {
                        let sonNode = this.getCBN(node, name);
                        if (sonNode) {
                            return sonNode;
                        }
                    }
                }
            }
            return null;
        }
    }

    var EBarrierState;
    (function(EBarrierState) {
        EBarrierState[EBarrierState["None"] = 0] = "None";
        EBarrierState[EBarrierState["Activate"] = 1] = "Activate";
        EBarrierState[EBarrierState["Die"] = 2] = "Die";
        EBarrierState[EBarrierState["Uninit"] = 3] = "Uninit";
    })(EBarrierState || (EBarrierState = {}));
    var EBarrierCollisionAction;
    (function(EBarrierCollisionAction) {
        EBarrierCollisionAction[EBarrierCollisionAction["None"] = 0] = "None";
        EBarrierCollisionAction[EBarrierCollisionAction["Pass"] = 1] = "Pass";
        EBarrierCollisionAction[EBarrierCollisionAction["Drop"] = 2] = "Drop";
        EBarrierCollisionAction[EBarrierCollisionAction["Die"] = 3] = "Die";
        EBarrierCollisionAction[EBarrierCollisionAction["TeamStop"] = 4] = "TeamStop";
    })(EBarrierCollisionAction || (EBarrierCollisionAction = {}));
    class BarrierScript extends Laya.Script3D {
        GetTriggerAction(player) {
            if (this.onTriggerRole) {
                return this.onTriggerRole(player, this);
            }
            return EBarrierCollisionAction.None;
        }
        Hit() {
            if (this.onHit)
                this.onHit();
        }
        onCollisionEnter(c) {
            if (this.onCollisonBuilding && c.other.owner.layer == 9) {
                this.onCollisonBuilding(c, this);
            }
        }
        onDestroy() {
            this.onTriggerRole = null;
            this.onCollisonBuilding = null;
            this.onHit = null;
        }
    }
    class BarrierBase {
        constructor(mgr, cfg, sprite) {
            this.mState = EBarrierState.None;
            this.mBarMgr = mgr;
            this.mCfg = cfg;
            this.mSprite = sprite;
        }
        onInit() {}
        onUpdate() {}
        Uninit() {
            this.mState = EBarrierState.Uninit;
        }
        onUninit() {
            if (this.mSprite) {
                this.mSprite.destroy();
                this.mSprite = null;
            }
            this.mCfg = null;
            this.mBarMgr = null;
        }
        Hit() {}
        setPart(partName, onHit, onRoleTrigger) {
            let part = this.mSprite.getChildByName(partName);
            if (!part) {
                console.error(this.mSprite);
                console.error(partName);
            }
            let collider = part.getComponent(Laya.PhysicsCollider);
            collider.collisionGroup = CollisionConfig.kBarrierGroup;
            let script = part.addComponent(BarrierScript);
            if (onHit) {
                script.onHit = onHit.bind(this);
            }
            if (onRoleTrigger) {
                script.onTriggerRole = onRoleTrigger.bind(this);
            }
            return part;
        }
        playAni(partName, clip) {
            let part = this.mSprite.getChildByName(partName);
            if (!part) {
                console.error(this.mSprite);
                console.error(partName);
            }
            let animator = part.getComponent(Laya.Animator);
            if (animator) {
                if (animator.getControllerLayer().getAnimatorState(clip)) {
                    animator.play(clip);
                } else {
                    console.error(part);
                    console.error(clip);
                }
            } else {
                console.error(part);
            }
        }
        changeWhite(name) {
            let obj = Sprite3DExt.getCBN(this.mSprite, name);
            if (!obj) {
                console.error(this);
                console.error(name);
            }
            Laya.loader.create("Resources/Conventional/Assets/Material/baise.lmat", Laya.Handler.create(this, (res) => {
                if (obj) {
                    if (obj.meshRenderer) {
                        obj.meshRenderer.material = res.clone();
                    } else if (obj.skinnedMeshRenderer) {
                        obj.skinnedMeshRenderer.material = res.clone();
                    }
                }
            }));
        }
        get position() {
            return this.mSprite.transform.position;
        }
        get rotation() {
            return this.mSprite.transform.rotation;
        }
        get config() {
            return this.mCfg;
        }
    }

    var ECameraState;
    (function(ECameraState) {
        ECameraState[ECameraState["Follow"] = 0] = "Follow";
        ECameraState[ECameraState["Hover"] = 1] = "Hover";
        ECameraState[ECameraState["Move"] = 2] = "Move";
        ECameraState[ECameraState["Offset"] = 3] = "Offset";
        ECameraState[ECameraState["Observe"] = 4] = "Observe";
        ECameraState[ECameraState["End"] = 5] = "End";
        ECameraState[ECameraState["Fail"] = 6] = "Fail";
        ECameraState[ECameraState["Over"] = 7] = "Over";
    })(ECameraState || (ECameraState = {}));
    class CameraConfig {}
    CameraConfig.kFiledView = 60;
    CameraConfig.kObserveView = 40;

    class CameraExt {
        static viewportProject(camera, position, out) {
            let outPos;
            if (out)
                outPos = out;
            else
                outPos = new Laya.Vector4();
            if (camera) {
                camera.viewport.project(position, camera.projectionViewMatrix, outPos);
                outPos.x /= Laya.stage.clientScaleX;
                outPos.y /= Laya.stage.clientScaleY;
            } else {
                outPos.x = -500;
                outPos.y = -500;
            }
            return outPos;
        }
        static viewportPointToRay(camera, point, out) {
            let outRay;
            if (out)
                outRay = out;
            else
                outRay = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            let p = new Laya.Vector2(point.x * Laya.stage.clientScaleX, point.y * Laya.stage.clientScaleY);
            camera.viewportPointToRay(p, outRay);
            return outRay;
        }
    }

    class Aimpoint extends ui.AimpointUI {
        constructor() {
            super();
            this.zOrder = 10;
            this.visible = true;
            Laya.stage.addChild(this);
        }
        static get UI() {
            if (!Aimpoint._UI)
                Aimpoint._UI = new Aimpoint();
            return Aimpoint._UI;
        }
        Hide() {
            this.visible = false;
        }
        Show(x, y) {
            if (!this.visible)
                this.visible = true;
            this.img.visible = false;
            this.pos(x, y);
        }
        StartAttack() {
            this.ani1.play(0, false);
            this.img.visible = true;
        }
        StopAttack() {
            this.ani1.stop();
            this.img.visible = false;
        }
    }

    class WeaponEntity {
        constructor(rParent, rLevel) {
            this.mAttackDistancTime = 0;
            this.mAttackStartTime = 0;
            this.mForward = new Laya.Vector3();
            this.mRay = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
            this.mHitResult = new Laya.HitResult();
            this.mRayDistance = 200;
            this.AttackCount = 0;
            this.tempV3 = new Laya.Vector2();
            this.isMove = false;
            this.mMousePosition = new Laya.Vector2();
            this.mAimPoint = new Laya.Vector2(Laya.stage.width / 2, Laya.stage.height / 2);
            this.AimMoveSM = 1.3;
            this.WeaponRotateSM = 0.05;
            this.kUpVec3 = new Laya.Vector3(0, 1, 0);
            rParent.transform.localPosition.z = -1;
            this.mLevel = rLevel;
            if (GInfo.suptrial === true)
                this.GunId = GInfo.suptrialGunId;
            else if (GInfo.trialGunId != null)
                this.GunId = GInfo.trialGunId;
            else
                this.GunId = GInfo.GunId;
            this.mWeaConfig = WeaponConfig.GetWeaponCfg(this.GunId);
            if (GInfo.suptrial === true)
                this.mModel = LoadSp3D(this.mWeaConfig.hModel);
            else if (GInfo.GetGun(this.GunId).goldskin === true)
                this.mModel = LoadSp3D(this.mWeaConfig.hModel);
            else
                this.mModel = LoadSp3D(this.mWeaConfig.Model);
            let gun = Sprite3DExt.getCBN(this.mModel, "skinAni");
            this.mGunPoint = Sprite3DExt.getCBN(this.mModel, "EffectPoint");
            let rEffect = LoadSp3D(GameMain.EFireEffect);
            this.mGunPoint.addChild(rEffect);
            rEffect.transform.localMatrix = Laya.Matrix4x4.DEFAULT;
            rEffect.transform.localRotation = new Laya.Quaternion();
            setTimeout(() => {
                this.mGunPoint.active = false;
            }, 300);
            this.mAnimator = gun.getComponent(Laya.Animator);
            rParent.transform.localScale.setValue(0.5, 0.5, 0.5);
            rParent.addChild(this.mModel);
            this.mModel.transform.localMatrix = Laya.Matrix4x4.DEFAULT;
            Sprite3DExt.setSprite3DShodow(this.mModel, false, false);
            this.mAttackStartTime = 0;
            this.mAttackDistancTime = this.mWeaConfig.AtkDistanceTime;
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.OnMouseDown);
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.OnMouseMove);
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.OnMouseUp);
            Laya.stage.on(Laya.Event.MOUSE_OVER, this, this.OnMouseUp);
            Laya.stage.on(Laya.Event.MOUSE_OUT, this, this.OnMouseUp);
            Aimpoint.UI.Show(Laya.stage.width / 2, Laya.stage.height / 2);
        }
        OnUninit() {
            this.mGunPoint.destroyChildren();
            Aimpoint.UI.Hide();
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.OnMouseDown);
            Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.OnMouseMove);
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.OnMouseUp);
            Laya.stage.off(Laya.Event.MOUSE_OVER, this, this.OnMouseUp);
            Laya.stage.off(Laya.Event.MOUSE_OUT, this, this.OnMouseUp);
            this.mLevel = null;
            this.mAnimator = null;
            this.mWeaConfig = null;
            if (this.mModel) {
                this.mModel.removeSelf();
                this.mModel.destroy();
                this.mModel = null;
            }
        }
        OnPlayAnimation() {
            if (this.mAnimator) {
                this.mAnimator.speed = 10;
                this.mAnimator.play("qiang_putong_1_sheji", 0, 0);
            }
        }
        OnAttack() {
            if (this.mLevel.mLevelCamera.mCameraState >= ECameraState.Fail) {
                this.mGunPoint.active = false;
                return;
            }
            this.AttackCount++;
            this.mAttackStartTime = Laya.timer.currTimer;
            let rRayHitObj = this.RayCheckSpr3D();
            if (rRayHitObj) {
                GameSound.VibrateShort();
                Aimpoint.UI.StartAttack();
                CplayerManager.ins.AreaHurtRole(rRayHitObj.point, this.mWeaConfig.AtkRange, 1);
                let rObj = this.mHitResult.collider.owner;
                let rBarrier = rObj.getComponent(BarrierScript);
                if (rBarrier) {
                    Aimpoint.UI.StartAttack();
                    rBarrier.Hit();
                }
            }
            this.OnPlayAnimation();
        }
        RayCheckSpr3D() {
            let rRay = this.mRay;
            this.tempV3.setValue(this.mAimPoint.x + MathExt.RandomInt(-20, 20), this.mAimPoint.y + MathExt.RandomInt(-20, 20));
            CameraExt.viewportPointToRay(CameraEntity.mCamera, this.tempV3, rRay);
            this.mModel.scene.physicsSimulation.rayCast(rRay, this.mHitResult, this.mRayDistance, CollisionConfig.kDefaultGroup, CollisionConfig.kMonsterGroup | CollisionConfig.kPlayerGroup | CollisionConfig.kBuildingGroup | CollisionConfig.kBarrierGroup | CollisionConfig.kDefaultGroup);
            if (this.mHitResult.succeeded) {
                this.ShowAimpoint2(this.mAimPoint);
                ObjectPoolManager.Instance.createEffect("ef_huicheng", this.mModel.scene, this.mHitResult.point, new Laya.Quaternion(), 1000);
                return this.mHitResult;
            } else {
                let rPosition = new Laya.Vector3(rRay.origin.x, rRay.origin.y, rRay.origin.z);
                let rMoveDirection = new Laya.Vector3(rRay.direction.x * this.mRayDistance, rRay.direction.y * this.mRayDistance, rRay.direction.z * this.mRayDistance);
                Laya.Vector3.add(rPosition, rMoveDirection, rPosition);
                this.ShowAimpoint(rPosition);
                this.ShowAimpoint2(this.mAimPoint);
            }
            return null;
        }
        ShowAimpoint2(vec) {
            Aimpoint.UI.Show(vec.x, vec.y);
        }
        ShowAimpoint(vec) {
            let vec4 = new Laya.Vector4();
            CameraExt.viewportProject(CameraEntity.mCamera, vec, vec4);
            Aimpoint.UI.Show(vec4.x, vec4.y);
        }
        OnMouseDown(rEvent) {
            if (this.mLevel.mLevelCamera.mCameraState >= ECameraState.Fail) {
                return;
            }
            this.mMousePosition = new Laya.Vector2(rEvent.stageX, rEvent.stageY);
            this.mAttackStartTime = 0;
            this.isMove = true;
            this.mGunPoint.active = true;
        }
        OnMouseMove(rEvent) {
            if (!this.isMove) {
                return;
            }
            if (this.isMove) {
                var rNewPosition = new Laya.Vector2(rEvent.stageX, rEvent.stageY);
                var rOffset = new Laya.Vector2(rEvent.stageX - this.mMousePosition.x, rEvent.stageY - this.mMousePosition.y);
                this.mAimPoint.x += rOffset.x * this.AimMoveSM;
                this.mAimPoint.y += rOffset.y * this.AimMoveSM;
                if (this.mAimPoint.x < 0) {
                    this.mAimPoint.x = 0;
                } else if (this.mAimPoint.x > Laya.stage.width) {
                    this.mAimPoint.x = Laya.stage.width;
                }
                if (this.mAimPoint.y < 0) {
                    this.mAimPoint.y = 0;
                } else if (this.mAimPoint.y > Laya.stage.height) {
                    this.mAimPoint.y = Laya.stage.height;
                }
                Aimpoint.UI.Show(this.mAimPoint.x, this.mAimPoint.y);
                this.mMousePosition = rNewPosition;
                this.isMove = true;
            }
        }
        OnMouseUp(rEvent) {
            this.mAnimator.play("qiang_putong_1_idle", 0, 0);
            this.isMove = false;
            this.mGunPoint.active = false;
        }
        OnUpdate() {
            if (this.isMove) {
                if (Laya.timer.currTimer - this.mAttackStartTime >= this.mAttackDistancTime) {
                    this.OnAttack();
                }
            }
            this.mModel.transform.localRotationEulerX = (Laya.stage.height - this.mAimPoint.y) * this.WeaponRotateSM * CameraEntity.mCamera.fieldOfView / 60 - 30;
            this.mModel.transform.localRotationEulerY = (Laya.stage.width / 2 - this.mAimPoint.x) * this.WeaponRotateSM * CameraEntity.mCamera.fieldOfView / 60;
        }
    }

    class CmpCamera {
        constructor(rEntity) {
            this.mTempVec3 = new Laya.Vector3();
            this.mVector3Up = new Laya.Vector3(0, 1, 0);
            this.mCamEntity = rEntity;
        }
    }

    class CmpCamFollow extends CmpCamera {
        constructor(rEntity) {
            super(rEntity);
            this.OffsetPos = new Laya.Vector3();
            this.mPlayerPos = new Laya.Vector3();
            GEvent.Ins.on(GCamEvent.kFollow, this, this.OnFollow);
        }
        OnFollow() {
            Laya.Vector3.subtract(this.mMoveSpr3D.transform.position, this.GetTargetPos, this.OffsetPos);
            this.mCamEntity.mCameraState = ECameraState.Follow;
        }
        get GetTargetPos() {
            if (CplayerManager.ins.TargetCameraPos) {
                this.mPlayerPos = CplayerManager.ins.TargetCameraPos;
            }
            return this.mPlayerPos;
        }
        OnInit(rMSpr3D) {
            this.mMoveSpr3D = rMSpr3D;
            Laya.Vector3.subtract(this.mMoveSpr3D.transform.position, this.GetTargetPos, this.OffsetPos);
        }
        OnUpdate() {
            if (this.mCamEntity.mCameraState != ECameraState.Follow && this.mCamEntity.mCameraState != ECameraState.Observe) {
                return;
            }
            Laya.Vector3.add(this.GetTargetPos, this.OffsetPos, this.mTempVec3);
            Laya.Vector3.lerp(this.mMoveSpr3D.transform.position, this.mTempVec3, GameMain.Ins.delta * 0.5, this.mTempVec3);
            this.mMoveSpr3D.transform.position = this.mTempVec3;
        }
        OnUnint() {
            GEvent.Ins.off(GCamEvent.kFollow, this, this.OnFollow);
            this.mMoveSpr3D = null;
        }
    }

    var EBarrier;
    (function(EBarrier) {
        EBarrier[EBarrier["None"] = 0] = "None";
        EBarrier[EBarrier["Plank"] = 1] = "Plank";
        EBarrier[EBarrier["Bomb"] = 2] = "Bomb";
        EBarrier[EBarrier["Sphere"] = 3] = "Sphere";
        EBarrier[EBarrier["HangOil"] = 4] = "HangOil";
        EBarrier[EBarrier["Roller"] = 5] = "Roller";
        EBarrier[EBarrier["Stairs"] = 6] = "Stairs";
        EBarrier[EBarrier["Bridge"] = 7] = "Bridge";
    })(EBarrier || (EBarrier = {}));
    class BarrierCfg {}
    class BarrierConfig {
        static getCfg(id) {
            for (let index = 0; index < this.Table.length; index++) {
                if (this.Table[index].Id == id) {
                    return this.Table[index];
                }
            }
            console.error(`在${this.name}配置表中 未找到Id:${id}的配置`);
            return null;
        }
        static getCfgByMeshName(mesh) {
            for (let index = 0; index < this.Table.length; index++) {
                if (this.Table[index].Mesh == mesh) {
                    return this.Table[index];
                }
            }
            console.error(`在${this.name}配置表中 未找到Mesh:${mesh}的配置`);
            return null;
        }
    }
    BarrierConfig.Table = [{
            Id: 2,
            Type: EBarrier.Plank,
            Name: "Plank",
            Mesh: "peijian_2"
        },
        {
            Id: 3,
            Type: EBarrier.Bomb,
            Name: "Bomb",
            Mesh: "peijian_3"
        },
        {
            Id: 4,
            Type: EBarrier.HangOil,
            Name: "HangOil",
            Mesh: "peijian_4"
        },
        {
            Id: 5,
            Type: EBarrier.Sphere,
            Name: "Sphere",
            Mesh: "peijian_5"
        },
        {
            Id: 6,
            Type: EBarrier.Roller,
            Name: "Roller",
            Mesh: "peijian_6"
        },
        {
            Id: 7,
            Type: EBarrier.Stairs,
            Name: "Stairs",
            Mesh: "peijian_7"
        },
        {
            Id: 8,
            Type: EBarrier.Roller,
            Name: "Roller",
            Mesh: "peijian_8"
        },
        {
            Id: 9,
            Type: EBarrier.Bridge,
            Name: "Bridge",
            Mesh: "peijian_9"
        },
        {
            Id: 10,
            Type: EBarrier.Roller,
            Name: "Roller",
            Mesh: "peijian_10"
        },
    ];

    class BarrierBomb extends BarrierBase {
        onInit() {
            this.mMain = this.setPart("Main", this.Hit, null);
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            this.mState = EBarrierState.Die;
            ObjectPoolManager.Instance.createEffect("ef_zhayaotong", this.mMain.scene, this.mMain.transform.position, Laya.Quaternion.DEFAULT, 2000);
            CplayerManager.ins.AreaHurtRole(this.mSprite.transform.position, 7);
            this.mBarMgr.BombExplode(this.mSprite.transform.position, 6);
            this.mMain = null;
            this.Uninit();
        }
    }

    class BarrierBridge extends BarrierBase {
        onInit() {
            this.setPart("Rope", this.Hit, null);
            this.mMain = this.setPart("Main", this.Hit, null);
            this.mEnter = this.setPart("Enter", null, this.onRoleTriggerEnter);
        }
        onRoleTriggerEnter(player, bar) {
            if (this.mState == EBarrierState.Die) {
                return EBarrierCollisionAction.None;
            } else {
                this.stopRole = player;
                return EBarrierCollisionAction.TeamStop;
            }
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            this.playAni("Other", "Hit");
            this.mState = EBarrierState.Activate;
            this.mMain.active = false;
            Laya.timer.once(300, this, this.Die);
            this.changeWhite("banzi");
            this.changeWhite("shengzi");
        }
        Die() {
            this.mState = EBarrierState.Die;
            this.mEnter.active = false;
            if (this.stopRole) {
                CplayerManager.ins.TeamContinueMove();
                this.stopRole = null;
            }
        }
        onUninit() {
            Laya.timer.clearAll(this);
            this.mMain = null;
            this.mEnter = null;
            this.stopRole = null;
            super.onUninit();
        }
    }

    class BarrierHangOil extends BarrierBase {
        constructor() {
            super(...arguments);
            this.AtkRange = 12;
        }
        onInit() {
            let trigger = this.mSprite.getChildByName("Rope");
            let collider = trigger.getComponent(Laya.PhysicsCollider);
            collider.collisionGroup = CollisionConfig.kBarrierGroup;
            let script = trigger.addComponent(BarrierScript);
            script.onHit = this.Hit.bind(this);
            this.mMain = this.mSprite.getChildByName("Main");
            let collider1 = this.mMain.getComponent(Laya.PhysicsCollider);
            collider1.collisionGroup = CollisionConfig.kBarrierGroup;
            let script1 = this.mMain.addComponent(BarrierScript);
            script1.onHit = this.Die.bind(this);
            let bottom = this.mSprite.getChildByName("Main_Bottom");
            this.mMain_Bottom_Y = bottom.transform.position.y;
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            let animator = this.mSprite.getChildAt(0).getComponent(Laya.Animator);
            if (animator) {
                animator.play("Hit");
            } else {
                console.error("bug...没有动画");
            }
            this.Activate();
        }
        Activate() {
            this.mState = EBarrierState.Activate;
        }
        Die() {
            this.mState = EBarrierState.Die;
            ObjectPoolManager.Instance.createEffect("ef_zhayaotong", this.mMain.scene, this.mMain.transform.position, Laya.Quaternion.DEFAULT, 2000);
            this.mMain.active = false;
            CplayerManager.ins.AreaHurtRole(this.mMain.transform.position, this.AtkRange);
        }
        onUpdate() {
            if (this.mState == EBarrierState.Activate) {
                this.mMain.transform.localPositionY -= 20 * GameMain.Ins.delta;
                if (this.mMain.transform.position.y <= this.mMain_Bottom_Y) {
                    this.Die();
                }
            }
        }
        onUninit() {
            this.mMain = null;
            super.onUninit();
        }
    }

    class BarrierPlank extends BarrierBase {
        onInit() {
            this.mMain = this.setPart("Main", this.Hit, null);
            let collider = this.mMain.getComponent(Laya.PhysicsCollider);
            this.mMianCollder = collider;
            let colliderDie = this.setPart("Die", null, this.onRoleTriggerDie);
        }
        onRoleTriggerDie(player, bar) {
            return EBarrierCollisionAction.Drop;
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            this.mState = EBarrierState.Die;
            let animator = this.mSprite.getChildAt(0).getComponent(Laya.Animator);
            if (animator) {
                animator.play("Hit");
                Laya.timer.once(160, this, () => {
                    this.mSprite.getChildAt(0).destroy();
                });
            } else {
                console.error("bug...");
            }
            this.mMianCollder.enabled = false;
        }
        onUninit() {
            this.mMain = null;
            this.mMianCollder = null;
            super.onUninit();
        }
    }

    class BarrierRoller extends BarrierBase {
        constructor() {
            super(...arguments);
            this.mRigidbodys = [];
            this.mMains = [];
            this.AtkRange = 5;
        }
        onInit() {
            let rope = this.mSprite.getChildByName("Rope");
            let collider = rope.getComponent(Laya.PhysicsCollider);
            collider.collisionGroup = CollisionConfig.kBarrierGroup;
            let script = rope.addComponent(BarrierScript);
            script.onHit = this.Hit.bind(this);
            let plank = this.mSprite.getChildByName("Plank");
            let collider1 = plank.getComponent(Laya.PhysicsCollider);
            collider1.collisionGroup = CollisionConfig.kBarrierGroup;
            let script1 = plank.addComponent(BarrierScript);
            script1.onHit = this.Hit.bind(this);
            let parent = this.mSprite.getChildByName("Main");
            let length = parent.numChildren;
            for (let index = 0; index < length; index++) {
                const main = parent.getChildAt(index);
                this.mMains.push(main);
                let rigidbody = main.getComponent(Laya.Rigidbody3D);
                rigidbody.collisionGroup = CollisionConfig.kBarrierGroup;
                this.mRigidbodys.push(rigidbody);
                let script1 = main.addComponent(BarrierScript);
                script1.onTriggerRole = this.onTriggerRole.bind(this);
                script1.onCollisonBuilding = this.CollisonBuilding.bind(this);
                script1.onHit = this.Hit.bind(this);
            }
            this.mMainParent = parent;
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            let animator = this.mSprite.getChildAt(0).getComponent(Laya.Animator);
            if (animator) {
                animator.play("Hit");
            } else {
                console.error("bug...");
            }
            this.Activate();
        }
        CollisonBuilding(c, barrierScr) {
            let mesh = barrierScr.owner;
            if (mesh.layer == 1)
                return;
            mesh.layer = 1;
            CplayerManager.ins.AreaHurtRole(mesh.transform.position, this.AtkRange);
        }
        Activate() {
            this.mState = EBarrierState.Activate;
            let v = new Laya.Vector3();
            this.mMainParent.transform.getRight(v);
            Laya.Vector3.scale(v, -5, v);
            for (let index = 0; index < this.mRigidbodys.length; index++) {
                this.mRigidbodys[index].isKinematic = false;
                this.mRigidbodys[index].gravity = new Laya.Vector3(0, -10, 0);
                this.mRigidbodys[index].mass = 0.1;
                this.mRigidbodys[index].linearVelocity = v;
                this.mRigidbodys[index].sleepLinearVelocity = 2;
                this.mRigidbodys[index].sleepAngularVelocity = 2;
            }
        }
        onUpdate() {
            if (this.mState == EBarrierState.Activate) {
                for (let index = 0; index < this.mMains.length; index++) {
                    const main = this.mMains[index];
                    if (main.active && main.transform.localPositionY < -20) {
                        main.active = false;
                    }
                }
            }
        }
        onTriggerRole(player, bar) {
            if (this.mState == EBarrierState.Activate && bar.owner.layer != 1) {
                CplayerManager.ins.AreaHurtRole(player.position, this.AtkRange);
                bar.owner.layer = 1;
            }
            return EBarrierCollisionAction.None;
        }
        onUninit() {
            super.onUninit();
            this.mMains = null;
            this.mRigidbodys = null;
        }
    }

    class BarrierSphere extends BarrierBase {
        constructor() {
            super(...arguments);
            this.isKillRole = false;
            this.killRoleTime = 0;
        }
        onInit() {
            let trigger = this.mSprite;
            let collider = trigger.getComponent(Laya.PhysicsCollider);
            collider.collisionGroup = CollisionConfig.kBarrierGroup;
            let script = trigger.addComponent(BarrierScript);
            script.onHit = this.Hit.bind(this);
            this.mMain = this.mSprite.getChildByName("Main");
            this.mRigidbody = this.mMain.getComponent(Laya.Rigidbody3D);
            this.mRigidbody.collisionGroup = CollisionConfig.kBarrierGroup;
            this.mRigidbody.mass = 0.1;
            let script1 = this.mMain.addComponent(BarrierScript);
            script1.onTriggerRole = this.onTriggerRole.bind(this);
            script1.onCollisonBuilding = this.CollisonBuilding.bind(this);
            script1.onHit = this.Hit.bind(this);
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            let animator = this.mSprite.getChildAt(0).getComponent(Laya.Animator);
            if (animator) {
                animator.play("Hit");
            } else {
                console.error("bug...");
            }
            this.Activate();
        }
        CollisonBuilding(c) {
            if (this.mState == EBarrierState.Die)
                return;
            this.mState = EBarrierState.Die;
            let v = this.mRigidbody.linearVelocity.clone();
            v.x *= 5;
            v.z *= 5;
            if (v.x > 5) {
                v.x = 5;
            }
            if (v.z > 5) {
                v.z = 5;
            }
            this.mRigidbody.linearVelocity = v;
            CplayerManager.ins.AreaHurtRole(this.mMain.transform.position, 6);
        }
        Activate() {
            this.mState = EBarrierState.Activate;
            this.mRigidbody.isKinematic = false;
            this.mRigidbody.gravity = new Laya.Vector3(0, -10, 0);
            this.mRigidbody.linearVelocity = new Laya.Vector3(0, -10, 0);
            this.mRigidbody.angularVelocity = new Laya.Vector3(MathExt.RandomNum(-3, 3), 0, MathExt.RandomNum(-3, 3));
        }
        onUpdate() {
            if (this.mState == EBarrierState.Activate) {
                if (this.isKillRole) {
                    if (Laya.timer.currTimer - this.killRoleTime > 2000) {
                        this.mState = EBarrierState.Die;
                    }
                }
            } else if (this.mState == EBarrierState.Die) {
                if (this.mMain.transform.localPositionY < -20) {
                    this.mMain.active = false;
                }
            }
        }
        onTriggerRole(player, bar) {
            this.CollisonBuilding(null);
            return EBarrierCollisionAction.None;
        }
        onUninit() {
            super.onUninit();
            this.mMain = null;
            this.mRigidbody = null;
        }
    }

    class BarrierStairs extends BarrierBase {
        onInit() {
            this.mMain = this.setPart("Main", this.Hit, null);
            this.mEnter = this.setPart("Enter", null, this.onRoleTriggerEnter);
        }
        onRoleTriggerEnter(player, bar) {
            if (this.mState == EBarrierState.Die) {
                return EBarrierCollisionAction.None;
            } else {
                this.stopPlayer = player;
                return EBarrierCollisionAction.TeamStop;
            }
        }
        Hit() {
            if (this.mState != EBarrierState.None)
                return;
            this.playAni("Other", "Hit");
            this.mState = EBarrierState.Activate;
            this.mMain.active = false;
            Laya.timer.once(1000, this, this.Die);
            this.changeWhite("tizi");
            this.changeWhite("shengzi");
        }
        Die() {
            this.mState = EBarrierState.Die;
            this.mEnter.active = false;
            if (this.stopPlayer) {
                CplayerManager.ins.TeamContinueMove();
                this.stopPlayer = null;
            }
        }
        onUninit() {
            Laya.timer.clearAll(this);
            this.mMain = null;
            this.mEnter = null;
            this.stopPlayer = null;
            super.onUninit();
        }
    }

    class BarrerManager {
        constructor(level) {
            this.mBarriers = [];
            this.mLevel = level;
            if (BarrerManager.instance) {
                console.error("bug...");
            }
            BarrerManager.instance = this;
            let barrier = this.mLevel.mLevelSpr3D.getChildByName("Barrier");
            if (barrier) {
                for (let index = 0; index < barrier.numChildren; index++) {
                    const sprite = barrier.getChildAt(index);
                    let cfg = BarrierConfig.getCfgByMeshName(sprite.name);
                    switch (cfg.Type) {
                        case EBarrier.Plank:
                            this.mBarriers.push(new BarrierPlank(this, cfg, sprite));
                            break;
                        case EBarrier.Bomb:
                            this.mBarriers.push(new BarrierBomb(this, cfg, sprite));
                            break;
                        case EBarrier.Sphere:
                            this.mBarriers.push(new BarrierSphere(this, cfg, sprite));
                            break;
                        case EBarrier.HangOil:
                            this.mBarriers.push(new BarrierHangOil(this, cfg, sprite));
                            break;
                        case EBarrier.Roller:
                            this.mBarriers.push(new BarrierRoller(this, cfg, sprite));
                            break;
                        case EBarrier.Stairs:
                            this.mBarriers.push(new BarrierStairs(this, cfg, sprite));
                            break;
                        case EBarrier.Bridge:
                            this.mBarriers.push(new BarrierBridge(this, cfg, sprite));
                            break;
                        case EBarrier.Bridge:
                            this.mBarriers.push(new BarrierBridge(this, cfg, sprite));
                            break;
                        default:
                            console.error("TODO 新防御物类型");
                            break;
                    }
                    this.mBarriers[this.mBarriers.length - 1].onInit();
                }
            } else {
                console.error("场景下没有 Barrier 挂点");
            }
            Laya.stage.on(Laya.Event.KEY_DOWN, this, (e) => {
                if (e.keyCode == Laya.Keyboard.K) {
                    for (let index = 0; index < this.mBarriers.length; index++) {
                        const element = this.mBarriers[index].Hit();
                    }
                }
            });
        }
        BombExplode(position, range) {
            Laya.timer.once(500, this, () => {
                for (let index = 0; index < this.mBarriers.length; index++) {
                    const element = this.mBarriers[index];
                    if (element.config.Type == EBarrier.Bomb) {
                        if (Laya.Vector3.distance(element.position, position) < range)
                            element.Hit();
                    }
                }
            });
        }
        create(name, rootNode, position) {
            let sprite = LoadSp3D(name);
            let cfg = BarrierConfig.getCfgByMeshName(name);
            switch (cfg.Type) {
                case EBarrier.Plank:
                    this.mBarriers.push(new BarrierPlank(this, cfg, sprite));
                    break;
                case EBarrier.Bomb:
                    this.mBarriers.push(new BarrierBomb(this, cfg, sprite));
                    break;
                case EBarrier.Sphere:
                    this.mBarriers.push(new BarrierSphere(this, cfg, sprite));
                    break;
                case EBarrier.HangOil:
                    this.mBarriers.push(new BarrierHangOil(this, cfg, sprite));
                    break;
                case EBarrier.Roller:
                    this.mBarriers.push(new BarrierRoller(this, cfg, sprite));
                    break;
                case EBarrier.Stairs:
                    this.mBarriers.push(new BarrierStairs(this, cfg, sprite));
                    break;
                case EBarrier.Bridge:
                    this.mBarriers.push(new BarrierBridge(this, cfg, sprite));
                    break;
                case EBarrier.Bridge:
                    this.mBarriers.push(new BarrierBridge(this, cfg, sprite));
                    break;
                default:
                    console.error("TODO 新防御物类型");
                    break;
            }
            this.mBarriers[this.mBarriers.length - 1].onInit();
            rootNode.addChild(sprite);
            sprite.transform.position = position;
            return;
        }
        onUninit() {
            for (let index = 0; index < this.mBarriers.length; index++) {
                const element = this.mBarriers[index];
                element.onUninit();
            }
            this.mBarriers.length = 0;
            BarrerManager.instance = null;
        }
        onUpdate() {
            for (let index = 0; index < this.mBarriers.length;) {
                const element = this.mBarriers[index];
                if (element.mState == EBarrierState.Uninit) {
                    element.onUninit();
                    this.mBarriers.splice(index, 1);
                } else {
                    element.onUpdate();
                    index++;
                }
            }
        }
    }

    class CamTrigger extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.mTargetPos = null;
            this.mIsEnd = false;
            this.mActionNum = 0;
            this.mIsFail = false;
        }
        OnInit(rModel, rType) {
            this.mModel = rModel;
            this.mTriType = rType;
            this.mCollider = this.mModel.getComponent(Laya.PhysicsCollider);
            this.mCollider.collisionGroup = CollisionConfig.kCameraState;
            let rTarget = this.mModel.getChildAt(0);
            if (rTarget)
                this.mTargetPos = rTarget.transform.position.clone();
            GEvent.Ins.on(GCamEvent.kFail, this, this.OnFail);
        }
        OnFail() {
            this.mIsFail = true;
        }
        onTriggerEnter(e) {
            if (this.mIsFail)
                return;
            this.mActionNum += 1;
            if (this.mActionNum > 1)
                return;
            this.mCollider.isTrigger = false;
            this.mCollider.enabled = false;
            let selfPoint = this.mModel.transform.position.clone();
            this.mModel.active = false;
            switch (this.mTriType) {
                case ETriggerType.Move:
                    GEvent.Ins.event(GCamEvent.kMove, [this.mTargetPos, ETriggerType.Move]);
                    break;
                case ETriggerType.End:
                    GEvent.Ins.event(GCamEvent.kMove, [this.mTargetPos, ETriggerType.End]);
                    GEvent.Ins.event(GCamEvent.kCamEnd, [selfPoint]);
                    break;
                case ETriggerType.MoveHover:
                    GEvent.Ins.event(GCamEvent.kMove, [this.mTargetPos, ETriggerType.MoveHover]);
                    break;
                case ETriggerType.Over:
                    GEvent.Ins.event(GCamEvent.kOver);
                    break;
                case ETriggerType.Observe:
                    GEvent.Ins.event(GCamEvent.kObserveTarget, [selfPoint]);
                    break;
                default:
                    break;
            }
        }
        onDestroy() {
            GEvent.Ins.off(GCamEvent.kFail, this, this.OnFail);
        }
    }

    class EffectUtil {
        constructor() {}
        static creatAcrMovementSprite(posX, posY, tweenToX, tweenToY, tweenTime, startAngle, parentLayer) {
            posY = -posY;
            tweenToY = -tweenToY;
            var follow = new Laya.Sprite();
            parentLayer.addChild(follow);
            follow.x = posX;
            follow.y = -posY;
            var XAB = this.getVec2Angle(tweenToX - posX, tweenToY - posY);
            if (startAngle == 0) {
                console.error("创建曲线轨迹，初始发射角度(startAngle)不能为0");
            }
            var BAO = startAngle < 0 ? 90 - Math.abs(startAngle) : -(90 - Math.abs(startAngle));
            BAO = this.getRadian(BAO);
            var r = this.getVec2Length(posX, posY, tweenToX, tweenToY) / 2 / Math.cos(BAO);
            var oX = posX - r * Math.cos(Math.PI - XAB - BAO);
            var oY = posY + r * Math.sin(Math.PI - XAB - BAO);
            var OA = 180 - this.getEuler(this.getVec2Angle(posX - oX, posY - oY));
            follow.rotation = OA;
            var AOB = this.getVec2Angle(tweenToX - oX, tweenToY - oY) - this.getVec2Angle(posX - oX, posY - oY);
            if (AOB < -Math.PI) {
                AOB += 2 * Math.PI;
            }
            if (AOB > Math.PI) {
                AOB -= 2 * Math.PI;
            }
            var t1 = 0;
            var followAnim;
            Laya.timer.frameLoop(1, this, followAnim = function() {
                t1 += Laya.timer.delta;
                var AOA1 = t1 / tweenTime * AOB;
                var A1Pos = this.getA1pos(posX, posY, AOA1, oX, oY, r);
                follow.x = A1Pos.x;
                follow.y = -A1Pos.y;
                var OA1 = 180 - this.getEuler(this.getVec2Angle(A1Pos.x - oX, A1Pos.y - oY));
                follow.rotation = OA1;
                if (t1 >= tweenTime) {
                    Laya.timer.clear(this, followAnim);
                    follow.destroy();
                    return;
                }
            });
            return follow;
        }
        static getVec2Angle(x, y) {
            return Math.atan2(y, x);
        }
        static getRadian(a) {
            return a / 180 * Math.PI;
        }
        static getEuler(a) {
            return a / Math.PI * 180;
        }
        static getVec2Length(xA, yA, xB, yB) {
            return Math.sqrt((xB - xA) * (xB - xA) + (yB - yA) * (yB - yA));
        }
        static getA1pos(aX, aY, AOA1Angle, oX, oY, r) {
            var XOA1 = this.getVec2Angle(aX - oX, aY - oY) + AOA1Angle;
            var x = oX - Math.cos(Math.PI - XOA1) * r;
            var y = oY + Math.sin(Math.PI - XOA1) * r;
            return {
                x,
                y
            };
        }
        static rondom(numMin, numMax) {
            if (numMin == numMax || numMax == null) {
                return numMin;
            }
            var r = Math.random();
            return r * numMin + (1 - r) * numMax;
        }
    }

    class TrailingParticle {
        constructor(texture, creatInterval, startScale, follow, parentLayer) {
            this.particles = [];
            this.timer = 0;
            this.parentLayer = parentLayer;
            this.creatInterval = creatInterval;
            this.texture = texture;
            this.follow = follow;
            this.startScale = startScale;
            this.spanParticle();
            Laya.timer.frameLoop(1, this, this.update);
        }
        spanParticle() {
            if (!this.follow || this.follow.destroyed) {
                return;
            }
            var par = new Laya.Sprite();
            par.texture = this.texture;
            par.pivotX = this.texture.width / 2;
            par.pivotY = this.texture.height / 2;
            par.scale(this.startScale, this.startScale);
            this.parentLayer.addChild(par);
            par.x = this.follow.x;
            par.y = this.follow.y;
            this.particles.push(par);
        }
        update() {
            if (!this.follow || this.follow.destroyed) {
                if (this.particles.length == 0) {
                    this.destroy();
                    return;
                }
            }
            this.timer += Laya.timer.delta;
            if (this.timer >= this.creatInterval) {
                this.spanParticle();
                this.timer -= this.creatInterval;
            }
            for (let index = this.particles.length - 1; index >= 0; index--) {
                const par = this.particles[index];
                par.scaleX -= 0.02;
                par.scaleY = par.scaleX;
                if (par.scaleX <= 0) {
                    par.scaleX = par.scaleY = 0;
                    par.removeSelf();
                    this.particles.splice(index, 1);
                    par.destroy();
                }
            }
        }
        destroy() {
            Laya.timer.clearAll(this);
            this.texture = null;
            this.parentLayer = null;
            this.follow = null;
            this.particles = null;
        }
    }

    class EffectManager {
        constructor() {
            this.mEffectList = [];
            this.mUID = 0;
            Laya.timer.frameLoop(1, this, this.update);
        }
        get UID() {
            return this.mUID++;
        }
        static get instance() {
            if (!EffectManager.GInstance) {
                EffectManager.GInstance = new EffectManager();
            }
            return EffectManager.GInstance;
        }
        update() {
            for (let index = this.mEffectList.length - 1; index >= 0; index--) {
                let effect = this.mEffectList[index];
                effect.update();
                if (!effect.isUsing) {
                    if (index != -1) {
                        this.mEffectList.splice(index, 1);
                    }
                    effect._destroy();
                }
            }
        }
        destroyEffectByName(name) {
            for (var index = this.mEffectList.length - 1; index >= 0; index--) {
                if (this.mEffectList[index].name === name) {
                    this.mEffectList[index].isUsing = false;
                }
            }
        }
        destroyEffectByID(id) {
            for (var index = this.mEffectList.length - 1; index >= 0; index--) {
                if (this.mEffectList[index].id === id) {
                    this.mEffectList[index].isUsing = false;
                }
            }
        }
        destroyEffectAll() {
            for (var index = this.mEffectList.length - 1; index >= 0; index--) {
                let effect = this.mEffectList[index];
                effect.isUsing = false;
            }
        }
        playTrailing(startX, startY, endX, endY, tweenTime, startAngle, texturePath, parentLayer) {
            let texture = Laya.loader.getRes(texturePath);
            if (!texture) {
                console.log("加载特效贴图失败：" + texturePath);
            }
            let follow = EffectUtil.creatAcrMovementSprite(startX, startY, endX, endY, tweenTime, startAngle, parentLayer);
            follow.texture = texture;
            follow.pivotX = texture.width / 2;
            follow.pivotY = texture.height / 2;
            follow.scaleX = 2;
            follow.scaleY = 2;
            follow.zOrder = 999;
            new TrailingParticle(texture, 50, 0.5, follow, parentLayer);
        }
    }
    EffectManager.GInstance = null;

    class WinUI extends ui.WinUI {
        constructor() {
            super();
            nativeOpen("胜利页");
            this.visible = false;
            this.zOrder = 10;
            Laya.stage.addChild(this);
        }
        static get UI() {
            if (!WinUI._UI)
                WinUI._UI = new WinUI();
            return WinUI._UI;
        }
        Goldani(Hide = true) {
            var rPoint = this.goldImg.localToGlobal(new Laya.Point(this.goldImg.displayWidth / 2, this.goldImg.displayHeight / 2));
            var rPostion = TopUI.UI.goldImg.localToGlobal(new Laya.Point(TopUI.UI.goldImg.displayWidth / 2, TopUI.UI.goldImg.displayHeight / 2));
            EffectManager.instance.playTrailing(rPoint.x, rPoint.y, rPostion.x, rPostion.y, 600, 1, "subpkg/UI/Share/1.png", Laya.stage);
            let cDelay = setTimeout(() => {
                clearTimeout(cDelay);
                Laya.Tween.to(TopUI.UI.goldImg, {
                    scaleX: 1.5,
                    scaleY: 1.5
                }, 100, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(TopUI.UI.goldImg, {
                        scaleX: 1,
                        scaleY: 1
                    }, 200, null, Laya.Handler.create(this, () => Hide && this.Hide()), 20);
                }));
            }, 600);
        }
        onCLICK() {
            this.offCLICK();
            this.btn.on(Laya.Event.CLICK, this, () => {
                this.offCLICK();
                this.anibtn.play(0, false);
                GInfo.addGold(parseInt(this.gold1.text));
                this.Goldani();
            });
            this.videobtn.on(Laya.Event.CLICK, this, () => {
                this.offCLICK();
                SDK().ShowV(end => {
                    this.onCLICK();
                    console.log("--->测试按钮事件", end);
                    if (end) {
                        GInfo.addGold(parseInt(this.gold1.text) * 2);
                        this.Goldani();
                    }
                },"胜利激励");
            });
            this.Share.disabled = false;
            this.Share.visible = SDK().SupShe();
            this.Share.on(Laya.Event.CLICK, this, () => {
                this.offCLICK();
                SDK().RecEv(end => {
                    this.onCLICK();
                    if (end) {
                        GInfo.addGold(1000);
                        this.Goldani(false);
                        this.Share.disabled = true;
                    }
                });
                SDK().ShaRec();
            });
        }
        offCLICK() {
            this.videobtn.offAll(Laya.Event.CLICK);
            this.Share.offAll(Laya.Event.CLICK);
            this.btn.offAll(Laya.Event.CLICK);
        }
        Show(n1, n2) {
            GInfo.trialGunId = null;
            GInfo.suptrial = false;
            SDK().StRec();
            this.visible = true;
            this.onCLICK();
            let gold = 0;
            let b = n1 * 0.2 + (GInfo.Commission * 0.1) + 1.1;
            gold = Math.floor(n2 * b + 200);
            this.gold1.text = `${gold}`;
            this.gold2.text = `${gold}`;
            TopUI.UI.Show();
            SDK().ShowI();
            // ++GameMain.Lvnum % 3 == 0 && SDK().ShowI();
            // ++GameMain.Lvnum % 5 == 0 && SDK().AddIcon();
            if (BSet.PfSDK == SDKType.OPPO)
                if (++GameMain.Bannernum % 2 == 0)
                    SDK().ShowB();
                else
                    SDK().ShowGB();
            else
                SDK().ShowB();
            console.log("show Win");
        }
        Hide() {
            BSet.PfSDK == SDKType.TT && SDK().HideB();
            SDK().HideGB();
            this.visible = false;
            HomeScene.instance.OnGameOver(true);
        }
    }

    class Box {}
    class BoxAward extends ui.BoxAwardUI {
        constructor() {
            super();
            nativeOpen("结算奖励页");
            this.list = [];
            this.key = 3;
            this.zOrder = 1;
            this.visible = true;
            Laya.stage.addChild(this);
            for (let i = 0; i < 9; i++) {
                let box = new Box();
                box.num = 160 + Math.floor(Math.random() * 160);
                box.open = false;
                this.list[i] = box;
            }
            this.List.renderHandler = new Laya.Handler(this, this.renderList);
            this.List.array = this.list;
            this.video.visible = false;
            this.Back.visible = false;
            this.Back.on(Laya.Event.CLICK, this, this.Hdie);
            this.video.on(Laya.Event.CLICK, this, () => {
                SDK().ShowV(end => {
                    if (end) {
                        this.key = 3;
                        this.video.visible = false;
                        this.Back.visible = false;
                        this.List.refresh();
                    }
                },"宝箱激励X3");
            });
            // SDK().ShowB2();
            // SDK().ShowB();
            Double.UI.Hide();
            SDK().ShowI();
            console.log("show BoxAward");
        }
        renderList(cell, index) {
            let data = cell.dataSource;
            let bj = cell.getChildByName("bj");
            let box = cell.getChildByName("box");
            let gold = cell.getChildByName("gold");
            let num = cell.getChildByName("num");
            let vbj = cell.getChildByName("vbj");
            let video = cell.getChildByName("video");
            box.visible = false;
            gold.visible = false;
            num.visible = false;
            vbj.visible = false;
            video.visible = false;
            num.text = `${data.num}`;
            if (data.open) {
                bj.skin = "subpkg/UI/TreasureBox/6.png";
                gold.visible = true;
                num.visible = true;
            } else {
                bj.skin = "subpkg/UI/TreasureBox/10.png";
                if (this.key <= 0) {
                    box.visible = true;
                    vbj.visible = true;
                    video.visible = true;
                } else
                    box.visible = true;
            }
            cell.offAll(Laya.Event.CLICK);
            cell.on(Laya.Event.CLICK, this, () => {
                if (video.visible) {
                    SDK().ShowV(end => {
                        if (end) {
                            GInfo.addGold(data.num);
                            this.list[index].open = true;
                            if (this.Checklist())
                                this.Hdie();
                            else
                                this.List.refresh();
                        }
                    },"宝箱激励X1");
                } else if (box.visible) {
                    GInfo.addGold(data.num);
                    this.list[index].open = true;
                    if (this.Checklist())
                        this.Hdie();
                    else {
                        if (--this.key <= 0) {
                            this.video.visible = true;
                            this.Back.visible = true;
                        }
                        this.List.refresh();
                    }
                }
            });
        }
        Checklist() {
            for (let i = 0; i < 9; i++)
                if (!this.list[i].open)
                    return false;
            return true;
        }
        Hdie() {
            this.destroy();
            WinUI.UI.Show(CplayerManager.ins.InAirPlaneNum, CplayerManager.ins.DieRedRoleNum);
        }
    }

    class Airplane {
        constructor(rScene, rAirplaneSprite3d) {
            this.curAirplaneAniName = "zhishengji_idle";
            this.FlyAniName = "zhishengji_shangshengzhuanxiang";
            this.mModel = LoadSp3D("Airplane");
            this.mAnimator = Sprite3DExt.getCBN(this.mModel, "zhishengji_idle").getComponent(Laya.Animator);
            rScene.addChild(this.mModel);
            this.mPoint = Sprite3DExt.getCBN(this.mModel, "Point");
            this.mModel.transform.position = rAirplaneSprite3d.transform.position;
            this.mModel.transform.localRotation = rAirplaneSprite3d.transform.localRotation;
            this.mEffect = LoadSp3D("ef_yanhua");
            rAirplaneSprite3d.addChild(this.mEffect);
            this.mEffect.transform.localMatrix = Laya.Matrix4x4.DEFAULT;
            this.mEffect.transform.localPositionY += 3;
            let rVecScale = new Laya.Vector3(7, 7, 7);
            for (let index = 0; index < this.mEffect.numChildren; index++) {
                const element = this.mEffect.getChildAt(0);
                element.transform.localScale = rVecScale;
            }
            this.mEffect.active = false;
        }
        get RolePosition() {
            if (this.mPoint) {
                return this.mPoint.transform.position.clone();
            }
            return new Laya.Vector3();
        }
        OnUpdate() {
            if (!this.mModel)
                return;
            if (!this.mAnimator)
                return;
            if (this.curAirplaneAniName == this.FlyAniName) {
                let aniState = this.mAnimator.getControllerLayer().getCurrentPlayState();
                if (aniState.normalizedTime >= 0.2 && !this.mEffect.active)
                    this.mEffect.active = true;
                if (aniState.normalizedTime >= 1) {
                    this.OnUninit();
                }
            }
        }
        OnPlayAnimation() {
            Laya.timer.once(1000, this, () => {
                if (this.mAnimator) {
                    let rr = this.mAnimator.getControllerLayer().getAnimatorState(this.FlyAniName);
                    if (rr) {
                        this.mAnimator.play(this.FlyAniName, 0, 0);
                        setTimeout(() => {
                            this.curAirplaneAniName = this.FlyAniName;
                            new BoxAward();
                            return;
                            if (BSet.PfSDK == SDKType.OPPO ||
                                BSet.PfSDK == SDKType.Dummy)
                                new BoxAward();
                            else
                                WinUI.UI.Show(CplayerManager.ins.InAirPlaneNum, CplayerManager.ins.DieRedRoleNum);
                        }, 200);
                    }
                }
            });
        }
        OnUninit() {
            Laya.timer.clearAll(this);
            if (this.mEffect) {
                this.mEffect.removeSelf();
                this.mEffect.destroy();
                this.mEffect = null;
            }
            this.mAnimator = null;
            if (this.mModel) {
                this.mModel.removeSelf();
                this.mModel.destroy();
                this.mModel = null;
            }
        }
    }

    var ETriggerType;
    (function(ETriggerType) {
        ETriggerType["None"] = "None";
        ETriggerType["Move"] = "Move";
        ETriggerType["End"] = "End";
        ETriggerType["Over"] = "Over";
        ETriggerType["Observe"] = "Observe";
        ETriggerType["MoveHover"] = "MoveHover";
    })(ETriggerType || (ETriggerType = {}));
    class Level {
        constructor(rScene, rSkyColor) {
            this.mScene = rScene;
            this.mScene.fogStart = 50;
            this.mScene.fogRange = 300;
            this.mSkyColor = rSkyColor;
            this.OnInit();
            this.mBarMgr = new BarrerManager(this);
            GEvent.Ins.on(GCamEvent.kOver, this, this.OnCamOver);
        }
        OnInit() {
            this.mLevelSpr3D = LoadSp3D("Level" + GInfo.LevelId);
            this.mScene.addChild(this.mLevelSpr3D);
            this.mLevelCameraRoot = Sprite3DExt.getCBN(this.mLevelSpr3D, "LevelCameraRoot");
            this.mLevelCameraRoot.active = false;
            this.mSuccessCamera = this.mLevelSpr3D.getChildByName("SuccessCamera");
            this.mCamTriggers = this.mLevelSpr3D.getChildByName("CamTriggers");
            let EffectEndNode = this.mLevelSpr3D.getChildAt(0).getChildByName("Effect");
            if (EffectEndNode) {
                for (let i = 0; i < EffectEndNode.numChildren; i++) {
                    let S = "ef_fangwuhuoyan";
                    const element = EffectEndNode.getChildAt(i);
                    if (i == 0) {
                        S = "ef_yinjiuguangquan";
                    }
                    let EffectModel = Laya.loader.getRes(GetSpPath(S)).clone();
                    this.mLevelSpr3D.addChild(EffectModel);
                    EffectModel.transform.position = element.transform.position;
                }
            }
            this.OnInitalizeTriggers();
            this.InitLieRole();
        }
        OnInitalizeTriggers() {
            for (let index = 0; index < this.mCamTriggers.numChildren; index++) {
                const rNode = this.mCamTriggers.getChildAt(index);
                if (rNode.name == "Airplane") {
                    this.mAriplanePoint = rNode;
                    break;
                }
                let rType = ETriggerType.None;
                switch (rNode.name) {
                    case ETriggerType.Move:
                        rType = ETriggerType.Move;
                        break;
                    case ETriggerType.End:
                        rType = ETriggerType.End;
                        break;
                    case ETriggerType.MoveHover:
                        rType = ETriggerType.MoveHover;
                        break;
                    case ETriggerType.Over:
                        rType = ETriggerType.Over;
                        break;
                    case ETriggerType.Observe:
                        rType = ETriggerType.Observe;
                        break;
                    default:
                        break;
                }
                if (rType == ETriggerType.None)
                    return;
                let rTriNode = rNode.addComponent(CamTrigger);
                rTriNode.OnInit(rNode, rType);
            }
        }
        StartGame() {
            this.InitalizeRole();
            this.mLevelCamera = new CameraEntity(this.mLevelCameraRoot, this, this.mSkyColor);
        }
        InitLieRole() {
            this.mcRoleMgr = new CplayerManager();
            this.mcRoleMgr.onInit(this.mLevelSpr3D);
            for (let i = 0; i < 2; i++) {
                if (i == 0) {
                    this.mcRoleMgr.CreatLieAndRole(true, false, true);
                } else {
                    this.mcRoleMgr.CreatLieAndRole(false, false, true);
                }
            }
        }
        InitalizeRole() {
            this.mcRoleMgr.PlayBlueMAni();
            this.mcRoleMgr.CreatRole(false);
        }
        OnTimerCreateEnemyRole() {
            let count = 100;
            let pathpoint = Laya.Vector3[5];
            let position = new Laya.Vector3(0, 0, 0);
            for (let i = 0; i < count; i++) {
                Laya.timer.once(100 * i, this, (pathpoint, position) => {
                    let speed = MathExt.RandomInt(3, 6);
                    let Color = new Laya.Vector4(1, 0, 0, 1);
                    let scale = new Laya.Vector3(1, 1, 1);
                    this.mcRoleMgr.CreatRoleByCustom(true, pathpoint, position, scale, speed, Color);
                }, [pathpoint, position], false);
            }
        }
        OnTimerCreateBarrer() {
            BarrerManager.instance.create("peijian_3", this.mScene, new Laya.Vector3(0, 0, 50));
        }
        OnCamOver() {
            this.mAirplane = new Airplane(this.mScene, this.mAriplanePoint);
            this.mLevelCamera.mCameraState = ECameraState.Over;
            this.mLevelCamera.mModel.active = false;
            this.mLevelCamera.mWeaponEntity.OnUninit();
            this.mLevelCamera.mModel.active = true;
            CameraEntity.mCamera.fieldOfView = 60;
            this.mLevelCamera.mModel.transform.position = this.mSuccessCamera.transform.position;
            this.mLevelCamera.mRotate.transform.localRotation = this.mSuccessCamera.transform.localRotation;
            setTimeout(() => {}, 300);
        }
        OnUpdate() {
            this.mBarMgr.onUpdate();
            if (this.mcRoleMgr) {
                this.mcRoleMgr.onUpdate();
            }
            if (this.mLevelCamera) {
                this.mLevelCamera.OnUpdate();
            }
            if (this.mAirplane) {
                this.mAirplane.OnUpdate();
            }
        }
        OnUnint() {
            GEvent.Ins.off(GCamEvent.kOver, this, this.OnCamOver);
            if (this.mAirplane) {
                this.mAirplane.OnUninit();
                this.mAirplane = null;
            }
            if (this.mLevelCamera) {
                this.mLevelCamera.OnUnint();
                this.mLevelCamera = null;
            }
            if (this.mLevelSpr3D) {
                this.mLevelSpr3D.removeSelf();
                this.mLevelSpr3D.destroy();
                this.mLevelSpr3D = null;
            }
            if (this.mBarMgr) {
                this.mBarMgr.onUninit();
            }
            if (this.mcRoleMgr) {
                this.mcRoleMgr.onUninit();
            }
            this.mScene = null;
        }
    }

    class CmpCamMove extends CmpCamera {
        constructor(rEntity) {
            super(rEntity);
            this.mTweenExt = null;
            GEvent.Ins.on(GCamEvent.kMove, this, this.OnMove);
            GEvent.Ins.on(GCamEvent.kFail, this, this.OnFail);
        }
        OnFail() {
            if (this.mTweenExt) {
                this.mTweenExt.onUninit();
            }
        }
        OnMove(rTargetPoint, rTriType) {
            this.mCamEntity.mCameraState = ECameraState.Move;
            this.mTweenExt = TweenExt.ZXTo(this.mMoveSpr3D, rTargetPoint, new Laya.Quaternion(), 3000, Laya.Ease.linearIn, () => {
                switch (rTriType) {
                    case ETriggerType.Move:
                        GEvent.Ins.event(GCamEvent.kFollow);
                        break;
                    case ETriggerType.MoveHover:
                        this.mCamEntity.mCameraState = ECameraState.Hover;
                        break;
                    case ETriggerType.End:
                        this.mCamEntity.mCameraState = ECameraState.End;
                        break;
                    default:
                        break;
                }
                this.mTweenExt = null;
            });
        }
        OnInit(rMSpr3D) {
            this.mMoveSpr3D = rMSpr3D;
        }
        OnUpdate() {}
        OnUnint() {
            if (this.mTweenExt) {
                this.mTweenExt.onUninit();
            }
            GEvent.Ins.off(GCamEvent.kMove, this, this.OnMove);
            GEvent.Ins.off(GCamEvent.kFail, this, this.OnFail);
            this.mMoveSpr3D = null;
        }
    }

    class CmpCamOffset extends CmpCamera {
        constructor(rEntity) {
            super(rEntity);
            GEvent.Ins.on(GCamEvent.kOffset, this, this.OnOffset);
        }
        OnOffset(rTargetPoint) {
            TweenExt.ZXTo(this.mOffsetSpr3D, rTargetPoint, new Laya.Quaternion(), 150, Laya.Ease.backIn, () => {
                TweenExt.ZXTo(this.mOffsetSpr3D, new Laya.Vector3(0, 0, 0), new Laya.Quaternion(), 150, Laya.Ease.backIn, () => {
                    GEvent.Ins.event(GCamEvent.kFollow);
                });
            });
        }
        OnInit(rOffset) {
            this.mOffsetSpr3D = rOffset;
        }
        OnUpdate() {}
        OnUnint() {
            GEvent.Ins.off(GCamEvent.kOffset, this, this.OnOffset);
            this.mOffsetSpr3D = null;
        }
    }

    class CmpCamRotate extends CmpCamera {
        constructor(rEntity) {
            super(rEntity);
            this.mPlayerPos = new Laya.Vector3();
            GEvent.Ins.on(GCamEvent.kObserveTarget, this, this.onChangeObserveTraget);
            GEvent.Ins.on(GCamEvent.kCamEnd, this, this.onChangeObserveTraget);
        }
        OnInit(rRotate) {
            this.mRotate = rRotate;
        }
        get GetTargetPos() {
            if (CplayerManager.ins.TargetCameraPos) {
                this.mPlayerPos = CplayerManager.ins.TargetCameraPos;
            }
            return this.mPlayerPos;
        }
        onChangeObserveTraget(rTargetPoint = null) {
            this.mObserveTargetPoint = rTargetPoint;
        }
        OnUpdate() {
            if (this.mCamEntity.mCameraState == ECameraState.Fail)
                return;
            if (this.mCamEntity.mCameraState == ECameraState.Observe || this.mCamEntity.mCameraState == ECameraState.End) {
                if (this.mObserveTargetPoint) {
                    let rQuat1 = this.mRotate.transform.rotation.clone();
                    this.mRotate.transform.lookAt(this.mObserveTargetPoint, this.mVector3Up);
                    let rQuat = this.mRotate.transform.rotation.clone();
                    this.mRotate.transform.rotation = rQuat1;
                    let temp = new Laya.Quaternion();
                    Laya.Quaternion.slerp(this.mRotate.transform.rotation, rQuat, GameMain.Ins.delta * 4, temp);
                    this.mRotate.transform.rotation = temp;
                }
                return;
            }
            let rQuat1 = this.mRotate.transform.rotation.clone();
            this.mRotate.transform.lookAt(this.GetTargetPos, this.mVector3Up);
            let rQuat = this.mRotate.transform.rotation.clone();
            this.mRotate.transform.rotation = rQuat1;
            let temp = new Laya.Quaternion();
            if (this.mCamEntity.mCameraState == ECameraState.Follow || this.mCamEntity.mCameraState == ECameraState.Hover)
                Laya.Quaternion.slerp(this.mRotate.transform.rotation, rQuat, GameMain.Ins.delta * 1, temp);
            else
                Laya.Quaternion.slerp(this.mRotate.transform.rotation, rQuat, GameMain.Ins.delta * 4, temp);
            this.mRotate.transform.rotation = temp;
        }
        OnUnint() {
            GEvent.Ins.off(GCamEvent.kObserveTarget, this, this.onChangeObserveTraget);
            GEvent.Ins.off(GCamEvent.kCamEnd, this, this.onChangeObserveTraget);
            this.mRotate = null;
        }
    }

    class FailUI extends ui.FailUI {
        constructor() {
            super();
            nativeOpen("失败页");
            this.zOrder = 10;
            this.visible = false;
            Laya.stage.addChild(this);
            SDK().ShowB();
        }
        static get UI() {
            if (!FailUI._UI)
                FailUI._UI = new FailUI();
            return FailUI._UI;
        }
        InitCLICK() {
            this.again.offAll(Laya.Event.CLICK);
            this.again.on(Laya.Event.CLICK, this, () => {
                this.again.offAll(Laya.Event.CLICK);
                HomeScene.instance.OnGameOver(false);
                this.Hide();
            });
            this.skip.offAll(Laya.Event.CLICK);
            this.skip.on(Laya.Event.CLICK, this, () => {
                SDK().ShowV(end => {
                    if (end) {
                        this.aniskip.play(0, false);
                        this.skip.offAll(Laya.Event.CLICK);
                        HomeScene.instance.OnGameOver(true);
                        this.Hide();
                    }
                },"跳过激励");
            });
        }
        Show() {
            GInfo.trialGunId = null;
            GInfo.suptrial = false;
            SDK().StRec();
            this.visible = true;
            this.InitCLICK();
            TopUI.UI.Show();
            // SDK().ShowB2();
            SDK().ShowI();
            // ++GameMain.Lvnum % 3 == 0 && SDK().ShowI();
            // ++GameMain.Lvnum % 5 == 0 && SDK().AddIcon();
            console.log("show Fail");
        }
        Hide() {
            if (BSet.PfSDK == SDKType.TT ||
                BSet.PfSDK == SDKType.OPPO)
                SDK().HideB();
            this.visible = false;
        }
    }

    class CmpCamView extends CmpCamera {
        constructor(rEntity) {
            super(rEntity);
            this.mStartBulletTime = 0;
            this.IsShootBullet = true;
        }
        OnInit(rCamera) {
            this.mCamera = rCamera;
            GEvent.Ins.on(GCamEvent.kFail, this, this.OnBulletTimeStart);
            GEvent.Ins.on(GCamEvent.kObserveTarget, this, this.OnObserveTarget);
            GEvent.Ins.on(GCamEvent.kChangeViewValue, this, this.ChangeView);
        }
        OnObserveTarget() {
            if (this.mCamEntity.mCameraState == ECameraState.Observe)
                return;
            this.mCamEntity.mCameraState = ECameraState.Observe;
            Laya.Tween.to(this.mCamera, {
                fieldOfView: CameraConfig.kObserveView
            }, 1000, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.mCamera, {
                    fieldOfView: CameraConfig.kFiledView
                }, 500, null, Laya.Handler.create(this, () => {
                    this.mCamEntity.mCameraState = ECameraState.Follow;
                }), 300);
            }));
        }
        ChangeView(rViewValue) {
            Laya.Tween.to(this.mCamera, {
                fieldOfView: rViewValue
            }, 500, Laya.Ease.linearIn, Laya.Handler.create(this, () => {}));
        }
        OnUpdate() {
            this.UpdateBulletTime();
        }
        OnBulletTimeStart() {
            this.mCamEntity.mCameraState = ECameraState.Fail;
            if (this.mStartBulletTime > 0)
                return;
            this.mStartBulletTime = Laya.timer.currTimer;
            Laya.timer.scale = 0.2;
            this.IsShootBullet = false;
        }
        UpdateBulletTime() {
            if (this.mStartBulletTime == 0)
                return;
            if (Laya.timer.currTimer - this.mStartBulletTime >= CmpCamView.kBulletTimeDistance) {
                Laya.timer.scale = 1;
                this.mStartBulletTime = 0;
                FailUI.UI.Show();
            } else {
                this.mCamera.fieldOfView -= 0.4;
            }
        }
        OnUnint() {
            GEvent.Ins.off(GCamEvent.kChangeViewValue, this, this.ChangeView);
            GEvent.Ins.off(GCamEvent.kFail, this, this.OnBulletTimeStart);
            GEvent.Ins.off(GCamEvent.kObserveTarget, this, this.OnObserveTarget);
            Laya.Tween.clearAll(this.mCamera);
            this.mCamera = null;
        }
    }
    CmpCamView.kBulletTimeDistance = 500;

    class CameraEntity {
        constructor(rLevelCamRoot, rLevel, rClearColor) {
            this.mCmpCamera = [];
            this.mCameraState = ECameraState.Follow;
            this.mLevel = rLevel;
            this.mModel = rLevelCamRoot;
            this.mModel.active = true;
            this.mOffsetPoint = this.mModel.getChildAt(0);
            this.mRotate = this.mOffsetPoint.getChildAt(0);
            CameraEntity.mCamera = this.mRotate.getChildAt(0);
            CameraEntity.mCamera.clearFlag = Laya.CameraClearFlags.SolidColor;
            CameraEntity.mCamera.clearColor = rClearColor;
            let rSceneCamera = HomeScene.instance.cameraRoot.getChildAt(0);
            CameraEntity.mCamera.skyRenderer.mesh = rSceneCamera.skyRenderer.mesh;
            CameraEntity.mCamera.skyRenderer.material = rSceneCamera.skyRenderer.material;
            this.mGunPoint = this.mRotate.getChildAt(1);
            this.mWeaponEntity = new WeaponEntity(this.mGunPoint, this.mLevel);
            this.OnInitCmp();
            GEvent.Ins.on(GCamEvent.kHover, this, this.OnHover);
        }
        OnHover() {
            this.mCameraState = ECameraState.Hover;
        }
        OnInitCmp() {
            let rCmpMove = new CmpCamMove(this);
            rCmpMove.OnInit(this.mModel);
            this.mCmpCamera.push(rCmpMove);
            let rCmpFollow = new CmpCamFollow(this);
            rCmpFollow.OnInit(this.mModel);
            this.mCmpCamera.push(rCmpFollow);
            let rCmpOffset = new CmpCamOffset(this);
            rCmpOffset.OnInit(this.mOffsetPoint);
            this.mCmpCamera.push(rCmpOffset);
            let rCmpRotate = new CmpCamRotate(this);
            rCmpRotate.OnInit(this.mRotate);
            this.mCmpCamera.push(rCmpRotate);
            let rCmpCamView = new CmpCamView(this);
            rCmpCamView.OnInit(CameraEntity.mCamera);
            this.mCmpCamera.push(rCmpCamView);
        }
        OnUpdate() {
            if (this.mCameraState == ECameraState.Over)
                return;
            for (const rItem of this.mCmpCamera) {
                rItem.OnUpdate();
            }
            this.mWeaponEntity && this.mWeaponEntity.OnUpdate();
        }
        OnUnint() {
            if (this.mWeaponEntity)
                this.mWeaponEntity.OnUninit();
            for (const rItem of this.mCmpCamera) {
                rItem.OnUnint();
            }
            if (CameraEntity.mCamera) {
                CameraEntity.mCamera = null;
            }
            this.mCmpCamera = [];
            this.mModel = null;
        }
    }

    var ECharacterAniState;
    (function(ECharacterAniState) {
        ECharacterAniState["None"] = "None";
        ECharacterAniState["StandOne"] = "lanren_daiji_1";
        ECharacterAniState["StandTwo"] = "lanren_daiji_2";
        ECharacterAniState["Run"] = "lanren_paobu";
        ECharacterAniState["RunFloor"] = "lanren_patizi";
        ECharacterAniState["Die"] = "lanren_siwang";
        ECharacterAniState["DieFall"] = "paobu_diaoluo";
        ECharacterAniState["DieFloorWallFall"] = "patizi_diaoluo";
        ECharacterAniState["Attack"] = "hongren_chiren";
        ECharacterAniState["DieFly"] = "renwu_hit";
        ECharacterAniState["Jump"] = "lanren_qitiaoshangfeiji";
        ECharacterAniState["JumpOne"] = "jump";
        ECharacterAniState["Victory"] = "hongren_shengli";
        ECharacterAniState["VictoryBlue"] = "renwu_feijishengli";
        ECharacterAniState["LieUP"] = "renwu_qishen";
        ECharacterAniState["LieDown"] = "renwu_tangdishang";
        ECharacterAniState["LieOn"] = "renwu_jifeipaxia";
    })(ECharacterAniState || (ECharacterAniState = {}));
    class Charter extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.VECTOR3_UP = new Laya.Vector3(0, 1, 0);
            this.mZeroQueternion = new Laya.Quaternion();
            this.mZeroVec3 = new Laya.Vector3();
            this.mAnimState = ECharacterAniState.None;
        }
        PlayAnim(state) {
            if (this.mAnimState == state) {
                return;
            }
            this.mAnimator.speed = 1;
            this.mAnimator.play(state);
            this.mAnimState = state;
        }
        getCurAniPlayState() {
            if (this.mAnimator) {
                return this.mAnimator.getControllerLayer().getCurrentPlayState();
            }
        }
        get model() {
            return this.owner;
        }
        get position() {
            return this.model.transform.position;
        }
        lookAtTarget(target) {
            this.model.transform.lookAt(target, this.VECTOR3_UP, false);
            this.model.transform.localRotationEulerY += 180;
        }
        set position(pos) {
            this.model.transform.position = pos;
        }
        getForward(out) {
            this.model.transform.getForward(out);
            return out;
        }
        get rotation() {
            return this.model.transform.rotation;
        }
        set rotation(rot) {
            this.model.transform.rotation = rot;
        }
        onUninit() {
            this.mZeroQueternion = null;
            this.mZeroVec3 = null;
            this.mAnimator = null;
            if (this.mModel) {
                this.mModel.removeSelf();
                let KC = this.mModel.getComponent(Laya.CharacterController);
                if (KC) {
                    KC.destroy();
                    KC = null;
                }
                let AASS = this.mModel.getComponent(Cplayer);
                if (AASS) {
                    AASS.destroy();
                }
                ObjectPoolManager.Instance.recover("Character", this.mModel);
                this.mModel = null;
            }
        }
    }

    var PlayerCondition;
    (function(PlayerCondition) {
        PlayerCondition[PlayerCondition["FoeRed"] = 0] = "FoeRed";
        PlayerCondition[PlayerCondition["PlayerBlue"] = 1] = "PlayerBlue";
    })(PlayerCondition || (PlayerCondition = {}));
    var RoleState;
    (function(RoleState) {
        RoleState[RoleState["Stand"] = 0] = "Stand";
        RoleState[RoleState["Walk"] = 1] = "Walk";
        RoleState[RoleState["Die"] = 2] = "Die";
    })(RoleState || (RoleState = {}));
    class Cplayer extends Charter {
        constructor() {
            super(...arguments);
            this.blueSpeed = 4;
            this.redSpeed = 6;
            this.kMoveDir = new Laya.Vector3();
            this.kAtkDis = 3.5;
            this.kTargetPos = [];
            this.kTargetPatrolIndex = 0;
            this.isRedRole = false;
            this.redMAlbeColor = new Laya.Vector4(1, 0, 0, 1);
            this.DieMAlbeColor = new Laya.Vector4(0, 0, 0, 1);
            this.isCrawl = false;
            this.IsJumpAirPlane = false;
            this.isLie = false;
            this.isCrawling = false;
            this.isLaddering = false;
            this.isCanMove = false;
            this.EffectModel = null;
            this.FallGra = new Laya.Vector3(0, -29.8, 0);
            this.BlueTarEtiny = null;
            this.InJumpAir = false;
            this.IsChase = false;
            this.BlueLastOne = false;
            this.flyTime = 0;
            this.CurTimer = 0;
            this.IsCanInfect = true;
            this.IsUping = false;
            this.IsCURTIMER = 0;
        }
        onUninit() {
            Laya.timer.clearAll(this);
            this.mAnimState = ECharacterAniState.None;
            if (this.EffectModel)
                this.ClearEffectInRole();
            this.kMoveDir = null;
            super.onUninit();
        }
        OnInit(_points, _isRedRole, _isLie, _isCrawl) {
            if (!_isRedRole) {
                CplayerManager.ins.LeastBlueRoleNum++;
            }
            let point = [];
            for (let index = 0; index < _points.numChildren; index++) {
                const element = _points.getChildAt(index);
                point.push(element.transform.position);
            }
            this.isRedRole = _isRedRole;
            this.isCrawl = _isCrawl;
            this.isLie = _isLie;
            this.setPatrol(point);
            this.mModel = this.owner;
            if (this.mModel) {
                this.kCharcter = this.mModel.addComponent(Laya.CharacterController);
                let sphereShape = new Laya.CapsuleColliderShape(0.6, 1.8);
                sphereShape.localOffset = new Laya.Vector3(0, 0.85, 0);
                this.kCharcter.colliderShape = sphereShape;
                this.kCharcter.gravity = this.FallGra;
                this.kCharcter.collisionGroup = CollisionConfig.kPlayerGroup;
                this.mAnimator = this.owner.getChildAt(0).getComponent(Laya.Animator);
                this.roleMaterial = (this.mModel.getChildAt(0).getChildAt(1)).skinnedMeshRenderer.material;
                this.roleMaCloro = this.roleMaterial.albedoColor;
                if (this.isCrawl || this.isLaddering) {
                    this.kCharcter.gravity = new Laya.Vector3(0, (this.MoveSpeed / 3) * GameMain.Ins.delta, 0);
                }
                if (this.isLie) {
                    let EffectRes = "";
                    if (this.isRedRole) {
                        this.setState(ECharacterAniState.LieDown);
                        EffectRes = "ef_z";
                        let ma = MathExt.RandomInt(0, 2);
                        if (ma == 1) {
                            EffectRes = "ef_tanhao";
                        }
                    } else {
                        this.setState(ECharacterAniState.StandTwo);
                        EffectRes = "ef_help";
                    }
                    let MR = MathExt.RandomInt(0, 360);
                    this.EffectModel = Laya.loader.getRes(GetSpPath(EffectRes)).clone();
                    this.model.parent.addChild(this.EffectModel);
                    let BP = this.model.getChildByName("EffectPoint");
                    this.EffectModel.transform.position = BP.transform.position;
                    this.model.transform.localRotationEulerY = MR;
                    this.model.transform.localRotationEulerY = this.model.transform.localRotationEulerY;
                } else {
                    this.setState(ECharacterAniState.StandOne);
                }
            }
            this.KRoleCondition = this.isRedRole ? PlayerCondition.FoeRed : PlayerCondition.PlayerBlue;
            this.MoveSpeed = this.isRedRole ? this.redSpeed : this.blueSpeed;
            this.isCanMove = true;
            this.KRoleState = RoleState.Stand;
            if (this.KRoleCondition == PlayerCondition.FoeRed) {
                Laya.timer.frameLoop(10, this, this.CheckFBDir);
            }
        }
        OnInit1(point, _isRedRole, _isLie, _isCrawl, MoveSpeed) {
            if (!_isRedRole) {
                CplayerManager.ins.LeastBlueRoleNum++;
            }
            this.isRedRole = _isRedRole;
            this.isCrawl = _isCrawl;
            this.isLie = _isLie;
            this.setPatrol(point);
            this.mModel = this.owner;
            if (this.mModel) {
                this.kCharcter = this.mModel.addComponent(Laya.CharacterController);
                let sphereShape = new Laya.CapsuleColliderShape(0.5, 1.8);
                sphereShape.localOffset = new Laya.Vector3(0, 0.85, 0);
                this.kCharcter.colliderShape = sphereShape;
                this.kCharcter.gravity = this.FallGra;
                this.kCharcter.collisionGroup = CollisionConfig.kPlayerGroup;
                this.mAnimator = this.owner.getChildAt(0).getComponent(Laya.Animator);
                this.roleMaterial = (this.mModel.getChildAt(0).getChildAt(1)).skinnedMeshRenderer.material;
                this.roleMaCloro = this.roleMaterial.albedoColor;
                if (this.isCrawl || this.isLaddering) {
                    this.kCharcter.gravity = new Laya.Vector3(0, (this.MoveSpeed / 3) * GameMain.Ins.delta, 0);
                }
                if (this.isLie) {
                    let EffectRes = "";
                    if (this.isRedRole) {
                        this.setState(ECharacterAniState.LieDown);
                        EffectRes = "ef_z";
                        let ma = MathExt.RandomInt(0, 2);
                        if (ma == 1) {
                            EffectRes = "ef_tanhao";
                        }
                    } else {
                        this.setState(ECharacterAniState.StandTwo);
                        EffectRes = "ef_help";
                    }
                    let MR = MathExt.RandomInt(0, 360);
                    this.EffectModel = Laya.loader.getRes(GetSpPath(EffectRes)).clone();
                    this.model.parent.addChild(this.EffectModel);
                    let BP = this.model.getChildByName("EffectPoint");
                    this.EffectModel.transform.position = BP.transform.position;
                    this.model.transform.localRotationEulerY = MR;
                    this.model.transform.localRotationEulerY = this.model.transform.localRotationEulerY;
                } else {
                    this.setState(ECharacterAniState.StandOne);
                }
            }
            this.KRoleCondition = this.isRedRole ? PlayerCondition.FoeRed : PlayerCondition.PlayerBlue;
            this.MoveSpeed = MoveSpeed;
            this.isCanMove = true;
            this.KRoleState = RoleState.Stand;
            if (this.KRoleCondition == PlayerCondition.FoeRed) {
                Laya.timer.frameLoop(10, this, this.CheckFBDir);
            }
        }
        ClearEffectInRole() {
            if (this.EffectModel) {
                this.EffectModel.removeSelf();
                this.EffectModel.destroy();
                this.EffectModel = null;
            }
        }
        RoleCutSpeed() {
            this.MoveSpeed = this.isRedRole ? (this.redSpeed - 1) : (this.blueSpeed - 1);
        }
        stopMove() {
            this.kMoveDir.setValue(0, 0, 0);
            this.kCharcter.move(new Laya.Vector3(0, 0, 0));
        }
        move(dir) {
            this.KRoleState = RoleState.Walk;
            dir.cloneTo(this.kMoveDir);
        }
        MoveChar() {
            if (this.isCanMove && !this.IsChase) {
                this.mModel.transform.rotation = this.mModel.transform.rotation;
                if (this.isCrawl || this.isLaddering) {
                    this.setState(ECharacterAniState.RunFloor);
                } else {
                    if (this.mAnimState == ECharacterAniState.Jump || this.mAnimState == ECharacterAniState.JumpOne) {} else {
                        this.setState(ECharacterAniState.Run);
                    }
                }
                let targetPos = this.getPatrolTargetPos;
                if (Laya.Vector3.distanceSquared(targetPos, this.position) < 1) {
                    this.changePatrolTargetPos();
                    targetPos = this.getPatrolTargetPos;
                }
                let dir = Vec3Ext.Sub(targetPos, this.position);
                dir = Vec3Ext.Normalize(dir);
                this.move(dir);
                var speed = Vec3Ext.Scale(this.kMoveDir, this.MoveSpeed * GameMain.Ins.delta);
                this.kCharcter.move(speed);
                this.model.transform.position = this.position;
                if (!this.isCrawl && !this.isLaddering && !this.InJumpAir) {
                    this.lookAtTarget(this.getPatrolTargetPos);
                } else {}
            }
        }
        setPatrol(points) {
            if (!points || points.length == 0)
                return;
            this.kTargetPos = points;
            this.position = points[0];
            this.kTargetPatrolIndex = 1;
        }
        changePatrolTargetPos() {
            if (this.isCrawl) {
                this.isCrawl = false;
                this.kCharcter.gravity = this.FallGra;
            }
            this.kTargetPatrolIndex = (this.kTargetPatrolIndex + 1) % this.kTargetPos.length;
            return this.kTargetPos[this.kTargetPatrolIndex];
        }
        get getPatrolTargetPos() {
            return this.kTargetPos[this.kTargetPatrolIndex];
        }
        get isReachTarget() {
            if (Laya.Vector3.distanceSquared(this.getPatrolTargetPos, this.position) < 1) {
                return true;
            }
            return false;
        }
        get isInit() {
            if (this.mAnimState == ECharacterAniState.None) {
                return false;
            }
            return true;
        }
        onUpdate() {
            if (!this.model) {
                return;
            }
            if (!this.isInit || this.isLie || this.KRoleState == RoleState.Die || this.mAnimState == ECharacterAniState.Victory || this.mAnimState == ECharacterAniState.VictoryBlue) {
                return;
            }
            if (CplayerManager.ins.IsGameOver) {
                return;
            }
            if (this.KRoleCondition == PlayerCondition.PlayerBlue) {
                switch (this.mAnimState) {
                    case ECharacterAniState.LieOn:
                        let Anistate = this.getCurAniPlayState();
                        if (Anistate.animatorState.name == ECharacterAniState.LieOn && Anistate.normalizedTime >= 1) {
                            this.PlayAnim(ECharacterAniState.LieUP);
                            return;
                        }
                    case ECharacterAniState.LieUP:
                        let kkAnistate = this.getCurAniPlayState();
                        if (kkAnistate.animatorState.name == ECharacterAniState.LieUP && kkAnistate.normalizedTime >= 1) {
                            this.setState(ECharacterAniState.StandOne);
                        }
                        return;
                    default:
                        break;
                }
            } else {
                if (this.IsUping) {
                    if (this.KRoleCondition == PlayerCondition.FoeRed) {
                        this.IsCURTIMER++;
                        if (this.IsCURTIMER < 3) {
                            return;
                        }
                        let kkKAnistate = this.getCurAniPlayState();
                        if (kkKAnistate.animatorState.name == ECharacterAniState.LieUP && kkKAnistate.normalizedTime >= 1) {
                            this.setState(ECharacterAniState.StandOne);
                            this.IsUping = false;
                        }
                        return;
                    }
                }
            }
            if (CplayerManager.ins.IsEnd && this.model.transform.position.y <= 0) {
                CplayerManager.ins.UninitOneRole(this);
            }
            if (!this.isCrawl) {
                if (this.isCrawl || this.isLaddering) {
                    this.kCharcter.gravity = new Laya.Vector3(0, (this.MoveSpeed / 3) * GameMain.Ins.delta, 0);
                } else {
                    this.kCharcter.gravity = this.FallGra;
                }
            }
            this.MoveChar();
            if (CplayerManager.ins.IsEnd && this.KRoleCondition == PlayerCondition.FoeRed) {
                this.MoveSpeed = this.redSpeed;
            }
            if (!CplayerManager.ins.IsEnd && this.CheckRole()) {
                let dis = Laya.Vector3.distanceSquared(this.position, this.BlueTarEtiny.position);
                if (dis < 1.5) {
                    if (this.BlueLastOne) {
                        return;
                    }
                    if (this.CheckLastOne == 1) {
                        this.BlueTarEtiny.stopMove();
                        this.BlueTarEtiny.setState(ECharacterAniState.Die);
                        this.BlueTarEtiny.KRoleState = RoleState.Die;
                        this.BlueTarEtiny.model.getComponent(Laya.CharacterController).enabled = false;
                        for (let i = 0; i < CplayerManager.ins.mRoleEnity.length; i++) {
                            const element = CplayerManager.ins.mRoleEnity[i];
                            element.BlueLastOne = true;
                        }
                        GEvent.Ins.event(GCamEvent.kFail);
                        CplayerManager.ins.GameORed(this.BlueTarEtiny);
                        return;
                    }
                    let index = CplayerManager.ins.mRoleEnity.indexOf(this.BlueTarEtiny);
                    CplayerManager.ins.mRoleEnity[index].KRoleCondition = PlayerCondition.FoeRed;
                    this.BlueTarEtiny.KRoleCondition = PlayerCondition.FoeRed;
                    this.BlueTarEtiny.roleMaterial.albedoColor = this.redMAlbeColor;
                    this.BlueTarEtiny.IsCanInfect = false;
                    Laya.timer.once(500, this, () => {
                        if (this.BlueTarEtiny) {
                            this.BlueTarEtiny.IsCanInfect = true;
                            this.BlueTarEtiny = null;
                        }
                    });
                    this.MoveSpeed = this.redSpeed;
                    this.IsChase = false;
                }
            }
            CplayerManager.ins.checkLieRole(this);
            if (this.IsJumpAirPlane && !this.InJumpAir) {
                if (this.KRoleCondition == PlayerCondition.FoeRed) {
                    this.MoveSpeed = 10;
                    this.kCharcter.gravity = this.FallGra;
                    this.PlayAnim(ECharacterAniState.Jump);
                } else {
                    this.stopMove();
                    this.PlayAnim(ECharacterAniState.JumpOne);
                    this.model.getComponent(Laya.CharacterController).enabled = false;
                    let rDistance = Vec3Ext.Distance(HomeScene.instance.mLevel.mAirplane.RolePosition, this.position);
                    this.flyTime = rDistance * 1000 / 8;
                    this.CurTimer = Laya.timer.currTimer;
                    TweenExt.PWXTo(this.model, HomeScene.instance.mLevel.mAirplane.RolePosition, false, rDistance / 4, this.flyTime, null);
                    Laya.timer.once(this.flyTime, this, () => {
                        CplayerManager.ins.InAirPlaneNum++;
                        this.JumpCom();
                        let rolePos = new Laya.Vector3();
                        let pos = this.position.clone();
                        CameraEntity.mCamera.viewport.project(pos, CameraEntity.mCamera.projectionViewMatrix, rolePos);
                        rolePos.x /= Laya.stage.clientScaleX;
                        rolePos.y /= Laya.stage.clientScaleX;
                        Emoji.Show(rolePos.x, rolePos.y);
                    });
                }
                this.InJumpAir = true;
                var k = 0;
            }
            if (this.InJumpAir) {
                k++;
                if (k < 3) {
                    return;
                }
                let Anistate = this.getCurAniPlayState();
                if (Anistate.animatorState.name == ECharacterAniState.JumpOne && Anistate.normalizedTime >= 0.8) {
                    if (this.KRoleCondition == PlayerCondition.FoeRed) {} else {
                        if (Laya.timer.currTimer - this.CurTimer >= this.flyTime) {
                            this.CurTimer = Laya.timer.currTimer;
                            this.PlayAnim(ECharacterAniState.VictoryBlue);
                        }
                    }
                }
            }
        }
        JumpCom() {
            HomeScene.instance.mLevel.mAirplane.mPoint.addChild(this.model);
            let x = Math.random() * 1.3 * (Math.random() > 0.5 ? 1 : -1);
            let z = Math.random() * 1.3 * (Math.random() > 0.5 ? 1 : -1);
            this.model.transform.localPosition = new Laya.Vector3(x, 0, z);
            this.model.transform.localRotationEuler = new Laya.Vector3(0, 180, 0);
            this.PlayAnim(ECharacterAniState.VictoryBlue);
        }
        CheckFBDir() {
            if (CplayerManager.ins.IsEnd) {
                return;
            }
            if (this.isCrawl) {
                return;
            }
            if (this.isLaddering) {
                return;
            }
            let A = CplayerManager.ins.mRoleEnity.length;
            let BlueRoty = [];
            let RedRoty = [];
            for (let q = 0; q < A; q++) {
                const element = CplayerManager.ins.mRoleEnity[q];
                if (!element.isLie) {
                    if (element.KRoleCondition == PlayerCondition.FoeRed) {
                        RedRoty.push(element);
                    } else {
                        BlueRoty.push(element);
                    }
                }
            }
            if (this.KRoleCondition == PlayerCondition.FoeRed) {
                for (let v = 0; v < BlueRoty.length; v++) {
                    const A = BlueRoty[v];
                    let dis = Vec3Ext.DistanceSquared(this.position, A.position);
                    if (this.position.y < A.position.y) {
                        return;
                    }
                    if (dis < 20) {
                        let dirEc = Vec3Ext.Sub(A.position, this.position);
                        let KK = Laya.Vector3.dot(this.FowardPos, dirEc);
                        if (KK < 0) {
                            if (this.BlueLastOne || !this.IsCanInfect) {
                                return;
                            }
                            if (this.KRoleCondition == PlayerCondition.FoeRed) {
                                for (let i = 0; i < CplayerManager.ins.mRoleEnity.length; i++) {
                                    const element = CplayerManager.ins.mRoleEnity[i];
                                    if (element.KRoleCondition == PlayerCondition.PlayerBlue && element.KRoleState != RoleState.Die && !element.isLie) {
                                        this.MoveSpeed = this.redSpeed + 1;
                                        this.BlueTarEtiny = element;
                                        this.IsChase = true;
                                        let targetPos = this.getPatrolTargetPos;
                                        let dis = Vec3Ext.DistanceSquared(targetPos, this.position);
                                        if (dis < 1) {
                                            this.changePatrolTargetPos();
                                            targetPos = this.getPatrolTargetPos;
                                            return;
                                        }
                                        if (this.IsChase) {
                                            let dir = Vec3Ext.Sub(this.BlueTarEtiny.position, this.position);
                                            dir = Vec3Ext.Normalize(dir);
                                            this.move(dir);
                                            var speed = Vec3Ext.Scale(this.kMoveDir, this.MoveSpeed * GameMain.Ins.delta);
                                            this.kCharcter.move(speed);
                                            this.model.transform.position = this.position;
                                            if (!this.isCrawl && !this.isLaddering) {
                                                this.lookAtTarget(this.BlueTarEtiny.position);
                                            }
                                            let disA = Laya.Vector3.distanceSquared(this.position, this.BlueTarEtiny.position);
                                            if (disA < 1.5) {
                                                if (this.CheckLastOne == 1) {
                                                    this.BlueTarEtiny.stopMove();
                                                    this.BlueTarEtiny.setState(ECharacterAniState.Die);
                                                    this.BlueTarEtiny.KRoleState = RoleState.Die;
                                                    this.BlueTarEtiny.model.getComponent(Laya.CharacterController).enabled = false;
                                                    for (let i = 0; i < CplayerManager.ins.mRoleEnity.length; i++) {
                                                        const element = CplayerManager.ins.mRoleEnity[i];
                                                        element.BlueLastOne = true;
                                                    }
                                                    GEvent.Ins.event(GCamEvent.kFail);
                                                    CplayerManager.ins.GameORed(this.BlueTarEtiny);
                                                    return;
                                                }
                                                let index = CplayerManager.ins.mRoleEnity.indexOf(this.BlueTarEtiny);
                                                CplayerManager.ins.mRoleEnity[index].KRoleCondition = PlayerCondition.FoeRed;
                                                this.BlueTarEtiny.KRoleCondition = PlayerCondition.FoeRed;
                                                this.BlueTarEtiny.roleMaterial.albedoColor = this.redMAlbeColor;
                                                this.BlueTarEtiny.IsCanInfect = false;
                                                Laya.timer.once(500, this, () => {
                                                    if (this.BlueTarEtiny) {
                                                        this.BlueTarEtiny.IsCanInfect = true;
                                                        this.BlueTarEtiny = null;
                                                    }
                                                });
                                                this.MoveSpeed = this.redSpeed;
                                                this.IsChase = false;
                                            }
                                        }
                                    }
                                }
                            }
                        } else {}
                    } else {}
                }
            }
        }
        setState(state) {
            if (this.mAnimState == state)
                return;
            switch (state) {
                case ECharacterAniState.StandOne:
                    this.stopMove();
                    this.PlayAnim(ECharacterAniState.StandOne);
                    break;
                case ECharacterAniState.StandTwo:
                    this.stopMove();
                    this.PlayAnim(ECharacterAniState.StandTwo);
                    break;
                case ECharacterAniState.DieFall:
                    this.PlayAnim(ECharacterAniState.DieFall);
                    break;
                case ECharacterAniState.DieFloorWallFall:
                    this.PlayAnim(ECharacterAniState.DieFloorWallFall);
                    break;
                case ECharacterAniState.Run:
                    this.PlayAnim(ECharacterAniState.Run);
                    break;
                case ECharacterAniState.RunFloor:
                    this.PlayAnim(ECharacterAniState.RunFloor);
                    break;
                case ECharacterAniState.Attack:
                    this.PlayAnim(ECharacterAniState.Attack);
                    break;
                case ECharacterAniState.Die:
                    this.PlayAnim(ECharacterAniState.Die);
                    break;
                case ECharacterAniState.DieFly:
                    this.PlayAnim(ECharacterAniState.DieFly);
                    break;
                case ECharacterAniState.Victory:
                    this.PlayAnim(ECharacterAniState.Victory);
                    break;
                case ECharacterAniState.VictoryBlue:
                    this.PlayAnim(ECharacterAniState.VictoryBlue);
                    break;
                case ECharacterAniState.Jump:
                    this.PlayAnim(ECharacterAniState.Jump);
                case ECharacterAniState.LieDown:
                    this.PlayAnim(ECharacterAniState.LieDown);
                case ECharacterAniState.LieUP:
                    this.PlayAnim(ECharacterAniState.LieUP);
                case ECharacterAniState.LieOn:
                    this.PlayAnim(ECharacterAniState.LieOn);
                    break;
                default:
                    break;
            }
            this.mAnimState = state;
        }
        get CheckLastOne() {
            let num = 0;
            for (let i = 0; i < CplayerManager.ins.mRoleEnity.length; i++) {
                let element = CplayerManager.ins.mRoleEnity[i];
                if (element.KRoleCondition == PlayerCondition.PlayerBlue) {
                    if (this.KRoleState == 0 || this.KRoleState == 1) {
                        if (!element.isLie) {
                            num++;
                        }
                    }
                }
            }
            return num;
        }
        CheckRole() {
            if (this.BlueLastOne || !this.IsCanInfect) {
                return;
            }
            if (this.KRoleCondition == PlayerCondition.FoeRed) {
                for (let i = 0; i < CplayerManager.ins.mRoleEnity.length; i++) {
                    const element = CplayerManager.ins.mRoleEnity[i];
                    if (element.KRoleCondition == PlayerCondition.PlayerBlue && element.KRoleState != RoleState.Die && !element.isLie) {
                        let dis = Vec3Ext.DistanceSquared(this.position, element.position);
                        if (dis < 6) {
                            this.MoveSpeed = this.redSpeed + 1;
                            this.BlueTarEtiny = element;
                            this.IsChase = true;
                            let targetPos = this.getPatrolTargetPos;
                            let dis = Vec3Ext.DistanceSquared(targetPos, this.position);
                            if (dis < 1) {
                                this.changePatrolTargetPos();
                                targetPos = this.getPatrolTargetPos;
                                return;
                            }
                            if (this.IsChase) {
                                let dir = Vec3Ext.Sub(this.BlueTarEtiny.position, this.position);
                                dir = Vec3Ext.Normalize(dir);
                                this.move(dir);
                                var speed = Vec3Ext.Scale(this.kMoveDir, this.MoveSpeed * GameMain.Ins.delta);
                                this.kCharcter.move(speed);
                                this.model.transform.position = this.position;
                                if (!this.isCrawl && !this.isLaddering) {
                                    this.lookAtTarget(this.BlueTarEtiny.position);
                                }
                                return element;
                            }
                        } else {
                            this.IsChase = false;
                        }
                    }
                }
            }
            return null;
        }
        onDie(_num) {
            switch (_num) {
                case 1:
                    if (this.KRoleCondition == PlayerCondition.FoeRed) {
                        if (this.isCrawl || this.isLaddering) {
                            this.setState(ECharacterAniState.DieFloorWallFall);
                        } else {
                            this.setState(ECharacterAniState.Die);
                        }
                    } else {
                        return;
                    }
                    break;
                case 2:
                    if (this.KRoleCondition == PlayerCondition.FoeRed) {
                        this.setState(ECharacterAniState.DieFly);
                    } else {
                        this.setState(ECharacterAniState.LieOn);
                        this.stopMove();
                        return;
                    }
                    break;
                case 3:
                    this.setState(ECharacterAniState.Die);
                    break;
                default:
                    break;
            }
            this.roleMaterial.albedoColor = this.DieMAlbeColor;
            this.KRoleState = RoleState.Die;
            if (!CplayerManager.ins.IsEnd) {
                let rolePos = new Laya.Vector3();
                let pos = this.position.clone();
                CameraEntity.mCamera.viewport.project(pos, CameraEntity.mCamera.projectionViewMatrix, rolePos);
                rolePos.x /= Laya.stage.clientScaleX;
                rolePos.y /= Laya.stage.clientScaleX;
                DieTip.Show(rolePos.x, rolePos.y);
            }
            this.kCharcter.gravity = this.FallGra;
            this.kCharcter.fallSpeed = 5;
            this.stopMove();
            if (!this.isCrawl && !this.InJumpAir) {
                this.model.getComponent(Laya.CharacterController).enabled = false;
            } else {
                let dir = Vec3Ext.Normalize(this.BackFowardPos);
                dir.y *= -5;
                var speed = Vec3Ext.Scale(dir, this.MoveSpeed * GameMain.Ins.delta);
                this.kCharcter.move(speed);
            }
            if (this.KRoleCondition == PlayerCondition.FoeRed) {
                CplayerManager.ins.DieRedRoleNum++;
            }
            CplayerManager.ins.UninitOneRole(this);
        }
        get BackFowardPos() {
            let foward = new Laya.Vector3();
            this.mModel.transform.getForward(foward);
            Laya.Vector3.scale(foward, 1, foward);
            let tarGetPos = Vec3Ext.Add(this.position, foward);
            return tarGetPos;
        }
        get FowardPos() {
            let foward = new Laya.Vector3();
            this.mModel.transform.getForward(foward);
            Laya.Vector3.scale(foward, -1, foward);
            return foward;
        }
        ContineMove() {
            let targetPos = this.getPatrolTargetPos;
            if (Laya.Vector3.distanceSquared(targetPos, this.position) < 1) {
                this.changePatrolTargetPos();
            }
            let dir = new Laya.Vector3();
            Laya.Vector3.subtract(targetPos, this.position, dir);
            this.move(dir);
            this.setState(ECharacterAniState.Run);
        }
        onTriggerEnter(c) {
            if (c.collisionGroup == CollisionConfig.kBarrierGroup) {
                let barrier = c.owner.getComponent(BarrierScript);
                let action = barrier.GetTriggerAction(this);
                switch (action) {
                    case EBarrierCollisionAction.Die:
                        this.onDie(2);
                        break;
                    case EBarrierCollisionAction.Drop:
                        CplayerManager.ins.UninitOneRole(this);
                        this.roleMaterial.albedoColor = this.DieMAlbeColor;
                        this.KRoleState = RoleState.Die;
                        let num = 0;
                        for (let index = 0; index < CplayerManager.ins.mRoleEnity.length; index++) {
                            const element = CplayerManager.ins.mRoleEnity[index];
                            if (element.KRoleCondition == PlayerCondition.PlayerBlue && !element.isLie) {
                                num++;
                            }
                        }
                        if (this.KRoleCondition == PlayerCondition.PlayerBlue) {
                            if (num == 1) {
                                GEvent.Ins.event(GCamEvent.kFail);
                            }
                        }
                        if (this.KRoleCondition == PlayerCondition.FoeRed) {
                            let rolePos = new Laya.Vector3();
                            let pos = this.position.clone();
                            CameraEntity.mCamera.viewport.project(pos, CameraEntity.mCamera.projectionViewMatrix, rolePos);
                            rolePos.x /= Laya.stage.clientScaleX;
                            rolePos.y /= Laya.stage.clientScaleX;
                            DieTip.Show(rolePos.x, rolePos.y);
                            CplayerManager.ins.DieRedRoleNum++;
                        }
                        break;
                    case EBarrierCollisionAction.Pass:
                        CplayerManager.ins.TeamContinueMove();
                        break;
                    case EBarrierCollisionAction.TeamStop:
                        CplayerManager.ins.TeamStop();
                        this.setState(ECharacterAniState.StandTwo);
                        break;
                    case EBarrierCollisionAction.None:
                        break;
                    default:
                        console.error("TODO 新的障碍物碰撞事件");
                        break;
                }
            }
        }
        onCollisionEnter(c) {
            this.onTriggerEnter(c.other);
        }
        onDestroy() {
            Laya.timer.clearAll(this);
        }
    }

    class AreaCollider extends Laya.Script3D {
        onInit() {}
        constructor() {
            super();
            setTimeout(() => {
                let rCollider = (this.owner.getComponent(Laya.PhysicsCollider));
                rCollider.collisionGroup = CollisionConfig.kAreaGroup;
            }, 100);
        }
        onTriggerEnter(e) {
            if (this.owner.name.slice(0, 3) == "Col") {
                if (e.owner.name == 'Character') {
                    let CplayerSpt = e.owner.getComponent(Cplayer);
                    if (!CplayerSpt)
                        return;
                    if (CplayerSpt.KRoleCondition == PlayerCondition.PlayerBlue && !CplayerSpt.isLie) {
                        let AB = this.owner.name;
                        let CC = AB.slice(AB.length - 1);
                        let A = this.owner.getComponent(Laya.PhysicsCollider);
                        A.enabled = false;
                        for (let q = 0; q < CplayerManager.ins.RedHouse.numChildren; q++) {
                            const element = CplayerManager.ins.RedHouse.getChildAt(q);
                            let A = element.name;
                            if (A.slice(A.length - 1) == CC) {
                                CplayerManager.ins.PlayRedMAni(element);
                            }
                        }
                        Laya.timer.once(1300, this, () => {
                            for (let i = 0; i < 1; i++) {
                                CplayerManager.ins.CreatRole(true, (parseInt(CC) - 1));
                            }
                        });
                    }
                }
            } else if (this.owner.name.slice(0, 6) == "CraCol") {
                let CplayerSpt = e.owner.getComponent(Cplayer);
                if (!CplayerSpt)
                    return;
                if (CplayerSpt.KRoleCondition == PlayerCondition.PlayerBlue && !CplayerSpt.isLie) {
                    let AB = this.owner.name;
                    let CC = AB.slice(AB.length - 1);
                    let B = this.owner.getComponent(Laya.PhysicsCollider);
                    B.enabled = false;
                    CplayerManager.ins.CurRedCraBirth = CplayerManager.ins.redCrawlBirthNode.getChildAt((parseInt(CC) - 1));
                    let AngleNode = (this.owner.getChildAt(0));
                    let Angle;
                    if (AngleNode)
                        Angle = parseInt(AngleNode.name);
                    CplayerManager.ins.CreatLieAndRole(true, true, false, Angle);
                }
            } else {
                let CplayerSpt = e.owner.getComponent(Cplayer);
                if (!CplayerSpt)
                    return;
                switch (this.owner.name) {
                    case "EndCol":
                        CplayerManager.ins.IsEnd = true;
                        if (CplayerSpt.KRoleCondition == PlayerCondition.FoeRed) {
                            CplayerSpt.MoveSpeed = CplayerSpt.blueSpeed;
                        } else {
                            CplayerSpt.MoveSpeed = CplayerSpt.blueSpeed + 2;
                        }
                        if (!CplayerManager.ins.IsScale) {
                            Laya.timer.scale = 0.4;
                            CplayerManager.ins.IsScale = true;
                            Laya.timer.once(700, this, () => {
                                Laya.timer.scale = 1;
                            });
                        }
                        break;
                    case "JumpCol":
                        CplayerSpt.IsJumpAirPlane = true;
                        break;
                    case "LadCol":
                        CplayerSpt.isLaddering = true;
                        break;
                    case "LieCol":
                        if (CplayerSpt.KRoleCondition == PlayerCondition.PlayerBlue && !CplayerSpt.isLie) {
                            let A = this.owner.getComponent(Laya.PhysicsCollider);
                            A.enabled = false;
                            CplayerManager.ins.checkLieRole();
                        }
                        break;
                    default:
                        break;
                }
            }
        }
        onTriggerStay(e) {}
        onTriggerExit(e) {
            let A = this.owner.name.slice(0, 3);
            switch (A) {
                case "Cra":
                    let CplayerSpt1 = e.owner.getComponent(Cplayer);
                    CplayerSpt1.isCrawling = false;
                    break;
                case "Lad":
                    let CplayerSpt2 = e.owner.getComponent(Cplayer);
                    CplayerSpt2.isLaddering = false;
                    break;
                default:
                    break;
            }
        }
    }

    class CplayerManager {
        constructor() {
            this.IsScale = false;
            this.mRoleEnity = [];
            this.ColEnity = [];
            this.IsInited = false;
            this.redMAlbeColor = new Laya.Vector4(1, 0, 0, 1);
            this.blueMAlbeColor = new Laya.Vector4(9 / 255, 136 / 255, 203 / 255, 1);
            this.blueLieAlbeColor = new Laya.Vector4(99 / 255, 210 / 255, 1, 1);
            this.IsEnd = false;
            this.RedBirthNodes = [];
            this.InAirPlaneNum = 0;
            this.CurBlueNum = 0;
            this.AirFly = false;
            this.StartAirFly = false;
            this.IsGameOver = false;
            this.DieRedRoleNum = 0;
            this.LeastBlueRoleNum = 0;
        }
        UninitOneRole(_kRole) {
            let index = this.mRoleEnity.indexOf(_kRole);
            this.mRoleEnity.splice(index, 1);
            Laya.timer.once(3000, this, () => {
                _kRole.onUninit();
            });
        }
        onInit(_mlevelSp3D) {
            CplayerManager.ins = this;
            this.mLevelSpr3D = _mlevelSp3D;
            this.blueHouse = this.mLevelSpr3D.getChildAt(0).getChildByName("BlueHouse");
            this.RedHouse = this.mLevelSpr3D.getChildAt(0).getChildByName("RedHouse");
            let BirthPointNode = this.mLevelSpr3D.getChildByName("BirthPoint");
            this.BlueBirthNode = BirthPointNode.getChildByName("BlueBirth");
            let LieBirthPointNode = this.mLevelSpr3D.getChildByName("LieBirthPoint");
            this.blueLieBirth = LieBirthPointNode.getChildByName("BlueBirth");
            this.redLieBirth = LieBirthPointNode.getChildByName("RedBirth");
            this.redCrawlBirthNode = this.mLevelSpr3D.getChildByName("CrawlBirth");
            let numA = BirthPointNode.numChildren;
            for (let index = 1; index < numA; index++) {
                const element = BirthPointNode.getChildAt(index);
                this.RedBirthNodes.push(element);
            }
            let ColNode = this.mLevelSpr3D.getChildByName("ColBox");
            let numB = ColNode.numChildren;
            for (let i = 0; i < numB; i++) {
                let colSpr = ColNode.getChildAt(i);
                let CollIderSpt = new AreaCollider();
                colSpr.addComponentIntance(CollIderSpt);
                this.ColEnity.push(CollIderSpt);
            }
            this.EndColNode = this.mLevelSpr3D.getChildByName("EndNode").getChildAt(0);
            let EndCollIderSpt = new AreaCollider();
            this.EndColNode.addComponentIntance(EndCollIderSpt);
            this.ColEnity.push(EndCollIderSpt);
            this.JumpColNode = this.mLevelSpr3D.getChildByName("JumoNode").getChildAt(0);
            let JumpCollIderSpt = new AreaCollider();
            this.JumpColNode.addComponentIntance(JumpCollIderSpt);
            this.ColEnity.push(JumpCollIderSpt);
            this.CrawlColNode = this.mLevelSpr3D.getChildByName("CraNode");
            for (let K = 0; K < this.CrawlColNode.numChildren; K++) {
                const element = this.CrawlColNode.getChildAt(K);
                let CrawlCollIderSpt = new AreaCollider();
                element.addComponentIntance(CrawlCollIderSpt);
                this.ColEnity.push(CrawlCollIderSpt);
            }
            this.LieColNode = this.mLevelSpr3D.getChildByName("LieRoleCol").getChildAt(0);
            if (this.LieColNode) {
                let LieCollIderSpt = new AreaCollider();
                this.LieColNode.addComponentIntance(LieCollIderSpt);
                this.ColEnity.push(LieCollIderSpt);
            }
            let ladCol = this.mLevelSpr3D.getChildByName("LadCol");
            if (ladCol) {
                for (let index = 0; index < ladCol.numChildren; index++) {
                    const element = ladCol.getChildAt(index);
                    let LadCollIderSpt = new AreaCollider();
                    element.addComponentIntance(LadCollIderSpt);
                    this.ColEnity.push(LadCollIderSpt);
                }
            }
            this.IsInited = true;
        }
        PlayBlueMAni() {
            let anima = this.blueHouse.getChildAt(0).getComponent(Laya.Animator);
            anima.play("mendakai", 0, 0);
        }
        PlayRedMAni(_redHosueNode) {
            let anima = _redHosueNode.getChildAt(0).getComponent(Laya.Animator);
            anima.play("men_qiaomendaodi", 0, 0);
        }
        OnCheckAroundRole(rDistance, rTarget) {
            let rVecList = [];
            for (const kRole of this.mRoleEnity) {
                let rDis = Laya.Vector3.distance(rTarget, kRole.position);
                if (rDis <= rDistance) {
                    rVecList.push({
                        Role: kRole,
                        Distance: rDis
                    });
                }
            }
            return rVecList;
        }
        get TargetCameraPos() {
            let BlueRoleEntity = [];
            for (let index = 0; index < this.mRoleEnity.length; index++) {
                const element = this.mRoleEnity[index];
                if (element.KRoleCondition == PlayerCondition.PlayerBlue) {
                    if (!element.isLie) {
                        BlueRoleEntity.push(element);
                    }
                }
            }
            if (!BlueRoleEntity || BlueRoleEntity.length <= 0)
                return null;
            return BlueRoleEntity[0].position;
        }
        GameORed(_target) {
            for (let i = 0; i < this.mRoleEnity.length; i++) {
                const element = this.mRoleEnity[i];
                if (element != _target) {
                    let dis = Vec3Ext.DistanceSquared(element.position, _target.position);
                    if (dis < 20) {
                        element.PlayAnim(ECharacterAniState.Attack);
                    } else {
                        element.PlayAnim(ECharacterAniState.StandTwo);
                    }
                    element.stopMove();
                }
            }
            this.IsGameOver = true;
        }
        ChecKGameOver() {
            let BlueRoleEntity = [];
            let num = 0;
            for (let index = 0; index < this.mRoleEnity.length; index++) {
                const element = this.mRoleEnity[index];
                if (element.KRoleCondition == PlayerCondition.PlayerBlue) {
                    BlueRoleEntity.push(element);
                }
            }
            if (this.mRoleEnity[1].KRoleCondition == PlayerCondition.FoeRed) {
                return true;
            }
            for (let i = 0; i < this.mRoleEnity.length; i++) {
                const AA = this.mRoleEnity[i];
                if (AA.KRoleCondition == PlayerCondition.PlayerBlue) {
                    num++;
                }
            }
            if (num == 1) {
                return true;
            }
            return false;
        }
        CreatLieAndRole(_isRedRole, _isCrawl, _isLie, _Angle) {
            let E;
            E = _isRedRole ? this.redLieBirth : this.blueLieBirth;
            if (_isCrawl) {
                E = this.CurRedCraBirth;
            }
            let A = 0;
            if (E) {
                A = E.numChildren;
            }
            for (let i = 0; i < A; i++) {
                const element = E.getChildAt(i);
                let RoleModel = ObjectPoolManager.Instance.getItem("Character");
                this.mLevelSpr3D.addChild(RoleModel);
                let Materila = (RoleModel.getChildAt(0).getChildAt(1)).skinnedMeshRenderer.material;
                Materila.albedoColor = _isRedRole ? this.redMAlbeColor : this.blueLieAlbeColor;
                if (_Angle)
                    RoleModel.transform.localRotationEulerY = -_Angle;
                RoleModel.transform.position = element.getChildAt(0).transform.position;
                let rRoleEnity = new Cplayer();
                RoleModel.addComponentIntance(rRoleEnity);
                rRoleEnity.OnInit(element, _isRedRole, _isLie, _isCrawl);
                this.mRoleEnity.push(rRoleEnity);
            }
        }
        CreatRole(_isRedRole, redBirthIndex) {
            let B;
            B = _isRedRole ? this.RedBirthNodes[redBirthIndex] : this.BlueBirthNode;
            let A = B.numChildren;
            let C;
            if (!_isRedRole) {
                var D = [];
                for (let q = 0; q < A; q++) {
                    D.push(q);
                }
                C = this.RandGetArrN(D);
                A = C.length;
            }
            let KK = _isRedRole ? (A + 10) : A;
            if (_isRedRole == true && KK > 20) {
                KK = 20;
            }
            for (let i = 0; i < KK; i++) {
                Laya.timer.once(300 * i, this, (NodeB) => {
                    let Q = i;
                    if (_isRedRole) {
                        if (i < A) {
                            Q = i;
                        } else {
                            Q = i - A;
                        }
                    }
                    let element;
                    if (!_isRedRole) {
                        element = NodeB.getChildAt(D[i]);
                    } else {
                        element = NodeB.getChildAt(Q);
                    }
                    if (!element) {
                        return;
                    }
                    let RoleModel = ObjectPoolManager.Instance.getItem("Character");
                    let AASS = RoleModel.getComponent(Cplayer);
                    if (AASS) {
                        AASS.destroy();
                    }
                    this.mLevelSpr3D.addChild(RoleModel);
                    let Materila = (RoleModel.getChildAt(0).getChildAt(1)).skinnedMeshRenderer.material;
                    Materila.albedoColor = _isRedRole ? this.redMAlbeColor : this.blueMAlbeColor;
                    RoleModel.transform.position = element.getChildAt(0).transform.position;
                    let rRoleEnity = new Cplayer();
                    RoleModel.addComponentIntance(rRoleEnity);
                    rRoleEnity.OnInit(element, _isRedRole, false, false);
                    this.mRoleEnity.push(rRoleEnity);
                }, [B], false);
            }
        }
        CreatRoleByCustom(_isRedRole, pathpoint, position, localScale, MoveSpeed, Color) {
            let RoleModel = ObjectPoolManager.Instance.getItem("Character");
            let AASS = RoleModel.getComponent(Cplayer);
            if (AASS) {
                AASS.destroy();
            }
            this.mLevelSpr3D.addChild(RoleModel);
            let Materila = (RoleModel.getChildAt(0).getChildAt(1)).skinnedMeshRenderer.material;
            Materila.albedoColor = Color;
            RoleModel.transform.position = position;
            RoleModel.transform.localScale = localScale;
            let rRoleEnity = new Cplayer();
            RoleModel.addComponentIntance(rRoleEnity);
            rRoleEnity.OnInit1(pathpoint, _isRedRole, false, false, MoveSpeed);
            this.mRoleEnity.push(rRoleEnity);
        }
        checkLieRole(_CplayerSpt) {
            if (_CplayerSpt && _CplayerSpt.KRoleCondition == PlayerCondition.PlayerBlue && !_CplayerSpt.isLie) {
                let A = CplayerManager.ins.mRoleEnity.length;
                for (let i = 0; i < A; i++) {
                    const element = CplayerManager.ins.mRoleEnity[i];
                    if (element.isLie && element.KRoleCondition == PlayerCondition.PlayerBlue) {
                        let dis = Vec3Ext.DistanceSquared(element.position, _CplayerSpt.position);
                        if (dis < 4) {
                            _CplayerSpt.MoveSpeed = _CplayerSpt.blueSpeed;
                            _CplayerSpt.BlueTarEtiny = element;
                            _CplayerSpt.IsChase = true;
                            let targetPos = _CplayerSpt.getPatrolTargetPos;
                            let disaa = Vec3Ext.DistanceSquared(targetPos, _CplayerSpt.position);
                            if (disaa < 1) {
                                _CplayerSpt.changePatrolTargetPos();
                                targetPos = _CplayerSpt.getPatrolTargetPos;
                                return;
                            }
                            if (_CplayerSpt.IsChase) {
                                let dir = Vec3Ext.Sub(_CplayerSpt.BlueTarEtiny.position, _CplayerSpt.position);
                                dir = Vec3Ext.Normalize(dir);
                                _CplayerSpt.move(dir);
                                var speed = Vec3Ext.Scale(_CplayerSpt.kMoveDir, _CplayerSpt.MoveSpeed * GameMain.Ins.delta);
                                _CplayerSpt.kCharcter.move(speed);
                                _CplayerSpt.model.transform.position = _CplayerSpt.position;
                                if (!_CplayerSpt.isCrawl && !_CplayerSpt.isLaddering) {
                                    _CplayerSpt.lookAtTarget(_CplayerSpt.BlueTarEtiny.position);
                                }
                            }
                            if (dis < 1.5) {
                                element.ClearEffectInRole();
                                element.isLie = false;
                                element.roleMaterial.albedoColor = this.blueMAlbeColor;
                                element.IsChase = false;
                                element.MoveChar();
                                _CplayerSpt.MoveSpeed = _CplayerSpt.blueSpeed;
                                _CplayerSpt.IsChase = false;
                            } else {
                                _CplayerSpt.IsChase = false;
                            }
                        } else {
                            _CplayerSpt.IsChase = false;
                        }
                    }
                }
            }
            if (!_CplayerSpt) {
                let A = CplayerManager.ins.mRoleEnity.length;
                for (let i = 0; i < A; i++) {
                    const element = CplayerManager.ins.mRoleEnity[i];
                    if (element.isLie && element.KRoleCondition == PlayerCondition.FoeRed) {
                        element.ClearEffectInRole();
                        element.isLie = false;
                        element.IsUping = true;
                        element.PlayAnim(ECharacterAniState.LieUP);
                    }
                }
            }
        }
        onUpdate() {
            if (!this.IsInited) {
                return;
            }
            if (this.IsEnd) {
                if (!this.AirFly) {
                    for (let i = 0; i < this.mRoleEnity.length; i++) {
                        const element = this.mRoleEnity[i];
                        if (element.KRoleCondition == PlayerCondition.PlayerBlue && element.KRoleState != RoleState.Die && !element.isLie) {
                            this.CurBlueNum++;
                        }
                    }
                    this.AirFly = true;
                }
                if (!this.StartAirFly) {
                    if (this.CurBlueNum == this.InAirPlaneNum) {
                        this.StartAirFly = true;
                        Laya.timer.once(1000, this, () => {
                            if (HomeScene.instance.mLevel.mAirplane)
                                HomeScene.instance.mLevel.mAirplane.OnPlayAnimation();
                        });
                    }
                }
            }
        }
        AreaHurtRole(_bombPos, _bombAreaNum, hurtType = 2) {
            for (let i = this.mRoleEnity.length - 1; i >= 0; i--) {
                const element = this.mRoleEnity[i];
                let dis = Laya.Vector3.distanceSquared(element.position, _bombPos);
                if (dis < (_bombAreaNum * _bombAreaNum)) {
                    element.onDie(hurtType);
                    GEvent.Ins.event(GCamEvent.kRedPlayerDie);
                }
            }
        }
        TeamStop() {
            for (let i = 0; i < this.mRoleEnity.length; i++) {
                const element = this.mRoleEnity[i];
                if (element.KRoleCondition == PlayerCondition.PlayerBlue && !element.isLie) {
                    element.isCanMove = false;
                    element.PlayAnim(ECharacterAniState.StandTwo);
                    element.stopMove();
                }
            }
        }
        TeamContinueMove() {
            for (let i = 0; i < this.mRoleEnity.length; i++) {
                const element = this.mRoleEnity[i];
                if (element.KRoleCondition == PlayerCondition.PlayerBlue && !element.isLie) {
                    element.isCanMove = true;
                    element.ContineMove();
                }
            }
        }
        onUninit() {
            Laya.timer.clearAll(this);
            for (const Role of this.mRoleEnity) {
                Role.onUninit();
            }
            this.CurBlueNum = 0;
            this.InAirPlaneNum = 0;
            this.mRoleEnity = null;
            this.mLevelSpr3D = null;
            this.RedBirthNodes = [];
            this.mRoleEnity = [];
            this.ColEnity = [];
            CplayerManager.ins = null;
        }
        RandGetArrN(_Arr) {
            let Spr = this.DeepCopy(_Arr);
            let SprNode = [];
            let nuA = GInfo.BlueRole;
            if (GInfo.BlueRole >= this.BlueBirthNode.numChildren) {
                nuA = this.BlueBirthNode.numChildren;
            }
            while (SprNode.length < nuA) {
                let buff = this.RandomArray(Spr);
                SprNode.push(buff);
                let index = Spr.indexOf(buff);
                if (index != -1) {
                    Spr.splice(index, 1);
                }
            }
            return SprNode;
        }
        DeepCopy(source) {
            if (null == source || {} == source || [] == source) {
                return source;
            }
            let newObject;
            let isArray = false;
            if (source.length) {
                newObject = [];
                isArray = true;
            } else {
                newObject = {};
                isArray = false;
            }
            for (let key of Object.keys(source)) {
                if (null == source[key]) {
                    if (isArray) {
                        newObject.push(null);
                    } else {
                        newObject[key] = null;
                    }
                } else {
                    let sub = (typeof source[key] == 'object') ? this.DeepCopy(source[key]) : source[key];
                    if (isArray) {
                        newObject.push(sub);
                    } else {
                        newObject[key] = sub;
                    }
                }
            }
            return newObject;
        }
        RandomArray(array) {
            return array[Math.round(Math.random() / (1 / array.length) - 0.5)];
        }
    }

    class Double extends ui.DoubleUI {
        constructor() {
            super();
            this.zOrder = 10;
            this.visible = false;
            Laya.stage.addChild(this);
        }
        static get UI() {
            if (!Double._UI)
                Double._UI = new Double();
            return Double._UI;
        }
        Show() {
            this.visible = true;
            this.ani1.play(0, false);
            let num = CplayerManager.ins.InAirPlaneNum * 0.2 + (GInfo.Commission * 0.1) + 1.1;
            this.num.text = num.toFixed(1);
        }
        Hide() {
            this.visible = false;
        }
    }

    class TopUI extends ui.TopUI {
        constructor() {
            super();
            this.zOrder = 666;
            this.visible = false;
            Laya.stage.addChild(this);
            this.Set.visible = false;
            GEvent.Ins.on(GEvent.reTop, this, () => this.Gold.text = `${GInfo.Gold}`);
        }
        static get UI() {
            if (!TopUI._UI)
                TopUI._UI = new TopUI();
            return TopUI._UI;
        }
        init() {
            this.Gold.text = `${GInfo.Gold}`;
        }
        ShowBox() {
            this.Box.visible = true;
        }
        HideBox() {
            this.Box.visible = false;
        }
        Show() {
            this.visible = true;
            this.init();
            Double.UI.Hide();
        }
        Hide() {
            this.visible = false;
        }
    }

    var Shoptype;
    (function(Shoptype) {
        Shoptype[Shoptype["put"] = 0] = "put";
        Shoptype[Shoptype["shis"] = 1] = "shis";
        Shoptype[Shoptype["chuans"] = 2] = "chuans";
    })(Shoptype || (Shoptype = {}));

    function CheckType(Id) {
        if (Id >= 1001 && Id <= 1999)
            return Shoptype.put;
        if (Id >= 2001 && Id <= 2999)
            return Shoptype.shis;
        if (Id >= 3001 && Id <= 3999)
            return Shoptype.chuans;
    }
    class ShopUI extends ui.ShopUI {
        constructor() {
            super();
            this.Lotterys = false;
            this.checkedIndex = 1;
            this.zOrder = 1;
            this.visible = false;
            Laya.stage.addChild(this);
            this.sBox.width = Laya.stage.width;
            this.sBox.height = Laya.stage.height;
            this.Adimg.alpha = 0;
            this.putbtn.on(Laya.Event.CLICK, this, this.Clickputbtn);
            this.shisbtn.on(Laya.Event.CLICK, this, this.Clickshisbtn);
            this.chuansbtn.on(Laya.Event.CLICK, this, this.Clickchuansbtn);
            this.Back.on(Laya.Event.CLICK, this, this.Hide);
            this.List.renderHandler = new Laya.Handler(this, this.renderList);
            this.random.visible = true;
            this.video.visible = true;
            this.lock.on(Laya.Event.CLICK, this, () => {
                SDK().ShowV(end => {
                    if (end) {
                        if (++GInfo.GetGun(GInfo.GunId).goldskin >= 2) {
                            GInfo.GunList[GInfo.GunId].goldskin = true;
                            this.ShowThreeModel(GInfo.GunId);
                            this.List.refresh();
                        }
                        this.CheckTypeBJ(GInfo.GunId);
                    }
                },1006);
            });
            this.video.on(Laya.Event.CLICK, this, () => {
                let data = this.List.cells[this.checkedIndex].dataSource;
                if (this.Adimg.skin == "subpkg/UI/shareImg.png") {
                    SDK().RecEv(end => {
                        if (end) {
                            if (++GInfo.GetGun(data.Id).Num >= data.Num)
                                GInfo.GunList[data.Id].lock = true;
                            this.tishi.visible = true;
                            this.List.refresh();
                        }
                    });
                    SDK().ShaRec();
                } else {
                    SDK().ShowV(end => {
                        if (end) {
                            console.log("--->测试视频加载");
                            if (++GInfo.GetGun(data.Id).Num >= data.Num)
                                GInfo.GunList[data.Id].lock = true;
                            this.tishi.visible = true;
                            this.List.refresh();
                        }
                    },"商店激励");
                }
            });
            this.queding.on(Laya.Event.CLICK, this, () => {
                this.tishi.visible = false;
            });
            this.random.on(Laya.Event.CLICK, this, () => {
                let num = parseInt(this.r_num.text);
                if (GInfo.Gold < num) {
                    this.anirandom2.play(0, false);
                    SDK().STips("金钱不足");
                } else {
                    GInfo.addGold(-num);
                    this.anirandom1.play(0, false);
                    let data = this.List.cells[this.checkedIndex].dataSource;
                    GInfo.GunList[data.Id] = {
                        lock: true,
                        Num: 0,
                        goldskin: 0
                    };
                    this.List.refresh();
                }
            });
            this.Left.on(Laya.Event.CLICK, this, () => {
                this.anirandom1.play(0, false);
                if (this.Right.visible)
                    this.Clickputbtn();
                else
                    this.Clickshisbtn();
            });
            this.Right.on(Laya.Event.CLICK, this, () => {
                this.anirandom1.play(0, false);
                if (this.Left.visible)
                    this.Clickchuansbtn();
                else
                    this.Clickshisbtn();
            });
            this.Clickputbtn();
            this.CheckTypeBJ(GInfo.GunId);
        }
        static get UI() {
            if (!ShopUI._UI)
                ShopUI._UI = new ShopUI();
            return ShopUI._UI;
        }
        renderList(cell, index) {
            let data = cell.dataSource;
            let xuanz = cell.getChildByName("xuanz");
            let gun = cell.getChildByName("gun");
            let ImageBG = cell.getChildByName("BG");
            let lockImage = cell.getChildByName("lock");
            xuanz.visible = false;
            let Gun = GInfo.GetGun(data.Id);
            if (!Gun) {
                Gun = {
                    lock: false,
                    Num: 0,
                    goldskin: 0
                };
                GInfo.GunList[data.Id] = Gun;
            }
            if (CheckType(data.Id) === Shoptype.put) {
                xuanz.skin = "subpkg/UI/Mall/Mall16.png";
            } else if (CheckType(data.Id) === Shoptype.shis) {
                xuanz.skin = "subpkg/UI/Mall/Mall16.png";
            } else if (CheckType(data.Id) === Shoptype.chuans) {
                xuanz.skin = "subpkg/UI/Mall/Mall16.png";
            }
            if (Gun.lock) {
                if (Gun.goldskin === true) {
                    gun.skin = `subpkg/gun/${data.Id}_2.png`;
                } else {
                    gun.skin = `subpkg/gun/${data.Id}.png`;
                }
                ImageBG.skin = "subpkg/UI/Mall/Mall17.png";
                gun.alpha = 1;
                lockImage.visible = false;
            } else {
                gun.skin = `subpkg/gun/${data.Id}.png`;
                gun.alpha = 0.4;
                lockImage.visible = true;
                ImageBG.skin = "subpkg/UI/Mall/BGpan.png";
            }
            if (this.checkedIndex === index) {
                xuanz.visible = true;
                this.ShowThreeModel(data.Id);
                this.CheckTypeBJ(data.Id);
                if (Gun.lock) {
                    GInfo.GunId = data.Id;
                } else {
                    if (data.Type === 2 && SDK().SupShe() && SDK().vPath) {} else {}
                    this.r_num.text = `${data.Gold}`;
                    this.v_num.text = `${Gun.Num}/${data.Num}`;
                }
            }
            cell.offAll(Laya.Event.CLICK);
            cell.on(Laya.Event.CLICK, this, () => {
                this.checkedIndex = index;
                Laya.Tween.to(cell, {
                    scaleX: 1.2,
                    scaleY: 1.2
                }, 150, null, new Laya.Handler(this, () => Laya.Tween.to(cell, {
                    scaleX: 1,
                    scaleY: 1
                }, 150)));
                this.List.refresh();
            });
        }
        CheckTypeBJ(id) {
            const bol = CheckType(id);
            if (bol === Shoptype.put) {
                this.BJ.skin = "subpkg/UI/Mall/Mall14.png";
            } else if (bol === Shoptype.shis) {
                this.BJ.skin = "subpkg/UI/Mall/Mall13.png";
            } else if (bol === Shoptype.chuans) {
                this.BJ.skin = "subpkg/UI/Mall/Mall12.png";
            }
            this.unlock.visible = false;
            this.lock.visible = false;
            let Gun = GInfo.GetGun(id);
            if (Gun.lock) {
                this.random.visible = false;
                this.video.visible = false;
                this.Used.visible = true;
            } else {
                this.random.visible = true;
                this.video.visible = true;
                this.Used.visible = false;
            }
            if (!Gun || !Gun.lock)
                return;
            if (Gun.goldskin === true) {
                this.unlock.visible = true;
            } else {
                this.lock.visible = true;
                this.progress.text = `(${Gun.goldskin}/2)`;
            }
        }
        Clickputbtn() {
            if (this.Lotterys)
                return;
            nativeOpen("商店普通");
            this.shis.visible = false;
            this.chuans.visible = false;
            this.put.visible = true;
            this.Left.visible = false;
            this.Right.visible = true;
            this.List.array = [];
            let list = [];
            WeaponConfig.WeaponTable.forEach(ele => CheckType(ele.Id) === Shoptype.put && list.push(ele));
            this.List.array = list;
        }
        Clickshisbtn() {
            if (this.Lotterys)
                return;
            nativeOpen("商店史诗");
            this.shis.visible = true;
            this.chuans.visible = false;
            this.put.visible = false;
            this.Left.visible = true;
            this.Right.visible = true;
            this.List.array = [];
            let list = [];
            WeaponConfig.WeaponTable.forEach(ele => CheckType(ele.Id) === Shoptype.shis && list.push(ele));
            this.List.array = list;
        }
        Clickchuansbtn() {
            if (this.Lotterys)
                return;
            nativeOpen("商店传说");
            this.shis.visible = false;
            this.chuans.visible = true;
            this.put.visible = false;
            this.Left.visible = true;
            this.Right.visible = false;
            this.List.array = [];
            let list = [];
            WeaponConfig.WeaponTable.forEach(ele => CheckType(ele.Id) === Shoptype.chuans && list.push(ele));
            this.List.array = list;
        }
        ShowThreeModel(_gunId) {
            if (this.playSpt)
                this.playSpt.onUninit();
            this.playSpt = new Player3DShow();
            this.playSpt.InitScene3D(this, _gunId);
        }
        Show() {
            TopUI.UI.HideBox();
            this.visible = true;
            this.SHOW.play(0, false);
            this.ShowThreeModel(GInfo.GunId);
            SDK().ShowI();
            console.log("show shop");
        }
        Hide() {
            nativeOpen("返回主页");
            BSet.PfSDK == SDKType.TT && SDK().HideB();
            this.HIDE.play(0, false);
            this.HIDE.offAll(Laya.Event.COMPLETE);
            this.HIDE.on(Laya.Event.COMPLETE, this, () => {
                this.visible = false;
                TopUI.UI.ShowBox();
                if (this.playSpt)
                    this.playSpt.onUninit();
                this.playSpt = null;
            });
            MainUI.UI.Show();
        }
    }

    class MainUIList {}
    class MainUI extends ui.MainUI {
        constructor() {
            super();
            this.zOrder = 1;
            this.visible = false;
            Laya.stage.addChild(this);
            this.sBox.width = Laya.stage.width;
            this.sBox.height = Laya.stage.height;
            this.List.renderHandler = new Laya.Handler(this, this.renderList);
            if (SDK().BAd) {
                SDK().BAd.destroy();
            }
        }
        static get UI() {
            if (!MainUI._UI)
                MainUI._UI = new MainUI();
            return MainUI._UI;
        }
        StartGame() {
            BSet.PfSDK == SDKType.TT && SDK().HideB();
            let Id = GInfo.GetNoUnlockGun();
            if (BSet.PfSDK == SDKType.TT && Id)
                new GetGunVideo(Id, () => this.Start());
            else
                this.Start();
        }
        Start() {
            nativeOpen("游戏页");
            SDK().StaRec(() => {});
            this.Hide();
            TopUI.UI.Hide();
            GameMain.Ins.homescene.GameStart();
        }
        renderList(cell, index) {
            let data = cell.dataSource;
            let left = cell.getChildByName("left");
            let right = cell.getChildByName("right");
            if (index === 0) {
                left.visible = false;
            } else if (index === 4) {
                right.visible = false;
            }
            let now = cell.getChildByName("now");
            let lock = cell.getChildByName("lock");
            let pass = cell.getChildByName("pass");
            let Level = cell.getChildByName("Level");
            now.visible = data.now;
            lock.visible = data.lock;
            pass.visible = data.pass;
            Level.visible = true;
            Level.visible = true;
        }
        initUi() {
            this.lvLV1.text = ` ${GInfo.Commission}`;
            this.lvLV2.text = ` ${GInfo.Commission}`;
            this.plLV1.text = ` ${GInfo.BlueRole - 5}`;
            this.plLV2.text = ` ${GInfo.BlueRole - 5}`;
            if (SDK().BAd) {
                SDK().BAd.destroy();
            }
            let lvmon = GInfo.Commission * 2000 + 2000;
            let plmon = GInfo.BlueRole * 2000 - 8000;
            if (GInfo.Commission >= 20) {
                this.lvmoney1.text = `MAX`;
                this.lvmoney2.text = `MAX`;
                this.anilvup.play(0, false);
                this.uplv.visible = false;
            } else {
                this.lvmoney1.text = `${lvmon}`;
                this.lvmoney2.text = `${lvmon}`;
                if (GInfo.Gold < lvmon) {
                    this.lvmoney2.color = "#ff4f4f";
                    this.anilvup.play(0, false);
                    this.uplv.visible = false;
                } else {
                    this.lvmoney2.color = "#ffffff";
                    this.anilvup.play(0, true);
                    this.uplv.visible = true;
                }
            }
            if (GInfo.BlueRole >= GInfo.MAXBlueRole) {
                this.plmoney1.text = `MAX`;
                this.plmoney2.text = `MAX`;
                this.aniplup.play(0, false);
                this.uppl.visible = false;
            } else {
                this.plmoney1.text = `${plmon}`;
                this.plmoney2.text = `${plmon}`;
                if (GInfo.Gold < plmon) {
                    this.plmoney2.color = "#ff4f4f";
                    this.aniplup.play(0, false);
                    this.uppl.visible = false;
                } else {
                    this.plmoney2.color = "#ffffff";
                    this.aniplup.play(0, true);
                    this.uppl.visible = true;
                }
            }
            this.Nad.visible = false;
            this.share.visible = false;
            this.trial.visible = false;
            this.more.visible = false;
            this.AddIcon.visible = false;
            if (BSet.PfSDK == SDKType.TT) {
                this.share.visible = SDK().vPath != null;
                this.trial.visible = true;
            } else if (BSet.PfSDK == SDKType.OPPO) {
                this.more.visible = true;
                this.AddIcon.visible = true;
            }
        }
        initList() {
            if (GInfo.LevelIdUI < 3) {
                let n = Math.floor((GInfo.LevelIdUI - 1) / 5);
                let m = (GInfo.LevelIdUI - 1) % 5;
                let list = [];
                for (let i = 0; i < 5; i++) {
                    let res = new MainUIList();
                    res.Level = n * 5 + i + 1;
                    res.now = false;
                    res.lock = false;
                    res.pass = false;
                    if (i < m)
                        res.pass = true;
                    else if (i > m)
                        res.lock = true;
                    else
                        res.now = true;
                    list.push(res);
                }
                this.List.array = list;
            } else {
                let list = [];
                for (let i = 0; i < 2; i++) {
                    let res = new MainUIList();
                    res.Level = GInfo.LevelIdUI + i - 2;
                    res.now = false;
                    res.lock = false;
                    res.pass = false;
                    res.pass = true;
                    list.push(res);
                }
                let res = new MainUIList();
                res.Level = GInfo.LevelIdUI;
                res.now = false;
                res.lock = false;
                res.pass = false;
                res.now = true;
                list.push(res);
                for (let i = 0; i < 2; i++) {
                    let res = new MainUIList();
                    res.Level = GInfo.LevelIdUI + i + 1;
                    res.now = false;
                    res.lock = false;
                    res.pass = false;
                    res.lock = true;
                    list.push(res);
                }
                this.List.array = list;
            }
        }
        anistart() {
            this.anistart1.play(0, false);
            this.anistart1.offAll(Laya.Event.COMPLETE);
            this.anistart1.on(Laya.Event.COMPLETE, this, () => {
                this.anistart2.play(0, false);
                Laya.timer.once(500, this, this.anistart);
            });
        }
        onCLICK() {
            this.offCLICK();
            this.shop.on(Laya.Event.CLICK, this, () => {
                this.offCLICK();
                this.anishop.play(0, false);
                this.anishop.offAll(Laya.Event.COMPLETE);
                this.anishop.on(Laya.Event.COMPLETE, this, () => {
                    this.Hide();
                    ShopUI.UI.Show();
                });
            });
            this.lvup.on(Laya.Event.CLICK, this, () => {
                this.anilv.play(0, false);
                if (this.lvmoney2.color === "#ffffff" && GInfo.Commission < 20) {
                    GInfo.addGold(-(GInfo.Commission * 2000 + 2000));
                    GInfo.Commission++;
                    this.initUi();
                } else {
                    SDK().STips("金钱不足");
                }
            });
            this.plup.on(Laya.Event.CLICK, this, () => {
                this.anipl.play(0, false);
                if (this.plmoney2.color === "#ffffff" && GInfo.BlueRole < GInfo.MAXBlueRole) {
                    GInfo.addGold(-(GInfo.BlueRole * 2000 - 8000));
                    GInfo.BlueRole++;
                    this.initUi();
                } else {
                    SDK().STips("金钱不足");
                }
            });
            this.Box.on(Laya.Event.CLICK, this, this.StartGame);
            this.more.on(Laya.Event.CLICK, this, () => SDK().ShowGP());
            this.AddIcon.on(Laya.Event.CLICK, this, () => SDK().AddIcon());
            this.share.on(Laya.Event.CLICK, this, () => {
                let Id = GInfo.GetNoUnlockGun();
                new GetGunShare(Id, null);
            });
            this.trial.on(Laya.Event.CLICK, this, () => {
                let Id = GInfo.GetNoUnlockGun();
                new GetGunVideo(Id, null);
            });
            this.sup.on(Laya.Event.CLICK, this, () => {
                this.offCLICK();
                SDK().ShowV(end => {
                    if (end) {
                        GInfo.suptrial = true;
                        this.StartGame();
                    }
                },"主页激励");
                Laya.timer.once(3000, this, () => {
                    this.onCLICK();
                });
            });
            GEvent.Ins.on(SDK().NIc, this, () => {
                if (SDK().NIcon) {
                    if (SDK().NIcon.icon)
                        this.NadIcon.skin = SDK().NIcon.icon;
                    else if (SDK().NIcon.iconUrlList && SDK().NIcon.iconUrlList.length > 0)
                        this.NadIcon.skin = SDK().NIcon.iconUrlList[0];
                    else
                        return;
                    SDK().NIOnShow();
                    this.Nad.visible = true;
                    this.NadIcon.on(Laya.Event.CLICK, this, () => {
                        SDK().NIcOnCl();
                        this.Nad.visible = false;
                    });
                    this.NadClo.on(Laya.Event.CLICK, this, () => {
                        this.Nad.visible = false;
                    });
                }
            });
        }
        offCLICK() {
            this.shop.offAll(Laya.Event.CLICK);
            this.lvup.offAll(Laya.Event.CLICK);
            this.plup.offAll(Laya.Event.CLICK);
            this.Box.offAll(Laya.Event.CLICK);
            this.NadIcon.offAll(Laya.Event.CLICK);
            this.NadClo.offAll(Laya.Event.CLICK);
            this.sup.offAll(Laya.Event.CLICK);
            this.more.offAll(Laya.Event.CLICK);
            this.AddIcon.offAll(Laya.Event.CLICK);
            this.share.offAll(Laya.Event.CLICK);
            this.trial.offAll(Laya.Event.CLICK);
            GEvent.Ins.offAll(SDK().NIc);
        }
        Show() {
            this.visible = true;
            this.mouseEnabled = true;
            this.SHOW.play(0, false);
            this.SHOW.offAll(Laya.Event.COMPLETE);
            this.SHOW.on(Laya.Event.COMPLETE, this, () => {
                this.anistart();
                this.initList();
                this.onCLICK();
                this.initUi();
            });
        }
        Hide() {
            this.mouseEnabled = false;
            this.offCLICK();
            Laya.timer.clearAll(this);
            this.anistart1.stop();
            this.anistart2.stop();
            this.anistart1.stop();
            this.anistart1.stop();
            this.HIDE.play(0, false);
            this.HIDE.offAll(Laya.Event.COMPLETE);
            this.HIDE.on(Laya.Event.COMPLETE, this, () => {
                this.visible = false;
            });
        }
    }

    class HomeScene {
        constructor() {
            this.mLevel = null;
            this.isInit = false;
        }
        onInit(isFirstlogin) {
            HomeScene.instance = this;
            this.mScene = Laya.loader.getRes("Resources/Conventional/HomeScene.ls");
            console.log("--->测试场景加载onInit");
            Laya.stage.addChild(this.mScene);
            this.cameraRoot = this.mScene.getChildByName("MainCameraRoot");
            this.mRotation = new Laya.Vector3(0, 0.2, 0);
            this.mLight = this.mScene.getChildByName("Directional Light");
            this.mLight.shadowMode = Laya.ShadowMode.Hard;
            this.mLight.shadowDistance = 0;
            this.mLight.shadowStrength = 0.0;
            this.mLight.intensity = 0.6;
            this.mLight.shadowDepthBias = 0.42;
            this.OnEnterLevel(isFirstlogin);
        }
        OnEnterLevel(isFirstlogin = false) {
            return __awaiter(this, void 0, void 0, function*() {
                console.log("--->测试场景加载OnEnterLevel");
                let end = yield LoadingUI.LoaderCreate(GetSpPath("Level" + GInfo.LevelId));
                if (!end) {
                    SDK().showerrM('关卡资源加载失败！', '请退出重启！');
                    return;
                }
                nativeOpen("游戏主页");
                this.mCurLeveId = GInfo.LevelId;
                let cfg = LevelConfig.getCfg(GInfo.LevelId);
                this.mScene.fogColor = new Laya.Vector3(cfg.Fog[0], cfg.Fog[1], cfg.Fog[2]);
                let cam = this.cameraRoot.getChildByName("Camera");
                cam.clearFlag = Laya.CameraClearFlags.SolidColor;
                cam.clearColor = new Laya.Vector4(cfg.Fog[0], cfg.Fog[1], cfg.Fog[2], 1);
                this.mLevel = new Level(this.mScene, cam.clearColor);
                this.mLight.shadowDistance = 150;
                if (!this.cameraRoot.active) {
                    this.cameraRoot.active = true;
                }
                let effectPos = cam.transform.position.clone();
                effectPos.y += 20;
                ObjectPoolManager.Instance.createEffect("ef_zhayaotong", this.mScene, effectPos, Laya.Quaternion.DEFAULT, 1000);
                ObjectPoolManager.Instance.createEffect("ef_huicheng", this.mScene, effectPos, Laya.Quaternion.DEFAULT, 1000);
                ObjectPoolManager.Instance.createEffect("ef_qiangkouhuoyan", this.mScene, effectPos, Laya.Quaternion.DEFAULT, 1000);
                for (let index = 0; index < 50; index++) {
                    ObjectPoolManager.Instance.createEffect("Character", this.mScene, effectPos, Laya.Quaternion.DEFAULT, 1000);
                }
                Laya.timer.once(1500, this, () => {
                    this.isInit = true;
                    MainUI.UI.Show();
                    TopUI.UI.Show();
                    LoadingUI.Hide();
                });
            });
        }
        onUpdate() {
            if (!this.isInit)
                return;
            this.cameraRoot.transform.rotate(this.mRotation, false, false);
            if (this.mLevel)
                this.mLevel.OnUpdate();
        }
        OnGameOver(rIsSuc) {
            if (rIsSuc && ++GInfo.LevelId > LevelConfig.getMaxLevel()) {
                GInfo.LevelId = MathExt.RandomInt(5, 10);
            }
            if (rIsSuc) {
                let IdUI = GInfo.LevelIdUI + 1;
                GInfo.LevelIdUI = IdUI;
                if (GInfo._LevelId > GInfo._LevelIdUI) {
                    GInfo._LevelIdUI = GInfo._LevelId;
                }
            }
            if (this.mLevel) {
                this.mLevel.OnUnint();
                this.mLevel = null;
            }
            if (GInfo.LevelId > this.mCurLeveId || this.mCurLeveId == LevelConfig.getMaxLevel()) {
                Laya.loader.clearRes(GetSpPath("Level" + this.mCurLeveId));
            }
            this.OnEnterLevel();
        }
        GameStart() {
            this.cameraRoot.active = false;
            this.mScene.fogStart = 20;
            this.mScene.fogRange = 100;
            if (this.mLevel) {
                this.mLevel.StartGame();
            }
            this.LoadNextRes();
        }
        LoadNextRes() {
            let Id = GInfo.LevelId + 1;
            if (GInfo.LevelId >= LevelConfig.getMaxLevel())
                Id = 7;
            Laya.Sprite3D.load(GetSpPath("Level" + Id), Laya.Handler.create(this, (res) => {}));
        }
        onUninit() {
            this.mScene.destroy(true);
        }
    }

    var ESceneType;
    (function(ESceneType) {
        ESceneType[ESceneType["None"] = 0] = "None";
        ESceneType[ESceneType["HomeScene"] = 1] = "HomeScene";
        ESceneType[ESceneType["Combat"] = 2] = "Combat";
        ESceneType[ESceneType["OnHook"] = 3] = "OnHook";
    })(ESceneType || (ESceneType = {}));

    function GetSpPath(name) {
        return "Resources/Conventional/" + name + ".lh";
    }

    function LoadSp3D(name) {
        return Laya.loader.getRes(GetSpPath(name)).clone();
    }
    class GameMain {
        constructor() {
            this.SceneType = ESceneType.None;
            this.curSceneRes = [];
            GameMain._Ins = this;
            SDK().Init();
            SDK().Login();
            GEvent.Ins.on(GEvent.Audv, this, (Show) => {
                if (Show)
                    GameSound.PlayMusic();
                else
                    GameSound.StopMusic();
                SDK().SetAudv(Show);
            });
            this.Down();
        }
        static get Ins() {
            return GameMain._Ins;
        }
        Down() {
            SDK().LoadSub(err => {
                if (err)
                    SDK().showerrM('分包下载失败！', '请退出重启！');
                else
                    this.LoadUI();
            }, (progress) => {
                LoadingUI.UI.Loadlab = '分包资源下载中', LoadingUI.onProgress(progress * .01);
            });
        }
        LoadUI() {
            return __awaiter(this, void 0, void 0, function*() {
                let res = [
                    "subpkg/UI.atlas",
                    "subpkg/more.atlas",
                    "subpkg/gun.atlas",
                    "subpkg/share.atlas",
                    "subpkg/UI/Share.atlas",
                ];
                LoadingUI.UI.Loadlab = '界面资源加载中';
                let end = yield LoadingUI.Load(res);
                res.splice(0, res.length);
                if (end)
                    this.LoadGame();
                else
                    SDK().showerrM('界面资源加载失败！', '请退出重启！');
            });
        }
        LoadGame() {
            return __awaiter(this, void 0, void 0, function*() {
                let res = [];
                LoadingUI.UI.Loadlab = '场景资源加载中';
                let end = yield LoadingUI.Load(res);
                res.splice(0, res.length);
                if (end) {
                    SDK().Initialize();
                    this.onEnterHomeScene(true);
                    Laya.timer.loop(5000, this, this.onLowUpdate);
                    Laya.timer.frameLoop(1, this, this.onUpdate);
                } else
                    SDK().showerrM('资源加载失败！', '请退出重启！');
            });
        }
        onLowUpdate() {
            GStor.Updt();
        }
        onUpdate() {
            this.delta = Laya.timer.delta * 0.001;
            if (this.delta > 0.1) {
                this.delta = 0.1;
            }
            this.homescene && this.homescene.onUpdate();
        }
        onEnterHomeScene(isFirstlogin = false) {
            return __awaiter(this, void 0, void 0, function*() {
                this.leaveHomeScene();
                this.curSceneRes.length = 0;
                this.curSceneRes.push("Resources/Conventional/HomeScene.ls");
                this.curSceneRes.push("Resources/Conventional/Character.lh");
                for (const rItem of WeaponConfig.WeaponTable) {
                    this.curSceneRes.push(GetSpPath(rItem.Model));
                    this.curSceneRes.push(GetSpPath(rItem.hModel));
                }
                this.curSceneRes.push("Resources/Conventional/ef_zhayaotong.lh");
                this.curSceneRes.push("Resources/Conventional/ef_huicheng.lh");
                this.curSceneRes.push("Resources/Conventional/ef_help.lh");
                this.curSceneRes.push("Resources/Conventional/ef_z.lh");
                this.curSceneRes.push("Resources/Conventional/ef_fangwuhuoyan.lh");
                this.curSceneRes.push("Resources/Conventional/ef_yinjiuguangquan.lh");
                this.curSceneRes.push("Resources/Conventional/ef_qiangkouhuoyan.lh");
                this.curSceneRes.push("Resources/Conventional/ef_tanhao.lh");
                this.curSceneRes.push("Resources/Conventional/ef_yanhua.lh");
                this.curSceneRes.push("Resources/Conventional/Airplane.lh");
                LoadingUI.Show();
                LoadingUI.UI.Loadlab = '加载中';
                let end = yield LoadingUI.Load(this.curSceneRes.slice());
                if (end) {
                    GameMain.Ins.SceneType = ESceneType.HomeScene;
                    this.homescene = new HomeScene();
                    this.homescene.onInit(isFirstlogin);
                } else
                    SDK().showerrM('关卡资源加载失败！', '请退出重启！');
            });
        }
        leaveHomeScene() {
            if (this.homescene) {
                LoadingUI.LoaderClear(this.curSceneRes);
                this.curSceneRes.splice(0, this.curSceneRes.length);
                this.homescene.onUninit();
                this.homescene = null;
            }
        }
    }
    GameMain._Ins = null;
    GameMain.EFireEffect = "ef_qiangkouhuoyan";
    GameMain.Lvnum = 0;
    GameMain.Bannernum = 0;

    class GameConfig {
        constructor() {}
        static init() {
            var reg = Laya.ClassUtils.regClass;
            window.ystorage = Laya.LocalStorage;
            if (window.YaGames) {
                YaGames.init().then(ysdk => {
                    console.log('Yandex SDK initialized');
                    window.ysdk = ysdk;
                    window.ysdk.getStorage()
                        .then(storage => {
                            window.ystorage = storage;
                        })
                }).catch(err => {})
            }
        }
    }
    GameConfig.width = 750;
    GameConfig.height = 1334;
    GameConfig.scaleMode = window.isPhone ? "fixedwidth" : "showall";
    GameConfig.screenMode = "none";
    GameConfig.alignV = "middle";
    GameConfig.alignH = "center";
    GameConfig.startScene = "Loading.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = true;
    GameConfig.physicsDebug = true;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    if (window["Laya3D"])
        Laya3D.init(GameConfig.width, GameConfig.height);
    else
        Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
    Laya.stage.scaleMode = GameConfig.scaleMode;
    Laya.stage.screenMode = GameConfig.screenMode;
    Laya.stage.alignV = GameConfig.alignV;
    Laya.stage.alignH = GameConfig.alignH;
    Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
    Laya.Loader.maxTimeOut = 3000;
    Laya.stage.frameRate = Laya.Stage.FRAME_FAST;
    new GameMain();

}());
//# sourceMappingURL=bundle.js.map